# -*- coding: utf-8 -*-

from sqlalchemy.sql.expression import and_

from at.utiles.conversiones import respuesta
from at.orm.decorators import DBSwitch
from at.utiles.singleton_decorador import singleton
from at.utiles.conversiones import sqla_to_dict


# cuando se arregle atapis, aca se debe poner atapis en vez de atapis_test
# @singleton
@DBSwitch('atapis')
class ParametrosGlobalesRepository:

    def __init__(self):
        pass

    def obtener_region_busqueda(self):
        """
               lista todos los filtros_palabras
               """
        session = self.atapis.binded_session()
        try:
            tabla = self.atapis.tabla('region_busqueda')

            # obtiene todos los filtros
            filtros = session.query(tabla).filter().all()

            if filtros:  # si hay filtros
                filtros = sqla_to_dict(filtros)  # lo pasa a dict
                rta = respuesta(True, u"ok", filtros)
            else:  # si no hay filtros
                rta = respuesta(False, u"No hay region de busqueda")

        except Exception as error:
            rta = respuesta(False, u"No se pudo aobtener region de busqueda", error)
        finally:
            session.close()

        return rta

    def obtener(self, id_api, telefono):

        """
            obtiene los datos de un telefono y api
        """
        session = self.atapis.binded_session()
        try:
            tabla = self.atapis.tabla('telefonos_apis')

            # obtiene todos los filtros
            filtros = session.query(tabla).filter(tabla.id_api == id_api, tabla.telefono == telefono).all()

            # Si el registro esta vacio
            if filtros is None:
                return respuesta(False, u'error al obtener telefonos apis d el telefono:%s' % telefono)

            if filtros:  # si hay filtros
                filtros = sqla_to_dict(filtros)  # lo pasa a dict
                rta = respuesta(True, u"ok", filtros)
            else:  # si no hay filtros
                rta = respuesta(False, u"No hay telefonos apis par abuscar")

        except Exception as error:
            rta = respuesta(False, u"No se pudo actualizar los filtros de la charla", error)
        finally:
            session.close()

        return rta

    def pepe(self):
        session = self.atapis.binded_session()
        try:
            tabla = self.atapis.tabla('telefonos_api')

            # obtiene todos los filtros
            filtros = session.query(tabla).all()

            if filtros:  # si hay filtros
                filtros = sqla_to_dict(filtros)  # lo pasa a dict
                rta = respuesta(True, u"ok", filtros)
            else:  # si no hay filtros
                rta = respuesta(False, u"No hay telefonos apis para listar")

        except Exception as error:
            rta = respuesta(False, u"No se pudo listar telefonos apis", error)
        finally:
            session.close()

        return rta

    def listar(self):

        """
        lista todos los filtros_palabras
        """
        session = self.atapis.binded_session()
        try:
            tabla = self.atapis.tabla('telefonos_apis')

            # obtiene todos los filtros
            filtros = session.query(tabla).all()

            if filtros:  # si hay filtros
                filtros = sqla_to_dict(filtros)  # lo pasa a dict
                rta = respuesta(True, u"ok", filtros)
            else:  # si no hay filtros
                rta = respuesta(False, u"No hay telefonos apis para listar")

        except Exception as error:
            rta = respuesta(False, u"No se pudo listar telefonos apis", error)
        finally:
            session.close()

        return rta

    def __registro_a_diccionario(self, registro):
        '''
        Esta funcion se encarga de transformar un objeto de SQLAlchemy a un diccionario.
        '''

        dic = registro.__dict__  # Transformamos el registro en diccionario

        dic.pop('_sa_instance_state')  # Borramos la entrada que contiene la instanciacion de la clase de SQLAlchemy

        return dic  # Devolvemos el diccionario
