# -*- coding: utf-8 -*-
import json
from at.utiles.http import enviar_por_http


def obtener_direcciones_posibles(ip_atapis, parametros):
    '''
    Esta funcion se solicitar obtener_direcciones_posibles a atapis.

    :param direccion: Una direccion en unicode.
    :return: Respuesta
    '''

    url = _armar_url(ip_atapis, '/obtener_direcciones_posibles')

    return _enviar(url, parametros, 'POST')



def obtener_coordenadas(ip_atapis, parametros):
    '''
    Esta funcion se solicitar obtener_coordenadas a atapis.

    :param direccion: Una direccion en unicode.
    :return: Respuesta
    '''

    url = _armar_url(ip_atapis, '/obtener_coordenadas')

    return _enviar(url, parametros, 'POST')


def _armar_url(ip, ruta):
    return 'http://' + ip + ruta


def _enviar(url, params, metodo):
    # Envía el nuevo mensaje por HTTP
    rta = enviar_por_http(url, params, metodo, tipo_params='json', timeout=25)

    # Si no se pudo enviar el mensaje
    if rta['Estado'] is False:
        # Retorna el error
        return rta

    # Obtiene la respuesta recibida en formato JSON
    try:
        rta = json.loads(rta['Respuesta']['content'].decode('utf-8'))
    except:
        return (False, u"Hubo un error al decodificar la respuesta")

    # Retorna la respuesta recibida como un diccionario
    return rta
