from at.utiles.singleton_decorador import singleton


@singleton
class ParametrosGlobales(object):
    """
    esta clase va a guardar parametros globales, creo que conviene hacer una clase especifica por tipo de info a guardar
    por ejemplo ahora solo guarda cosas de arcgis
    la idea de esta clase es evitar usar variables globales!

    los atributos de esta clase se iran seteando cuando corresponda, en principio apenas se levanta el servidor
    """

    def __init__(self):
        self.x_min = None
        self.x_max = None
        self.y_min = None
        self.y_max = None
        self.token_arcgis = None


    def obtener_region_busqueda(self):
        return {'x_min': self.x_min,
                'x_max': self.x_max,
                'y_max': self.y_max,
                'y_min': self.y_min}

    def obtener_token_arcgis(self):
        return self.token_arcgis

    def setear_token_arcgis(self, token):
        self.token_arcgis = token

    def setear_region_busqueda(self, objeto):
        self.x_min = objeto['x_min']
        self.x_max = objeto['x_max']
        self.y_max = objeto['y_max']
        self.y_min = objeto['y_min']
