# -*- coding: utf-8 -*-

from at.cpbot.bdcpbot import CpBotBd
from at.cpbot.cpadapter import CpBotAdapter
from at.utiles.conversiones import respuesta, decode_string
from decimal import Decimal
import at.cpbot.atmsjadapter as atmsjadapter
import pprint
import datetime

'''
En este archivo se guardan todas las funciones relativas a la obtencion de textos para tags en un menu a enviar.
'''

cpbotbd = CpBotBd()  # Instanciacion de la clase que interactua con la Base de Datos de CpBot
cpadapter = CpBotAdapter()  # Instanciacion de la clase que interactua con el CallProcessorWeb y la BD 'cp2000'


def datos_chofer(parametros):
    '''
    Esta funcion se encarga de obtener los datos de un chofer mediante
    :return:
    '''
    print("ENTRA EN DATOS CHOFER -<-<-<-<-<-<-<-<-<-")
    dni_chofer = parametros['servicio']['dni_chofer']  # Guardo el dni del chofer

    if dni_chofer is None:
        return respuesta(False, u'El servicio no tiene un chofer asignado todavia')

    # Utilizo la funcion para obtener los datos del chofer
    rta_datos_chofer = cpadapter.obtener_datos_chofer(dni_chofer)

    if rta_datos_chofer['Estado'] is False:  # Si no puedo obtener los datos del chofer
        return rta_datos_chofer  # Devuelvo la respuesta

    # Creo el string a devolver
    nombre = rta_datos_chofer['Dato']['nombre']
    apellido = rta_datos_chofer['Dato']['apellido']
    chofer = nombre + ' ' + apellido
    print("CHOFER: ", chofer)
    return respuesta(True, u'Datos del chofer obtenidos con exito', dato=chofer)


def patente(parametros):
    return respuesta(True, u'PREDETERMINADO', dato="PATENTE")


def saludo_horario(parametros):
    horarios = parametros['horarios'].split(',')  # Separamos los horarios para convertirlos en una lista

    horarios = [int(horario) for horario in horarios]  # Convertimos los horarios en int

    hora_actual = int(datetime.datetime.now().strftime("%H"))  # Obtenemos la hora actual como int

    if hora_actual >= horarios[0] and hora_actual < horarios[1]:  # Si estamos dentro del horario mañanero

        rta = cpbotbd.obtener_texto_tag('mananero')  # Obtenemos el texto del tag mañanero

        if rta['Estado'] is False:  # Si fallamos al obtener el texto
            return rta  # Devolvemos la respuesta

        return respuesta(True, u'PREDETERMINADO', dato=rta['Dato'])

    if hora_actual >= horarios[1] and hora_actual < horarios[2]:  # Si estamos de tardecita

        rta = cpbotbd.obtener_texto_tag('tarde')  # Obtenemos el texto del tag de tarde

        if rta['Estado'] is False:  # Si no pudimos obtener el texto del tag
            return rta  # Devolvemos la respuesta

        return respuesta(True, u'PREDETERMINADO', dato=rta['Dato'])

    if hora_actual >= horarios[2] or hora_actual < horarios[0]:  # Si estamos de nochecita

        rta = cpbotbd.obtener_texto_tag('noche')  # Obtenemos el texto del tag de noche

        if rta['Estado'] is False:  # Si no pudimos obtener el texto del tag
            return rta

        return respuesta(True, u'PREDETERMINADO', dato=rta['Dato'])

    return respuesta(False, u'Fallo en obtener saludo con horario')


def distancia(parametros):
    '''
    Esta funcion se encarga de devolver la distancia de un movil despachado a su destino

    :param parametros (dict): Un diccionario con datos relevantes al servicio cargado
    :return: (dict) Una respuesta con Estado, un mensaje y SI O SI un dato.
    '''
    distancia = str(parametros['servicio']['distancia']) + " metros"

    return respuesta(True, u'PRUEBITA', dato=distancia)


def direccion(parametros):
    '''
    Esta funcion se encarga de devolver la direccion a un servicio que se ha cargado.

    :param parametros (dict): Un diccionario con datos relevantes al servicio cargado
    :return: (dict) Una respuesta con Estado, un mensaje y SI O SI un dato.
    '''
    print("DIRECCION: ", parametros['log']['datos'])
    return respuesta(True, u'PRUEBITA', dato=eval(parametros['log']['datos'])['datos_ejecucion']['direccion'])



