# -*- coding: utf-8 -*-

import pprint

from at.cpbot.cpadapter import CpBotAdapter
from at.cpbot.bdcpbot import CpBotBd
from at.cpbot.atmsjadapter import finalizar_charla
from at.utiles.conversiones import respuesta
import at.cpbot.atmsjadapter as atmsj
from at.cpbot.tagutiles import formatear_texto
from at.cpbot.atmsjadapter import enviar_atmsj
from at.cpbot.utilesfunciones import *

'''
En este modulo se encuentran las funciones encargadas
de ejecutar cierta logica dependiendo del modo permitido
en el nodo.

IMPORTANTE: Todas las funciones deben devolver un diccionario
'''

cpbotbd = CpBotBd()  # Instanciacion de la clase que interactua con la BD 'cpbot'
cpadapter = CpBotAdapter()  # Instanciacion de la clase que interactura con CallProcessor


def cancelar(parametros):
    '''
    Esta funcion se encarga de cancelar un servicio, o simplemente cancelar la charla

    :param datos_usuario (dict): Un diccionario con varios datos utiles del usuario, la empresa, etc.
    :return: (dict) Una respuesta con Estado y un mensaje.
    '''
    print("\nentra en cancelar de modos permitidos:")
    # pprint.pprint(parametros)

    datos = eval(parametros['log']['datos'])

    # import web_pdb
    # web_pdb.set_trace()
    # servicio esta en
    # parametros.log.datos.datos_ejecucion.Dato.id_servicio
    # Primero verificamos si hay un servicio cargado

    try:
        if 'id_servicio' in datos['datos_ejecucion']:
            id_servicio = datos['datos_ejecucion']['id_servicio']

            print("DATOS EN CANCELAR: ", datos)
            # Llamo a la funcion del adaptador de CallProcessor para anular un servicio
            rta_anular = cpadapter.cancelar_servicio(
                id_servicio=id_servicio,
                host=parametros['ip_callprocessor'])

            rta_anular['Dato'] = {
                'con_titulo': False
            }

            return rta_anular  # Devuelvo la respuesta de la anulacion del servicio

        else:  # Si no hay ningun servicio cargado
            # Devolvemos una respuesta con True
            return respuesta(True, u'No habia ningun servicio por finalizar', dato={'con_titulo': False})
    except:
        raise Exception(u"falla al querer cancelar servicio")


def debug(datos_usuario):
    pass


def cc(datos_usuario):
    pass


def pasar_a_manual(datos_usuario):
    '''
    Esta funcion se encarga de pasar la charla a manual.
    '''

    print("DATOS DEL USUARIO EN PAM: ", datos_usuario)

    # Intentamos pasar la charla a manual en atmsj
    rta_pasar_a_manual = atmsj.cambiar_automatico(telefono=datos_usuario['charla']['telefono_origen'],
                                                  automatico=0,
                                                  ip_atmsj=datos_usuario['ip_atmsj'])

    print("\nrta_pasar_manual:",rta_pasar_a_manual)
    # Finalizamos la charla en el cpbot
    rta_finalizar_en_cpbot = cpbotbd.cambiar_estado_charla(datos_usuario['charla']['id_charla'], "finalizada")

    # Si no pude finalizar la charla
    if rta_finalizar_en_cpbot['Estado'] is False:
        raise Exception(u'Error al pasar la charla a manual', rta_finalizar_en_cpbot['Respuesta'])
    #
    # Devolvemos la respuesta
    rta_pasar_a_manual['Dato'] = {
        'con_titulo': False
    }
    return rta_pasar_a_manual


def estado_servicio(parametros):
    '''
    Esta funcion se encarga de obtener la informacion de un servicio en curso, utilizando la tabla "actual" de la base
    de datos "cp2000"

    :param parametros (dict): Un diccionario con datos utiles para la ejecucion de funciones
    :return: (dict) Una respuesta con Estado, un mensaje y SI O SI un dato.
    '''

    # Guardo los datos del servicio
    datos_servicio = eval(parametros['log']['datos'])

    id_servicio = datos_servicio['datos_ejecucion']['id_servicio']

    estado_servicio = obtener_estado_del_servicio(id_servicio)
    print("ESTADO DEL SERVICIO: ", estado_servicio)

    # Guardamos el booleano para verificar el estado del servicio
    fue_despachado = estado_servicio['despachado']

    parametros['servicio'] = estado_servicio

    # si el servicio ya fue despachado
    if fue_despachado:

        # Creamos el booleano para saber si el movil llego a destino
        llego_a_destino = llego_movil_a_destino(estado_servicio)

        # Si el movil llego a su destino
        if llego_a_destino:
            print("*********>ENTRA EN ARRIBO")

            texto = obtener_texto_a_enviar(parametros, 'arribo')  # Obtenemos el mensaje que debemos enviar

            enviar_estado_servicio(parametros, texto)  # Enviamos el mensaje hacia atmsj

            dic = {
                'despachado': True,
                'con_titulo': False  # Este dato sirve para saber si debemos repetir el menu sin titulo
            }

            # Devuelvo la respuesta con True y el diccionario como dato, de esta manera se encarga el titulo de armar el mensaje.
            return respuesta(True, u'Se obtuvo el estado servicio con exito', dato=dic)

        texto = obtener_texto_a_enviar(parametros, 'despachado')  # Obtenemos el mensaje que debemos enviar

        enviar_estado_servicio(parametros, texto)  # Enviamos el mensaje hacia atmsj

        dic = {
            'despachado': True,
            'con_titulo': False  # Este dato sirve para saber si debemos repetir el menu sin titulo
        }

        # Devuelvo la respuesta con True y el estado del servicio
        return respuesta(True, u'Se obtuvo el estado servicio con exito', dato=dic)

    else:  # Si el servicio no se encuentra despachado

        texto = obtener_texto_a_enviar(parametros, 'sin_despachar')  # Obtenemos el mensaje que debemos enviar

        enviar_estado_servicio(parametros, texto)  # Enviamos el mensaje hacia atmsj

        dic = {
            'despachado': False,
            'con_titulo': False  # Este dato sirve para saber si debemos repetir el menu sin titulo
        }

        return respuesta(True, u'Se obtuvo el estado servicio con exito', dato=dic)


def llego_movil_a_destino(estado_servicio):
    return estado_servicio['informacion_servicio']['Distancia'] < 100
