# -*- coding: utf-8 -*-

from at.orm.decorators import DBSwitch
from at.utiles.conversiones import respuesta


@DBSwitch('cpbot')
class Funciones:

    def __init__(self, datos):
        """
        En el init se reciben lo datos de la request.
        """
        self.datos = datos

    def __registro_a_dict(self, registro):
        """
        Funcion privada para formatear un registro de SQLAlchemy a diccionario.
        """
        dic = registro.__dict__
        dic.pop('_sa_instance_state')
        return dic

    def obtener_funciones(self):
        """
        Obtiene todas las funciones que se encuentran en la base de datos
        """

        session = self.cpbot.binded_session()

        funciones = self.cpbot.tabla('funciones')

        q_obj = session.query(funciones)

        registros = q_obj.all()

        if len(registros) == 0:  # Si no se encontro ninguna funcion
            session.close()
            return respuesta(estado=False,
                             rta="No se encontro ninguna funcion en la base de datos")

        lista = list()

        for registro in registros:

            dic = self.__registro_a_dict(registro)

            lista.append(dic['nombre'])
        session.close()
        return respuesta(estado=True,
                         rta="Se obtuvieron las funciones con exito",
                         dato=lista)