# -*- coding: iso-8859-1 -*-

import unittest

from at.map.provincia import ProvinciaPostgres


class TestProvincia(unittest.TestCase):

    def setUp(self):
        self.provincia_postgres = ProvinciaPostgres()

    def tearDown(self):
        pass

    def test_obtener_provincia_postgres(self):
        # caso incorrecto
        id_provincia = 'asd'
        r = self.provincia_postgres.obtener_provincia(id_provincia)
        self.assertFalse(r['Estado'])
        # caso correcto
        id_provincia = 1
        r = self.provincia_postgres.obtener_provincia(id_provincia)
        self.assertTrue(r['Estado'])

    def test_listar_provincias_postgres(self):
        # caso correcto
        r = self.provincia_postgres.listar_provincias(12)
        self.assertTrue(len(r['Respuesta']) > 0)
        self.assertTrue(r['Estado'])

    def test_grabar_provincia_postgres(self):

        ### CASOS INCORRECTOS


        id_pais = None
        nombre = None
        id_provincia = None

        rta = self.provincia_postgres.grabar(
            id_pais, nombre, id_provincia=id_provincia
        )

        self.assertTrue(rta['Estado'] is False)

        ########################

        id_pais = 14
        nombre = None
        id_provincia = None

        rta = self.provincia_postgres.grabar(
            id_pais, nombre, id_provincia=id_provincia
        )

        self.assertTrue(rta['Estado'] is False)

        ########################

        id_pais = 12
        nombre = u'Formosa'
        id_provincia = None

        rta = self.provincia_postgres.grabar(
            id_pais, nombre, id_provincia=id_provincia
        )

        self.assertTrue(rta['Estado'] is False)

        ###

        ### CASOS CORRECTOS

        # id_pais = 12
        # nombre = u'Garca'
        # id_provincia = None
        #
        # rta = self.provincia_postgres.grabar(
        #     id_pais, nombre, id_provincia=id_provincia
        # )
        #
        # self.assertTrue(rta['Estado'] is True)

    def test_eliminar_provincia_postgres(self):

        ### CASOS INCORRECTOS

        id_provincia = None

        rta = self.provincia_postgres.eliminar(id_provincia)

        self.assertTrue(rta['Estado'] is False)

        id_provincia = 999999999

        rta = self.provincia_postgres.eliminar(id_provincia)

        self.assertTrue(rta['Estado'] is False)

        ########################

        id_pais = 12
        nombre = u'Garca'
        id_provincia = 999999999

        rta = self.provincia_postgres.grabar(
            id_pais, nombre, id_provincia=id_provincia
        )

        self.assertTrue(rta['Estado'] is True)

        id_provincia = 999999999

        rta = self.provincia_postgres.eliminar(id_provincia)

        self.assertTrue(rta['Estado'] is True)


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestProvincia))
    return suite
