# -*- coding: utf-8 -*-

import unittest

from at.map import _
from at.map.routing import Routing
from at.orm.abm import ABM


class TestRouting(unittest.TestCase):

    def setUp(self):
        self.routing = Routing()

    def tearDown(self):
        pass

    def test_obtener_recorrido_pgr(self):

        # origen = [-32.933576, -60.718233]
        origen = [-32.97250395241524, -60.66613335125762]
        # destino = [-32.936907, -60.668676]
        destino = [-32.97413063528369, -60.66146835228172]
        direccional = False

        # Creo la topología.
        rta = self.routing.obtener_recorrido(
            origen, destino, direccional=direccional
        )

        self.assertTrue(rta['Estado'] is True)

        # Determino los parametros.
        origen = [-32.895753, -60.688870]

        destino = [-32.914028, -60.683446]

        # Creo la topología.
        rta = self.routing.obtener_recorrido(
            origen, destino, direccional=direccional
        )

        self.assertTrue(rta['Estado'] is True)

    def test_recorrido_varios_destinos(self):

        # Creo los puntos.
        destino_1 = [-32.933576, -60.718233]
        destino_2 = [-32.936907, -60.668676]
        destino_3 = [-32.937100, -60.664126]
        destino_4 = [-32.937530, -60.668201]
        destino_5 = [-32.938630, -60.668236]
        destino_6 = [-32.9396311, -60.6686452]

        # Defino la lista de destinos.
        destinos = [
            destino_1, destino_2, destino_3, destino_4, destino_5, destino_6
        ]

        # Defino direccional.
        direccional = False

        # Creo la topología.
        rta = self.routing.recorrido_varios_destinos(
            destinos, direccional=direccional
        )

        self.assertTrue(rta['Estado'])


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestRouting))
    return suite
