# -*- coding: iso-8859-1 -*-

from at.orm.decorators import DBSwitch

from sqlalchemy.sql.expression import and_
from sqlalchemy.sql.expression import or_
from sqlalchemy.sql.expression import func


@DBSwitch('portics')
class Mapas(object):
    def __init__(self):
        self.debug = False

    def traducir(self):

        session = self.gis2.binded_session()
        calles_nombres = self.gis2.tabla('calles_nombres')

        q_obj = session.query(calles_nombres)
        q_obj = q_obj.filter(and_(
            calles_nombres.nombre != None,
            calles_nombres.nombre != '',
            calles_nombres.nombre.like('%~[%')
        ))

        ciudades_tmp = q_obj.all()
        for c in ciudades_tmp:
#            c.nombre = c.nombre.replace('~[0X03]','')
            aux = c.nombre.split('~[0X1E]')
            if len(aux) == 1:
                aux = aux[0].split('~[0X1F]')
            aux[0] = aux[0].strip()
            aux[1] = aux[1].strip()
            if len(aux[1]) > len(aux[0]):
                aux2 = aux[0]
                aux[0] = aux[1]
                aux[1] = aux2
            c.nombre = aux[0]
            if aux[1] != '':
                c.etiqueta = aux[1]
        session.flush()
        session.commit()


    def migrar(self):
        session = self.gis2.binded_session()
        tabla_autopistas = self.gis2.tabla('argentina_autopistas_l')
        tabla_avenidas = self.gis2.tabla('argentina_avenidas_l')
        tabla_rutas = self.gis2.tabla('argentina_rutas_l')
        tabla_caminos = self.gis2.tabla('argentina_caminos_l')
        tabla_calles = self.gis2.tabla('argentina_calles_l')

        calles_nombres = self.gis2.tabla('calles_nombres')
        provincias = self.gis2.tabla('provincias')
        ciudades = self.gis2.tabla('ciudades')

        id_calle_nombre = 1
        tipos = {
            'calle':1,
            '0x0001':2,
            '0x0002':3,
            '0x0003':4,
            '0x0004':5,
            '0x0005':6,
            '0x0006':7,
            '0x0007':8,
            '0x0008':9,
            '0x0009':10,
            '0x000a':11,
            '0x000b':12,
            '0x000c':13,
            '0x000f':14,
            '0x0010':15,
            '0x0016':16
        }
        buffer = {}

        q_obj = session.query(provincias).distinct()

        provincias_tmp = q_obj.all()

        provincias = {}
        for p in provincias_tmp:
            provincias[str(p.nombre).upper()] = {}
            provincias[str(p.nombre).upper()]['id'] = p.id
            provincias[str(p.nombre).upper()]['ciudades'] = {}

            q_obj = session.query(ciudades)
            q_obj = q_obj.filter(
                ciudades.idProvincia == p.id
            )

            ciud = q_obj.all()

            for c in ciud:
                provincias[unicode(p.nombre).upper()]['ciudades'][unicode(c.nombre).upper()] = c.id


        '''#Agrego las ciudades

        q_obj = session.query(func.convert_to(func.lower(tabla_calles.city).label('city'),'UTF8').label('city')).distinct()
        q_obj = q_obj.filter(
            tabla_calles.provincia == str(p.nombre).upper()
        )

        ciud = q_obj.all()

        for c in ciud:
            nombre = str(c.city).lower().replace('?','?').replace('?','?').capitalize()
            print p.nombre,nombre
            d = {}
            d['nombre'] = nombre,
            d['idProvincia'] = p.id
            print self.gis2.agregar('ciudades', **d)


        '''

        # Obtenemos todas la calles
        q_obj = session.query(tabla_calles)

        calles = q_obj.all()

        # Obtenemos todas la avenidas
        q_obj = session.query(tabla_avenidas)

        avenidas = q_obj.all()

        calles.extend(avenidas)

        # Obtenemos todas la rutas
        q_obj = session.query(tabla_rutas)

        rutas = q_obj.all()

        calles.extend(rutas)

        # Obtenemos todas las autpistas
        q_obj = session.query(tabla_autopistas)

        autopistas = q_obj.all()

        calles.extend(autopistas)

        # Obtenemos todos los caminos
        q_obj = session.query(tabla_caminos)

        caminos = q_obj.all()

        calles.extend(caminos)

        for cal in calles:

            if cal.type is None:
                cal.type = 'calle'

            prov = provincias.get(unicode(cal.provincia))
            if prov is None:
                # Ponemos la ciudad Argentina
                ciudad = 1
            else:
                ciudad = prov['ciudades'].get(unicode(cal.city))
                if ciudad is None:
                    # Ponemos la ciudad Argentina
                    ciudad = 1


            if buffer.get(str(ciudad)) is None:
                buffer[str(ciudad)] = {}

            nombre = cal.label
            if nombre is  None:
                nombre = ''

                # Agregamos la calle_nombre
                d = {}

                d['id'] = id_calle_nombre
                d['nombre'] = nombre
                d['id_ciudad'] = ciudad
                self.gis2.agregar('calles_nombres', **d)

                # Agregamos la calle
                d = {}
                d['id_calle_nombre'] = id_calle_nombre
                d['tipo'] = tipos[str(cal.type)]
                d['geom'] = cal.the_geom

                self.gis2.agregar('calles', **d)

                id_calle_nombre += 1

            else:

                if not (nombre in buffer[str(ciudad)].keys()):
                     # Agregamos la calle_nombre
                    d = {}

                    d['id'] = id_calle_nombre
                    d['nombre'] = nombre
                    d['id_ciudad'] = ciudad
                    self.gis2.agregar('calles_nombres', **d)
                    buffer[str(ciudad)][nombre] = id_calle_nombre

                    id_calle_nombre += 1

                # Agregamos la calle
                d = {}
                d['id_calle_nombre'] = buffer[str(ciudad)][nombre]
                d['tipo'] = tipos[str(cal.type)]
                d['geom'] = cal.the_geom

                self.gis2.agregar('calles', **d)


        '''

        for p in prov:
            print 'Busco',str(p.nombre).upper()
            q_obj = session.query(func.convert_to(func.lower(tabla_calles.city).label('city'),'UTF8').label('city')).distinct()
            q_obj = q_obj.filter(
                tabla_calles.provincia == str(p.nombre).upper()
            )

            ciud = q_obj.all()

            for c in ciud:
                c = str(c.city).lower().replace('?','?').replace('?','?').capitalize()
                print p.nombre,c
                d = {}
                d['nombre'] = c,
                d['idProvincia'] = p.id
                #print self.gis2.agregar('ciudades', **d)
        q_obj = session.query(tabla_calles.provincia, tabla_calles.city)
        q_obj = q_obj.filter(
            tabla_calles.pais == 'ARGENTINA'
        )


        all = q_obj.all()
        print all
        for a in all:
            print a



            provincia = q_obj.first()

            print provincia.id

#            d = {}
#            d['nombre'] = str(a.provincia).capitalize(),
#            d['idProvincia'] = 1

#            print self.gis2.agregar('provincias', **d)
        '''
        session.close()

        print tipos

    def migrar_de_osm(self):
        session = self.gis2.binded_session()
        osm_line = self.gis2.tabla('planet_osm_line')
        calles = self.gis2.tabla('calles')
        calles_nombres = self.gis2.tabla('calles_nombres')
        provincias = self.gis2.tabla('provincias')
        ciudades = self.gis2.tabla('ciudades')


        tipos = {
            "residential": 2,
            "secondary": 5,
            "motorway_link": 7,
            "primary": 6,
            "primary_link": 6,
            "service": 1,
            "motorway": 7,
            "unclassified": 1,
            "footway": 1,
            "tertiary": 4,
            "track": 1,
            "path": 1,
            "road": 7,
            "steps": 1,
            "trunk": 9 ,
            "trunk_link": 10
        }

        q_obj = session.query(calles_nombres)
        q_obj = q_obj.order_by(calles_nombres.id.desc())

        calle = q_obj.first()

        id_calle_nombre = calle.id + 1

        buffer = {}
         # Obtenemos todas la calles
        q_obj = session.query(
            func.st_multi(osm_line.way).label('way'),
            osm_line.name,
            osm_line.highway
        )
        q_obj = q_obj.filter(and_(
            osm_line.highway != None,
            osm_line.highway != ''
        ))

        calles_osm = q_obj.all()
        for cal in calles_osm:
            # Ponemos a santo domingo en este caso
            ciudad = 1309

            if buffer.get(str(ciudad)) is None:
                buffer[str(ciudad)] = {}

            nombre = cal.name

            if nombre is  None:
                nombre = ''

                # Agregamos la calle_nombre
                d = {}

                d['id'] = id_calle_nombre
                d['nombre'] = nombre
                d['id_ciudad'] = ciudad
                self.gis2.agregar('calles_nombres', **d)

                # Agregamos la calle
                d = {}
                d['id_calle_nombre'] = id_calle_nombre
                d['id_tipo'] = tipos[str(cal.highway)]
                d['geom'] = cal.way

                self.gis2.agregar('calles', **d)

                id_calle_nombre += 1

            else:

                if not (nombre in buffer[str(ciudad)].keys()):
                     # Agregamos la calle_nombre
                    d = {}

                    d['id'] = id_calle_nombre
                    d['nombre'] = nombre
                    d['id_ciudad'] = ciudad
                    self.gis2.agregar('calles_nombres', **d)
                    buffer[str(ciudad)][nombre] = id_calle_nombre

                    id_calle_nombre += 1

                # Agregamos la calle
                d = {}
                d['id_calle_nombre'] = buffer[str(ciudad)][nombre]
                d['id_tipo'] = tipos[str(cal.highway)]
                d['geom'] = cal.way

                self.gis2.agregar('calles', **d)


    def migrar_ferrocarriles(self):
        session = self.gis2.binded_session()
        tabla_ferrocarril = self.gis2.tabla('argentina_ferrocarril_l')

        buffer = {}

        # Obtenemos todos los ferrorcarriles
        q_obj = session.query(tabla_ferrocarril)

        ferrocarriles = q_obj.all()

        id_ferro_nombre = 1
        # Ponemos la ciudad Argentina
        ciudad = 1

        for f in ferrocarriles:

            if buffer.get(str(ciudad)) is None:
                buffer[str(ciudad)] = {}

            nombre = f.label
            if nombre is None:
                nombre = ''

                # Agregamos la calle_nombre
                d = {}

                d['id'] = id_ferro_nombre
                d['nombre'] = nombre
                d['id_ciudad'] = ciudad
                print self.gis2.agregar('ferrocarriles_nombres', **d)

                # Agregamos la calle
                d = {}
                d['id_ferrocarril_nombre'] = id_ferro_nombre
                d['geom'] = f.the_geom

                print self.gis2.agregar('ferrocarriles', **d)

                id_ferro_nombre += 1

            else:

                if not (nombre in buffer[str(ciudad)].keys()):
                     # Agregamos el nombre del ferrocarril
                    d = {}

                    d['id'] = id_ferro_nombre
                    d['nombre'] = unicode(nombre).title()
                    d['id_ciudad'] = ciudad
                    print self.gis2.agregar('ferrocarriles_nombres', **d)
                    buffer[str(ciudad)][nombre] = id_ferro_nombre

                    id_ferro_nombre += 1

                # Agregamos el ferrocarril
                d = {}
                d['id_ferrocarril_nombre'] = buffer[str(ciudad)][nombre]
                d['geom'] = f.the_geom

                print self.gis2.agregar('ferrocarriles', **d)

        session.close()

    def migrar_ciudades(self):
        session = self.gis2.binded_session()
        tabla_argentina_ciudades = self.gis2.tabla('argentina_ciudades_p')
        tabla_ciudades = self.gis2.tabla('ciudades')
        tabla_asentamientos = self.gis2.tabla('argentina_asentamientos_p')
        tabla_pueblos = self.gis2.tabla('argentina_pueblos_p')

#        # Obtenemos todas las ciudades
#        q_obj = session.query(
#            tabla_argentina_ciudades.type,
#            tabla_argentina_ciudades.label,
#            func.st_astext(tabla_argentina_ciudades.the_geom).label('the_geom')
#        )
#        argentina_ciudades = q_obj.all()

        argentina_ciudades = []

        q_obj = session.query(tabla_asentamientos)
        argentina_asentamientos = q_obj.all()

        argentina_ciudades.extend(argentina_asentamientos)

        q_obj = session.query(tabla_pueblos)
        argentina_pueblos = q_obj.all()

        argentina_ciudades.extend(argentina_pueblos)

        q_obj = session.query(tabla_ciudades)
        q_obj = q_obj.filter(or_(
            tabla_ciudades.geom == None
        ))
        ciudades = q_obj.all()
        buffer = {}
        for c in ciudades:
            for ac in argentina_ciudades:
                if unicode(c.nombre) == unicode(ac.label).title():
                    if buffer.get(unicode(c.nombre)) is None:
                        buffer[unicode(c.nombre)] = (ac.type,ac.the_geom)
#                        print 'agregamos',unicode(c.nombre)
                    else:
                        print 'Se repite', unicode(c.nombre)
#                        print ac.the_geom, ac.type
#                        print buffer[unicode(c.nombre)][1],buffer[unicode(c.nombre)][0]
                        buffer[unicode(c.nombre)] = False

        for c in ciudades:
            if buffer.get(unicode(c.nombre)) != None:
                if buffer[unicode(c.nombre)] != False:
                    c.nombre = unicode(c.nombre).title()
                    c.tipo = buffer[unicode(c.nombre)][0]
                    c.geom = buffer[unicode(c.nombre)][1]

        session.flush()
        session.commit()

#

#                        if ac.the_geom == buffer[unicode(c.nombre)][1]:
#                            print 'COINCIDE GEOMETRIA'
#                            print ac.type,buffer[unicode(c.nombre)][0]

#                        else:
#                            print ac.the_geom, ac.type
#                            print buffer[unicode(c.nombre)][1],buffer[unicode(c.nombre)][0]
#        print buffer,len(buffer)
        session.close()

    def migrar_agua_area(self):
        session = self.gis2.binded_session()
        tabla_argentina_agua = self.gis2.tabla('argentina_agua_a')

        # Obtenemos todas las ciudades
        q_obj = session.query(
            tabla_argentina_agua.label,
            func.st_buffer(func.st_collect(tabla_argentina_agua.the_geom),0).label('the_geom')
        )
        q_obj = q_obj.group_by(tabla_argentina_agua.label)
        areas = q_obj.all()
        session.close()
        for area in areas:
            print area.label
            d = {}
            d['id_pais'] = 1
            d['nombre'] = area.label
            d['geom'] = area.the_geom
            print self.gis2.agregar('aguas_area', **d)

    def limpiar_ciudades(self):

        session = self.gis2.binded_session()
        tabla_ciudades = self.gis2.tabla('ciudades_prov')

        buffer = {}

        id_prov = {
            "TUCUMAN": 23,
            "TIERRA DEL FUEGO ANTARTIDA E ISLAS DEL ATLANTICO S": 24,
            "SANTIAGO DEL ESTERO": 19,
            "SANTA FE": 20,
            "SANTA CRUZ": 18,
            "SAN LUIS": 22,
            "SAN JUAN": 21,
            "SALTA": 17,
            "RIO NEGRO": 16,
            "NEUQUEN": 15,
            "MISIONES": 14,
            "MENDOZA": 13,
            "LA RIOJA": 12,
            "LA PAMPA": 11,
            "JUJUY": 10,
            "FORMOSA": 9,
            "ENTRE RIOS": 8,
            "CORRIENTES": 5,
            "CORDOBA": 4,
            "CHUBUT": 3,
            "CHACO": 2,
            "CATAMARCA": 6,
            "BUENOS AIRES": 1
        }

        '''
        1 Capital pais
        2 Segunda ciudad mas importante
        3 Terceras ciudades mas importantes
        4 Cuartas ciudades mas impotantes
        5
        6
        7
        8 Ciudades menos importantes
        9 Municipios
        10 Pueblo mas importante
        11
        12
        13 Pueblo menos importante
        14 Asentamiento mas importante
        15
        16
        17 Asentamiento menos importante
        '''

        id_tipo = {
            '0x0200': 1,
            '0x0300': 2,
            '0x0400': 3,
            '0x0500': 4,
            '0x0600': 5,
            '0x0700': 6,
            '0x0800': 7,
            '0x0900': 8,
            '0x1f00': 9,
            '0x0a00': 10,
            '0x0b00': 11,
            '0x0c00': 12,
            '0x0d00': 13,
            '0x0e00': 14,
            '0x0f00': 15,
            '0x1000': 16,
            '0x1100': 17,
        }

        # Obtenemos el ultimo id de calle nombre
        q_obj = session.query(tabla_ciudades)
        q_obj = q_obj.order_by(tabla_ciudades.provincia.desc())
        q_obj = q_obj.order_by(tabla_ciudades.label.desc())

        ciudades = q_obj.all()
        for c in ciudades:
            if buffer.get(c.provincia+'-'+c.label) is None:
                buffer[c.provincia+'-'+c.label] = {
                    'nombre': c.label.title(),
                    'id_provincia': id_prov[c.provincia],
                    'id_tipo': id_tipo[c.type],
                    'geom': c.the_geom,
                }

        for key in buffer:
            print self.gis2.agregar('ciudades_prov2', **buffer[key])

        session.close()

    def migrar_calles_ciudades(self):

        session = self.gis2.binded_session()
        tabla_ciudades = self.gis2.tabla('ciudades')
        tabla_calles_nombres = self.gis2.tabla('calles_nombres')
        tabla_ciudades_prov = self.gis2.tabla('ciudades_prov2')

        # Correlacion entre id_provincias viejos y nuevos
        id_prov = [
            [21, 23],
            [7, 19],
            [8, 18],
            [5, 22],
            [16, 21],
            [17, 17],
            [2, 16],
            [11, 15],
            [18, 14],
            [23, 13],
            [19, 12],
            [20, 11],
            [14, 10],
            [10, 9],
            [12, 8],
            [9, 5],
            [15, 4],
            [6, 3],
            [22, 2],
            [3, 6],
            [4, 1],
            [13, 20],
        ]

        conn = session.connection()
        for p in id_prov:
            # Obtenemos el ultimo id de calle nombre
            q_obj = session.query(tabla_ciudades, tabla_ciudades_prov.id)
            q_obj = q_obj.join((tabla_ciudades_prov, and_(
                    func.lower(tabla_ciudades.nombre).label('nombre') == func.lower(tabla_ciudades_prov.nombre).label('nombre_prov'),
                    tabla_ciudades.id_provincia == p[0],
                    tabla_ciudades_prov.id_provincia == p[1],
                ),
            ))

            ciudades = q_obj.all()
            for c in ciudades:
                # Actualizamos con la ciudad nueva

#                for call in q_obj2.all():
#                     call.id_ciudad = c.id
#                session.commit()

                print c.id
                print c[0].id
                print c[0].nombre
                sql = 'UPDATE calles_nombres SET id_ciudad = '+str(c.id)+' WHERE id_ciudad = '+str(c[0].id)
                print sql
                r = conn.execute(sql)
                print r.rowcount
            print len(ciudades)
        session.commit()
        session.close()



    def migrar_provincia(self):
        provincia = 'tucuman'
        id_provincia = 23

        reemplazo_ciudades = {
            'Capital': "San Miguel De Tucuman",
            'Leales': 'Villa De Leales',
            'Cruz Alta': "Banda Del Rio Sali",
        }

        tipos = {
            "Conector de autopistas": 8,
            "Ruta principal": 7,
            "Autopista": 8,
            "Callejon/Calle privada": 13,
            "Sendero": 1,
            "Colectora": 6,
            "Camino sin pavimentar": 1,
            "Rotonda": 12,
            "Calle residencial": 2,
            "Rampa de autopista": 10,
            "Otra ruta": 6,
            "Avenida/Ruta Arterial": 6,
        }

        session = self.gis2.binded_session()
        tabla_provincias = self.gis2.tabla('provincias')
        tabla_calles = self.gis2.tabla('calles')
        tabla_calles_nombres = self.gis2.tabla('calles_nombres')
        tabla_ciudades = self.gis2.tabla('ciudades')
        tabla_provincia = self.gis2.tabla(provincia)

        # Obtenemos la geometria de la provincia a limpiar
        q_obj = session.query(tabla_provincias.geom).filter(tabla_provincias.id == id_provincia)
        prov = q_obj.first()
        if prov is None:
            print 'Fallo'
            return

        geom_provincia = prov.geom

        # Obtenemos el ultimo id de calle nombre
        q_obj = session.query(tabla_calles_nombres)
        q_obj = q_obj.order_by(tabla_calles_nombres.id.desc())
        calle = q_obj.first()
        id_calle_nombre = calle.id + 1

        # Definimos los buffers
        buffer_ciudades = []
        buffer_calles = {}

        q_obj = session.query(tabla_ciudades).filter(tabla_ciudades.id_provincia == id_provincia)
        ciudades = q_obj.all()
        ciudades_provincia = {}
        for ciudad in ciudades:
            ciudades_provincia[ciudad.nombre] = ciudad.id
            q_obj2 = session.query(tabla_calles_nombres).filter(
                tabla_calles_nombres.id_ciudad == ciudad.id
            )
            calles_nombres = q_obj2.all()
            for calle_nombre in calles_nombres:
                q_obj3 = session.query(tabla_calles).filter(
                    tabla_calles.id_calle_nombre == calle_nombre.id
                )
                # Borramos la calle
                q_obj3.delete(synchronize_session=False)
            # Borramos calle_nombre
            q_obj2.delete(synchronize_session=False)


            q_obj2 = session.query(tabla_calles_nombres).filter(
                tabla_calles_nombres.id_ciudad == ciudad.id
            )

        q_obj2 = session.query(tabla_calles_nombres).join((tabla_calles,
            tabla_calles.id_calle_nombre == tabla_calles_nombres.id)).filter(
            func.ST_Contains(geom_provincia, tabla_calles.geom))

        calles_nombres = q_obj2.all()
        for calle_nombre in calles_nombres:
            print calle_nombre.nombre
            q_obj3 = session.query(tabla_calles).filter(
               tabla_calles.id_calle_nombre == calle_nombre.id
            )
            # Borramos la calle
            q_obj3.delete(synchronize_session=False)

            q_obj3 = session.query(tabla_calles_nombres).filter(
               tabla_calles_nombres.id == calle_nombre.id
            )
            # Borramos la call nombre
            q_obj3.delete(synchronize_session=False)

        session.commit()

        ciudades_fallidas = []

        q_obj = session.query(tabla_provincia).filter(tabla_provincia.tipo != 'Ferrocarril')
        q_obj = q_obj.order_by(tabla_provincia.departamto).order_by(tabla_provincia.street).order_by(tabla_provincia.departamto)
        calles_nuevas = q_obj.all()
        for calle_nueva in calles_nuevas:
            if calle_nueva.departamto.title() not in buffer_ciudades:
                d = {}
                d['id_provincia'] = id_provincia
                d['nombre'] = calle_nueva.departamto.title()
                if ciudades_provincia.get(d['nombre']) != None:
                    buffer_ciudades.append(d['nombre'])
                    buffer_calles[d['nombre']] = []
                    id_ciudad = ciudades_provincia.get(d['nombre'])

                else:
                    if reemplazo_ciudades.get(d['nombre']) != None:
                        d['nombre'] = reemplazo_ciudades.get(d['nombre'])
                        if d['nombre'] not in buffer_ciudades:
                            buffer_ciudades.append(d['nombre'])
                            buffer_calles[d['nombre']] = []
                            id_ciudad = ciudades_provincia.get(d['nombre'])

                    elif d['nombre'] not in ciudades_fallidas:
                        ciudades_fallidas.append(d['nombre'])

#                print calle_nueva.departamto.title(), self.gis2.agregar('ciudades', **d)
#                buffer_ciudades.append(calle_nueva.departamto.title())
#                buffer_calles[calle_nueva.departamto.title()] = []
#                q_obj = session.query(tabla_ciudades.id).filter(
#                    tabla_ciudades.nombre == calle_nueva.departamto.title()
#                )
#                ciudad = q_obj.first()
#                id_ciudad = ciudad.id
#                sys.exit(1)
#                return

            nombre = calle_nueva.street
            if nombre is  None:
                nombre = ''

                id_calle_nombre += 1
                # Agregamos la calle_nombre
                d = {}
                d['id'] = id_calle_nombre
                d['nombre'] = nombre
                d['id_ciudad'] = id_ciudad
                print 'Calle Nombre vacia', self.gis2.agregar('calles_nombres', **d)

                # Agregamos la calle
                d = {}
                d['id_calle_nombre'] = id_calle_nombre
                d['id_tipo'] = tipos[str(calle_nueva.tipo)]
                d['sentido'] = calle_nueva.dirindicat
                d['desde_der'] = calle_nueva.fromright
                d['desde_izq'] = calle_nueva.fromleft
                d['hasta_der'] = calle_nueva.toright
                d['hasta_izq'] = calle_nueva.toleft
                d['geom'] = calle_nueva.the_geom

                print 'Calle',self.gis2.agregar('calles', **d)


            else:
                nombre = nombre.title()
                ciudad = calle_nueva.departamto.title()
                if reemplazo_ciudades.get(ciudad) != None:
                    ciudad = reemplazo_ciudades.get(ciudad)
                if not (nombre in buffer_calles[ciudad]):
                    # Agregamos la calle_nombre
                    id_calle_nombre += 1
                    d = {}
                    d['id'] = id_calle_nombre
                    d['nombre'] = nombre
                    d['id_ciudad'] = id_ciudad
                    print 'Calle nombre',nombre, self.gis2.agregar('calles_nombres', **d)
                    buffer_calles[ciudad].append(nombre)

                # Agregamos la calle
                d = {}
                d['id_calle_nombre'] = id_calle_nombre
                d['id_tipo'] = tipos[str(calle_nueva.tipo)]
                d['sentido'] = calle_nueva.dirindicat
                d['desde_der'] = calle_nueva.fromright
                d['desde_izq'] = calle_nueva.fromleft
                d['hasta_der'] = calle_nueva.toright
                d['hasta_izq'] = calle_nueva.toleft
                d['geom'] = calle_nueva.the_geom

                print 'Calle',self.gis2.agregar('calles', **d)

        session.close()

    def page_query(self, q):
        offset = 0
        while True:
            for elem in q.limit(100).offset(offset):
               r = True
               yield elem
            offset += 100
            if not r:
                break
            r = False

    def migrar_portics(self):
        reemplazo_ciudades = {
            'Capital': "San Miguel De Tucuman",
            'Leales': 'Villa De Leales',
            'Cruz Alta': "Banda Del Rio Sali",
        }

        tipos = {
            "Conector de autopistas": 8,
            "Ruta principal": 7,
            "Autopista": 8,
            "Callejon/Calle privada": 13,
            "Sendero": 1,
            "Colectora": 6,
            "Camino sin pavimentar": 1,
            "Rotonda": 12,
            "Calle residencial": 2,
            "Rampa de autopista": 10,
            "Otra ruta": 6,
            "Avenida/Ruta Arterial": 6,
        }

        buffer_ciudades = {}

        session = self.portics.binded_session()
        tabla_calles = self.portics.tabla('calles')
        tabla_calles_nombres = self.portics.tabla('calles_nombres')
        tabla_ciudades = self.portics.tabla('ciudades')
        tabla_localidades = self.portics.tabla('localidades')
        tabla_provincias = self.portics.tabla('provincias')
        tabla_callesportics = self.portics.tabla('callesportics')

        q_obj = session.query(tabla_callesportics.loc).order_by('loc').distinct()
        for c_port in self.page_query(q_obj):
            ind_par = c_port.loc.find('(')
            if ind_par > 0:
                c_port.loc = c_port.loc[:ind_par]

            if buffer_ciudades.get(c_port.loc) is None:
                q_obj2 = session.query(tabla_ciudades.id, tabla_ciudades.nombre).join(
                            (
                                tabla_provincias,
                                tabla_ciudades.id_provincia == tabla_provincias.id
                            )
                        ).join((
                            tabla_localidades,
                            func.ST_Distance(tabla_localidades.the_geom, tabla_ciudades.geom).label('distancia') < 0.5
                        )).filter(
                            or_(
                                func.ST_Contains(tabla_provincias.geom, c_port.the_geom),
                                func.ST_Distance(tabla_provincias.geom, c_port.the_geom).label('distancia') < 0.5
                            )
                        )
                aux = c_port.loc.split(' ')
                terms = []
                terms.append(tabla_ciudades.nombre.op('~*')(c_port.loc))
                str_order = "CASE WHEN lower(ciudades.nombre) LIKE '" + c_port.loc.lower() + " %' THEN 1 ELSE 0 END + "
                str_order += "CASE WHEN lower(ciudades.nombre) LIKE '% " + c_port.loc.lower() + "' THEN 1 ELSE 0 END + "
                for a in aux:
                    a = a.strip()
                    if a != 'DE' and a != 'DEL' and a != 'LA' and a != 'LAS' and a != 'EL' and a != 'LOS' and a != '':
                        terms.append(tabla_ciudades.nombre.op('~*')(a))
                        str_order += "CASE WHEN lower(ciudades.nombre) LIKE '% " + a.lower() + "' THEN 1 ELSE 0 END + "
                        str_order += "CASE WHEN lower(ciudades.nombre) LIKE '" + a.lower() + " %' THEN 1 ELSE 0 END + "
                        str_order += "CASE WHEN lower(ciudades.nombre) LIKE '% " + a.lower() + " %' THEN 1 ELSE 0 END + "

                str_order  = str_order[:-2] + ' DESC'
                q_obj2 = q_obj2.filter(or_(*terms)).order_by(str_order)
                ciudad = q_obj2.first()
                if ciudad is not None:
                    buffer_ciudades[c_port.loc] = [ciudad.id, ciudad.nombre]
                    print c_port.loc,'=>', buffer_ciudades.get(c_port.loc)

                else:
                    buffer_ciudades[c_port.loc] = [None, None]

    def backup(self):
        calles = [[842635,433391,"",6,1,"0105000020E6100000010000000102000000020000006EC0E787114E50C068AED3484BD53AC00E846401134E50C0213CDA3862D53AC0",0,0,398,400],
[842671,433391,"",6,1,"0105000020E610000001000000010200000002000000274EEE77284E50C0AD174339D1D63AC06EFAB31F294E50C0BB7EC16ED8D63AC0",0,0,798,800],
[842753,433397,"",2,1,"0105000020E610000001000000010200000002000000D482177D054D50C0C6A2E9EC64D83AC009C4EBFA054D50C02A1DACFF73D83AC0",200,200,201,201],
[843431,433437,"",2,1,"0105000020E610000001000000010200000002000000DD5ED218AD4D50C03546EBA86AD23AC0A81DFE9AAC4D50C08A3C49BA66D23AC0",500,598,501,599],
[843895,433466,"",2,1,"0105000020E610000001000000010200000002000000BB0F406A134D50C01DC9E53FA4CF3AC0A583F57F0E4D50C08126C286A7CF3AC0",759,741,758,740],
[844924,433533,"",2,1,"0105000020E610000001000000010200000002000000A7CB6262F34D50C0E44EE960FDCF3AC0CEA5B8AAEC4D50C01CB1169F02D03AC0",1100,1098,1101,1099],
[844942,433535,"",2,0,"0105000020E610000001000000010200000002000000AC1C5A643B4F50C0B2683A3B19CC3AC008556AF6404F50C0075F984C15CC3AC0",1898,1898,1899,1899],
[845678,433591,"",2,1,"0105000020E61000000100000001020000000200000009C4EBFA054D50C02A1DACFF73D83AC0D482177D054D50C0C6A2E9EC64D83AC0",1049,1001,1048,1000],
[845763,433598,"",2,0,"0105000020E610000001000000010200000002000000A72215C6165050C071C971A774D03AC08750A5660F5050C0637FD93D79D03AC0",498,498,499,499],
[845965,433618,"",2,0,"0105000020E610000001000000010200000002000000C6850321595050C060CD018239D23AC08E23D6E2535050C00AD7A3703DD23AC0",3999,3981,3998,3980],
[846688,433680,"",2,1,"0105000020E610000001000000010200000002000000CEA5B8AAEC4D50C01CB1169F02D03AC0A7CB6262F34D50C0E44EE960FDCF3AC0",1600,1628,1601,1629],
[846719,433680,"",2,1,"0105000020E610000001000000010200000002000000200C3CF71E4E50C08E01D9EBDDCF3AC0F20C1AFA274E50C0C746205ED7CF3AC0",1800,1828,1801,1829],
[847095,433702,"",6,0,"0105000020E610000001000000010200000002000000A9FB00A4365150C04260E5D022D33AC0C18BBE82345150C0A5BDC11726D33AC0",199,181,198,180],
[847133,433702,"",2,1,"0105000020E610000001000000010200000002000000F94ECC7A314E50C021938C9C85D53AC0BCE82B48334E50C0CBD6FA22A1D53AC0",1498,1498,1499,1499],
[847448,433715,"",2,1,"0105000020E6100000010000000102000000020000004E621058394E50C02098A3C7EFD53AC08386FE092E4E50C04BB0389CF9D53AC0",1501,1501,1498,1500],
[847583,433721,"",2,1,"0105000020E610000001000000010200000002000000BCE82B48334E50C0CBD6FA22A1D53AC0F94ECC7A314E50C021938C9C85D53AC0",499,499,498,498],
[847591,433721,"",2,1,"0105000020E6100000010000000102000000020000008386FE092E4E50C04BB0389CF9D53AC04E621058394E50C02098A3C7EFD53AC0",599,599,598,598],
[847953,433752,"",2,1,"0105000020E610000001000000010200000002000000FEB7921D1B4D50C08CDB68006FD13AC0ACC5A700184D50C0A88C7F9F71D13AC0",901,899,900,900],
[848863,433813,"",2,0,"0105000020E610000001000000010200000002000000E5D53906644B50C020EF552B13D63AC0567DAEB6624B50C0832F4CA60AD63AC0",0,0,0,0],
[849226,433824,"",2,1,"0105000020E610000001000000010200000002000000115322895E4E50C0A774B0FECFD13AC0E3361AC05B4E50C0C425C79DD2D13AC0",498,498,499,499],
[849319,433831,"",2,1,"0105000020E6100000010000000102000000020000006EC0E787114E50C068AED3484BD53AC00E846401134E50C0213CDA3862D53AC0",1401,1401,1398,1400],
[850013,433881,"",2,0,"0105000020E610000001000000010200000002000000C6850321595050C060CD018239D23AC08E23D6E2535050C00AD7A3703DD23AC0",48,48,49,49],
[850123,433889,"",2,1,"0105000020E6100000010000000102000000020000006EFAB31F294E50C0BB7EC16ED8D63AC0274EEE77284E50C0AD174339D1D63AC0",1401,1401,1398,1400],
[850438,433917,"",2,1,"0105000020E610000001000000010200000002000000CA37DBDC984E50C0446E861BF0D13AC0462575029A4E50C00B46257502D23AC0",2099,2101,2098,2100],
[850661,433924,"",2,1,"0105000020E610000001000000010200000002000000F20C1AFA274E50C0C746205ED7CF3AC0200C3CF71E4E50C08E01D9EBDDCF3AC0",1099,1099,1098,1098],
[850766,433931,"",2,1,"0105000020E6100000010000000102000000020000008750A5660F5050C0637FD93D79D03AC0A72215C6165050C071C971A774D03AC0",3750,3798,3751,3799],
[850769,433931,"",2,1,"0105000020E610000001000000010200000002000000A81DFE9AAC4D50C08A3C49BA66D23AC0DD5ED218AD4D50C03546EBA86AD23AC0",1198,1198,1199,1199],
[850785,433931,"",2,1,"0105000020E610000001000000010200000002000000E3361AC05B4E50C0C425C79DD2D13AC0115322895E4E50C0A774B0FECFD13AC0",1900,1918,1901,1919],
[850863,433937,"",6,1,"0105000020E610000001000000010200000002000000FEB7921D1B4D50C08CDB68006FD13AC0ACC5A700184D50C0A88C7F9F71D13AC0",0,0,698,700],
[851017,433952,"",2,0,"0105000020E610000001000000010200000002000000A583F57F0E4D50C08126C286A7CF3AC0BB0F406A134D50C01DC9E53FA4CF3AC0",1398,1398,1399,1399],
[851141,433957,"",2,1,"0105000020E610000001000000010200000002000000462575029A4E50C00B46257502D23AC0CA37DBDC984E50C0446E861BF0D13AC0",400,418,401,419],
[851214,433968,"",2,0,"0105000020E610000001000000010200000002000000A9FB00A4365150C04260E5D022D33AC0C18BBE82345150C0A5BDC11726D33AC0",619,601,618,600],
[851350,433981,"",2,0,"0105000020E61000000100000001020000000200000008556AF6404F50C0075F984C15CC3AC0AC1C5A643B4F50C0B2683A3B19CC3AC0",3119,3101,3118,3100],
[851669,434014,"",8,1,"0105000020E610000001000000010200000002000000567DAEB6624B50C0832F4CA60AD63AC0E5D53906644B50C020EF552B13D63AC0",0,0,0,0],
[852144,434489,"",2,0,"0105000020E6100000010000000102000000020000003A3B191C254D50C0734BAB2171DF3AC08C2D0439284D50C00FEECEDA6DDF3AC0",0,0,0,0],
[852317,434662,"",2,0,"0105000020E6100000010000000102000000020000003A3B191C254D50C0734BAB2171DF3AC08C2D0439284D50C00FEECEDA6DDF3AC0",0,0,0,0],
[852934,435076,"",1,0,"0105000020E61000000100000001020000000200000060764F1E167C50C0FCC6D79E594A3BC0CBF8F719177C50C09869FB57564A3BC0",0,0,0,0],
[852938,435076,"",1,0,"0105000020E610000001000000010200000002000000CBF8F719177C50C09869FB57564A3BC060764F1E167C50C0FCC6D79E594A3BC0",0,0,0,0],
[853758,435134,"",2,1,"0105000020E610000001000000010200000002000000C93CF207036750C057957D5704573BC005A3923A016750C01E166A4DF3563BC0",0,0,0,0],
[853787,435136,"",2,0,"0105000020E61000000100000001020000000200000005A3923A016750C01E166A4DF3563BC0C93CF207036750C057957D5704573BC0",0,0,0,0],
[854629,435156,"",2,0,"0105000020E61000000100000001020000000200000074D2FBC6D76650C053CBD6FA22593BC0C6C4E6E3DA6650C0A9C1340C1F593BC0",0,0,0,0],
[855477,435593,"",2,0,"0105000020E6100000010000000102000000020000006284F068E36650C0D44334BA83583BC0B476DB85E66650C07FC16ED8B6583BC0",0,0,0,0],
[855588,435704,"",2,0,"0105000020E61000000100000001020000000200000074D2FBC6D76650C053CBD6FA22593BC0C6C4E6E3DA6650C0A9C1340C1F593BC0",0,0,0,0],
[855965,436081,"",2,0,"0105000020E6100000010000000102000000020000006284F068E36650C0D44334BA83583BC0B476DB85E66650C07FC16ED8B6583BC0",0,0,0,0],
[864684,440091,"",2,0,"0105000020E6100000010000000102000000020000006B82A8FB005650C070253B3602F13AC03541D47D005650C07E6FD39FFDF03AC0",0,0,0,0],
[864844,440251,"",2,0,"0105000020E6100000010000000102000000020000003541D47D005650C07E6FD39FFDF03AC06B82A8FB005650C070253B3602F13AC0",0,0,0,0],
[865899,440973,"",2,0,"0105000020E610000001000000010200000002000000C5E6E3DA505F50C0DEE522BE132B3BC0DE76A1B94E5F50C0174850FC182B3BC0",0,0,0,0],
[866536,440997,"",2,0,"0105000020E610000001000000010200000002000000C5E6E3DA505F50C0DEE522BE132B3BC0DE76A1B94E5F50C0174850FC182B3BC0",0,0,0,0],
[874001,444265,"",2,1,"0105000020E610000001000000010200000002000000D3DEE00B934D50C041BCAE5FB0CB3AC0967840D9944D50C06BB75D68AECB3AC0",2399,2401,2398,2400],
[874029,444268,"",2,0,"0105000020E6100000010000000102000000020000008750A5660F5050C0062AE3DF67BC3AC0A0E062450D5050C0B13385CE6BBC3AC0",0,0,0,0],
[874520,444313,"",2,0,"0105000020E61000000100000001020000000200000065DF15C1FF5050C0B532E197FAB93AC057957D57045150C052D50451F7B93AC0",0,0,0,0],
[874527,444314,"",2,0,"0105000020E61000000100000001020000000200000057957D57045150C052D50451F7B93AC065DF15C1FF5050C0B532E197FAB93AC0",0,0,0,0],
[874531,444314,"",2,0,"0105000020E61000000100000001020000000200000037C30DF8FC5050C0C364AA6054BA3AC02C7DE882FA5050C051BD35B055BA3AC0",0,0,0,0],
[876981,444433,"",1,0,"0105000020E6100000010000000102000000020000006B9A779CA26750C062156F641EA93AC0EF8FF7AA956750C046D3D9C9E0A83AC0",0,0,0,0],
[877253,444433,"",1,0,"0105000020E6100000010000000102000000020000006B9A779CA26750C062156F641EA93AC0EF8FF7AA956750C046D3D9C9E0A83AC0",0,0,0,0],
[877749,444436,"",2,0,"0105000020E610000001000000010200000002000000CC457C27665150C0062AE3DF67BC3AC008AC1C5A645150C0062AE3DF67BC3AC0",1299,1201,1298,1200],
[878076,444465,"",2,0,"0105000020E610000001000000010200000002000000D3DEE00B934D50C041BCAE5FB0CB3AC0967840D9944D50C06BB75D68AECB3AC0",1500,1518,1501,1519],
[878226,444490,"",2,0,"0105000020E6100000010000000102000000020000008750A5660F5050C0062AE3DF67BC3AC0A0E062450D5050C0B13385CE6BBC3AC0",0,0,0,0],
[878429,444511,"",2,0,"0105000020E6100000010000000102000000020000007BBDFBE3BD4E50C00AF4893C49CA3AC03411363CBD4E50C0B5E0455F41CA3AC0",0,0,0,0],
[878677,444530,"",2,0,"0105000020E6100000010000000102000000020000002C7DE882FA5050C051BD35B055BA3AC037C30DF8FC5050C0C364AA6054BA3AC0",0,0,0,0],
[880166,444837,"",2,0,"0105000020E610000001000000010200000002000000CC457C27665150C0062AE3DF67BC3AC008AC1C5A645150C0062AE3DF67BC3AC0",0,0,0,0],
[880213,444884,"",2,0,"0105000020E6100000010000000102000000020000007BBDFBE3BD4E50C00AF4893C49CA3AC03411363CBD4E50C0B5E0455F41CA3AC0",0,0,0,0],
[885599,447874,"",2,0,"0105000020E61000000100000001020000000200000002F1BA7EC15850C01CEBE2361AD83AC0062FFA0AD25850C0B9533A58FFD73AC0",0,0,0,0],
[885601,447874,"",2,0,"0105000020E6100000010000000102000000020000005BCEA5B8AA5850C0C7F484251ED83AC002F1BA7EC15850C01CEBE2361AD83AC0",0,0,0,0],
[885748,447880,"",2,0,"0105000020E61000000100000001020000000200000002F1BA7EC15850C01CEBE2361AD83AC0062FFA0AD25850C0B9533A58FFD73AC0",0,0,0,0],
[885749,447880,"",2,0,"0105000020E6100000010000000102000000020000005BCEA5B8AA5850C0C7F484251ED83AC002F1BA7EC15850C01CEBE2361AD83AC0",0,0,0,0],
[886693,447962,"",2,0,"0105000020E61000000100000001020000000200000073A25D85945150C01A34F44F70D13AC0C49448A2975150C0FD82DDB06DD13AC0",100,198,101,199],
[887320,448034,"",2,0,"0105000020E610000001000000010200000002000000C49448A2975150C0FD82DDB06DD13AC073A25D85945150C01A34F44F70D13AC0",609,601,608,600]]
        for c in calles:
            d = {}
            d['gid'] = c[0]
            d['id_calle_nombre'] = c[1]
            d['alturas'] = c[2]
            d['id_tipo'] = c[3]
            d['sentido'] = c[4]
            d['geom'] = c[5]
            d['desde_izq'] = c[6]
            d['hasta_izq'] = c[7]
            d['desde_der'] = c[8]
            d['hasta_der'] = c[9]

            print 'Calle',self.portics.agregar('calles', **d)


    def reparar_alturas(self):
        session = self.portics.binded_session()
        tabla_callesporticsoriginal = self.portics.tabla('callesporticsoriginal')
        tabla_callesportics = self.portics.tabla('callesportics')

        q_obj = session.query(
            tabla_callesporticsoriginal.tipo,
            tabla_callesporticsoriginal.street,
            tabla_callesporticsoriginal.fromleft,
            tabla_callesporticsoriginal.toleft,
            tabla_callesporticsoriginal.fromright,
            tabla_callesporticsoriginal.toright,
        ).filter(and_(
            tabla_callesporticsoriginal.street != '',
            tabla_callesporticsoriginal.street != None,
            or_(
                tabla_callesporticsoriginal.fromleft != 0,
                tabla_callesporticsoriginal.toleft != 0,
                tabla_callesporticsoriginal.fromright != 0,
                tabla_callesporticsoriginal.toright != 0,
                )
            )
        ).order_by(tabla_callesporticsoriginal.street)
        total = q_obj.count()
        offset = 0
        cantidad = 1
        count = 0

        while offset < total:
            conn = session.connection()
            for c_port_ori in q_obj.limit(cantidad).offset(offset):
                q_obj2 = session.query(
                    tabla_callesporticsoriginal.gid,
                ).filter(
                    and_(
                        tabla_callesportics.tipo == c_port_ori.tipo,
                        tabla_callesportics.nombrecall != c_port_ori.street,
                    )
                )
                calle_nueva = q_obj2.first()
#                if calle_nueva is not None:
#                    sql = "UPDATE callesportics SET fromleft=%s, toleft=%s, fromright=%s, toright=%s WHERE gid=%s"% (
#                        str(c_port_ori.fromleft),
#                        str(c_port_ori.toleft),
#                        str(c_port_ori.fromright),
#                        str(c_port_ori.toright),
#                        str(calle_nueva.gid)
#                    )
#                    print sql
#                    r = conn.execute(sql)
#                    print r.rowcount
#                # Imprimimos la pasada
#                count += 1
#                print count
##                    print 'Actualizamos', c_port_ori.street
#
            # Aumentamos la pagina
            offset += cantidad
            session.commit()

        session.close()

#select astext(multi(ST_Union(the_geom))) as the_geom,label from argentina_agua_a group by label

if __name__ == '__main__':
    m = Mapas()
    m.reparar_alturas()
