# -*- coding: iso-8859-1 -*-

from at.orm.decorators import DBSwitch

from sqlalchemy.sql.expression import and_
from sqlalchemy.sql.expression import or_
from sqlalchemy.sql.expression import func


@DBSwitch('gis3')
class Mapas(object):
    def __init__(self):
        self.debug = False

    def reparar_alturas(self):
        session = self.portics.binded_session()
        tabla_callesporticsoriginal = self.portics.tabla('callesporticsoriginal')
        tabla_callesportics = self.portics.tabla('callesportics')

        q_obj = session.query(
            tabla_callesportics.gid,
            tabla_callesportics.loc,
            tabla_callesportics.nombrecall,
            tabla_callesportics.the_geom,
            tabla_callesportics.fromleft,
            tabla_callesportics.toleft,
            tabla_callesportics.fromright,
            tabla_callesportics.toright,
            tabla_callesportics.reparado,
        ).filter(
            and_(
                tabla_callesportics.nombrecall != '',
                tabla_callesportics.nombrecall != None,
                tabla_callesportics.reparado == 0,
                func.st_intersects(
                    tabla_callesportics.the_geom,
                    func.st_geomfromtext(
#                        'POLYGON((-61.007309 -32.650938,-60.132523 -32.650938,-60.132523 -33.379853,-61.007309 -33.379853,-61.007309 -32.650938))',
#                        'POLYGON((-66.080475 -26.160369, -64.528656 -26.160369, -64.528656 -27.880356, -66.080475 -27.880356, -66.080475 -26.160369))',
#                         'POLYGON((-59.134369 -34.184542, -57.739105 -34.184542, -57.739105 -35.054732, -59.134369 -35.054732, -59.134369 -34.184542))',
                         'POLYGON((-62.801514 -27.566721, -59.483643 -27.566721, -59.483643 -34.759666,-62.801514 -34.759666,-62.801514 -27.566721))',
                         4326
                    )
                )
            )
        ).order_by(tabla_callesportics.nombrecall)#.desc())#.limit(100000)
#        total = q_obj.count()
#        offset = 0
#        cantidad = 10000
##        while offset < total:
        calles = q_obj.all()
        for calle in calles:
            try:
                print calle.loc, '-', calle.nombrecall, 'reparado:', calle.reparado
            except:
                print 'Fallo imprimir la calle'
            q_obj2 = session.query(
                tabla_callesporticsoriginal.street,
                tabla_callesporticsoriginal.fromleft,
                tabla_callesporticsoriginal.toleft,
                tabla_callesporticsoriginal.fromright,
                tabla_callesporticsoriginal.toright,
            ).filter(
                and_(
                    func.st_distance(
                        func.st_line_interpolate_point(
                            func.st_geometryn(calle.the_geom, 1), 0.5
                        ),
                        func.st_line_interpolate_point(
                            func.st_geometryn(
                                tabla_callesporticsoriginal.the_geom, 1
                            ), 0.5
                        )
                    ) < 0.0001,
                )
            )
            calle_ori = q_obj2.first()
            sql = ""
            if calle_ori is not None:
                if (calle_ori.fromleft != calle.fromleft or \
                    calle_ori.toleft != calle.toleft or \
                    calle_ori.fromright != calle.fromright or \
                    calle_ori.toright != calle.toright) and \
                   ((calle_ori.fromleft != None and calle_ori.fromleft != 0) or \
                    (calle_ori.toleft != None or calle_ori.toleft != 0) or \
                    (calle_ori.fromright != None or calle_ori.fromright != 0) or \
                    (calle_ori.toright != None or calle_ori.toright != 0)):

                    try:
                        print calle.gid, calle.nombrecall, calle.fromleft, calle.toleft, calle.fromright, calle.toright
                        print calle_ori.street, calle_ori.fromleft, calle_ori.toleft, calle_ori.fromright, calle_ori.toright
                    except:
                        print 'Fallo imprimir la calle'
                    if calle_ori.fromleft != 0:
                        sql += " fromleft=" + str(calle_ori.fromleft) + ','
                    if calle_ori.toleft != 0:
                        sql += " toleft=" + str(calle_ori.toleft) + ','
                    if calle_ori.fromright != 0:
                        sql += " fromright=" + str(calle_ori.fromright) + ','
                    if calle_ori.toright != 0:
                        sql += " toright=" + str(calle_ori.toright) + ','

            sql = "UPDATE callesportics SET" + sql + " reparado = 1 WHERE gid=" + str(calle.gid)
            print sql
            conn = session.connection()
            r = conn.execute(sql)
            session.commit()
            print 'Actualizo', r.rowcount
#        offset += cantidad
#        print 'COMITEAMOS ################################################'

        session.close()

    def page_query(self, q):
        offset = 0
        while True:
            for elem in q.limit(100).offset(offset):
               r = True
               yield elem
            offset += 100
            if not r:
                break
            r = False

    def reparar_ciudades(self):
        reemplazo_ciudades = {
            'Capital': "San Miguel De Tucuman",
            'Leales': 'Villa De Leales',
            'Cruz Alta': "Banda Del Rio Sali",
        }

        tipos = {
            "Conector de autopistas": 8,
            "Ruta principal": 7,
            "Autopista": 8,
            "Callejon/Calle privada": 13,
            "Sendero": 1,
            "Colectora": 6,
            "Camino sin pavimentar": 1,
            "Rotonda": 12,
            "Calle residencial": 2,
            "Rampa de autopista": 10,
            "Otra ruta": 6,
            "Avenida/Ruta Arterial": 6,
        }

        buffer_ciudades = {}

        session = self.portics.binded_session()
        tabla_calles = self.portics.tabla('calles')
        tabla_calles_nombres = self.portics.tabla('calles_nombres')
        tabla_ciudades = self.portics.tabla('ciudades')
        tabla_localidades = self.portics.tabla('localidades')
        tabla_provincias = self.portics.tabla('provincias')
        tabla_callesportics = self.portics.tabla('callesportics')

        from string import maketrans
        intab =  u"?????????????????????????????????????????????????????"
        outtab = u"aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn"
        trans = dict((ord(a), b) for a, b in zip(intab, outtab))
        # Obtenemos las ciudades
        q_obj = session.query(
            tabla_callesportics.loc,
            tabla_callesportics.the_geom
        ).filter(
            and_(
                tabla_callesportics.loc != None,
                func.isdigit(tabla_callesportics.loc) == False
            )
        ).order_by('loc DESC')
        calles_portics = q_obj.all()
        contador = 0

        # Obtenemos las calles para poder obtener las ciudades
        for c_port in calles_portics:
            try:
                aux = int(c_port.loc)
            except:
                aux = ''
                pass

            if isinstance(aux, int):
                continue

            # guardamos el nombre real
            ciudadportics = c_port.loc
            # Si hay algun parentesis, lo remobemos del nombre
            ind_par = c_port.loc.find('(')
            if ind_par > 0:
                c_port.loc = c_port.loc[:ind_par]

            # Si no esta guardao en el buffer de ciudades, lo vamos a buscar
            if buffer_ciudades.get(ciudadportics) is None:
                # Buscamos en la tabla de ciudades
#                q_obj2 = session.query(tabla_ciudades.id, tabla_ciudades.nombre).filter(
#                    func.translate(func.lower(tabla_ciudades.nombre), '?????????????????????????????????????????????????????','aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn') == \
#                    c_port.loc.lower().translate(trans)
#                )
                q_obj2 = session.query(tabla_ciudades.id, tabla_ciudades.nombre).join(
                            (
                                tabla_provincias,
                                tabla_ciudades.id_provincia == tabla_provincias.id
                            )
#                        ).join((
#                            tabla_localidades,
#                            func.ST_Distance(tabla_localidades.the_geom, tabla_ciudades.geom).label('distancia') < 0.5
                        ).filter(
                            and_(
                                or_(
                                    func.ST_Contains(tabla_provincias.geom, c_port.the_geom),
                                    func.ST_Distance(tabla_provincias.geom, c_port.the_geom).label('distancia') < 0.5
                                ),
                                tabla_ciudades.id_tipo <= 9,
                                tabla_ciudades.id_tipo != 0,
                            )
                        )
                aux = c_port.loc.split(' ')
                terms = []
                terms.append(tabla_ciudades.nombre.op('~*')(c_port.loc))
                str_order = "CASE WHEN lower(ciudades.nombre) ~* '" + c_port.loc.lower() + " %' THEN 1 ELSE 0 END + "
                str_order += "CASE WHEN lower(ciudades.nombre) ~* '% " + c_port.loc.lower() + "' THEN 1 ELSE 0 END + "
                for a in aux:
                    a = a.strip()
                    if a != 'DE' and a != 'DEL' and a != 'LA' and a != 'LAS' and a != 'EL' and a != 'LOS' and a != '':
                        terms.append(tabla_ciudades.nombre.op('~*')(a))
                        str_order += "CASE WHEN lower(ciudades.nombre) ~* '% " + a.lower() + "' THEN 1 ELSE 0 END + "
                        str_order += "CASE WHEN lower(ciudades.nombre) ~* '" + a.lower() + " %' THEN 1 ELSE 0 END + "
                        str_order += "CASE WHEN lower(ciudades.nombre) ~* '% " + a.lower() + " %' THEN 1 ELSE 0 END + "

                str_order  = str_order[:-2] + ' DESC'
                q_obj2 = q_obj2.filter(or_(*terms)).order_by(str_order)
                ciudad = q_obj2.first()
                if ciudad is not None:
                    buffer_ciudades[ciudadportics] = [int(ciudad.id), ciudad.nombre.encode('latin1')]
                    sql = "UPDATE callesportics SET loc = '" + str(ciudad.id) + "' WHERE loc='" + ciudadportics.encode('latin1') + "'"

                    print ciudadportics, '=>', buffer_ciudades.get(ciudadportics)
                    print sql
                    conn = session.connection()
                    r = conn.execute(sql)
                    session.commit()
                    print 'Actualizo', r.rowcount
                    contador = 0
                else:
                    if contador < 700:
                        contador += 1
#                        print ciudadportics, 'Intento ', contador
                    else:
                        print 'Fallo', ciudadportics
                        buffer_ciudades[ciudadportics] = [None, None]
                        contador = 0
        session.close()

    def migrar_portics(self):
        tipos = {
            "Ferrocarril": -1,
            "Camino sin pavimentar": 1,
            "Calle residencial": 2,
            "Callejon/Calle privada": 3,
            "Bouluevard": 4,
            "Ruta": 6,
            "Ruta secundaria": 6,
            "0xf": 6,
            "Otra ruta": 6,
            "0xe": 6,
            "Avenida/Ruta Arterial": 6,
            "0x10": 6,
            "0x11": 6,
            "0xd": 7,
            "Colectora": 7,
            "Ruta principal": 7,
            "Autopista": 8,
            "Rampa de autopista": 10,
            "Conector de autopistas": 11,
            "Rotonda": 12,
        }

        buffer_ciudades = {}

        session = self.gis3.binded_session()
        tabla_calles_nombres = self.gis3.tabla('calles_nombres')
        tabla_callesportics = self.gis3.tabla('callesportics')
        # Obtenemos el ultimo id de calle nombre
        q_obj = session.query(tabla_calles_nombres)
        q_obj = q_obj.order_by(tabla_calles_nombres.id.desc())
        calle = q_obj.first()
        id_calle_nombre = calle.id + 1

        q_obj = session.query(tabla_callesportics).filter(
            tabla_callesportics.tipo != 'Ferrocarril'
        ).order_by('gid').limit(100)
        while True:
            calles = q_obj.all()
            if len(calles) == 0:
                break
            for c_port in calles:
                if buffer_ciudades.get(c_port.loc) is None:
                    buffer_ciudades[c_port.loc] = {}

                nombre = c_port.nombrecall


                # Si la ciudad no es un id, continuamos
                try:
                    c_port.loc = int(c_port.loc)

                except:
                    session.delete(c_port)
                    continue

                # Si no tiene nombre, seguios
                if nombre is None:
                    id_calle_nombre += 1
                    # Agregamos la calle_nombre
                    calle_nombre_bd = self.gis3.tabla('calles_nombres')()
                    calle_nombre_bd.id = id_calle_nombre
                    calle_nombre_bd.nombre = nombre
                    calle_nombre_bd.id_ciudad = c_port.loc
                    print session.add(calle_nombre_bd)
                    print 'Calle Nombre vacia',

                    # Agregamos la calle
                    calle_bd = self.gis3.tabla('calles')()
                    calle_bd.id_calle_nombre = id_calle_nombre
                    calle_bd.id_tipo = tipos[str(c_port.tipo)]
                    calle_bd.sentido = c_port.dirindicat
                    calle_bd.desde_der = c_port.fromright
                    calle_bd.desde_izq = c_port.fromleft
                    calle_bd.hasta_der = c_port.toright
                    calle_bd.hasta_izq = c_port.toleft
                    calle_bd.geom = c_port.the_geom

                    print c_port.loc, 'Calle'
                    print session.add(calle_bd)

                else:
                    nombre = nombre.title()
                    if buffer_ciudades[str(c_port.loc)].get(nombre) is None:
                        # Agregamos la calle_nombre
                        id_calle_nombre += 1
                        calle_nombre_bd = self.gis3.tabla('calles_nombres')()
                        calle_nombre_bd.id = id_calle_nombre
                        calle_nombre_bd.nombre = nombre
                        calle_nombre_bd.id_ciudad = c_port.loc

                        print c_port.loc, 'Calle nombre',nombre,
                        print session.add(calle_nombre_bd)

                        buffer_ciudades[str(c_port.loc)][nombre] = id_calle_nombre

                    # Agregamos la calle
                    calle_bd = self.gis3.tabla('calles')()
                    calle_bd.id_calle_nombre = buffer_ciudades[str(c_port.loc)][nombre]
                    calle_bd.id_tipo = tipos[str(c_port.tipo)]
                    calle_bd.sentido = c_port.dirindicat
                    calle_bd.desde_der = c_port.fromright
                    calle_bd.desde_izq = c_port.fromleft
                    calle_bd.hasta_der = c_port.toright
                    calle_bd.hasta_izq = c_port.toleft
                    calle_bd.geom = c_port.the_geom

                    print c_port.loc, 'Calle', buffer_ciudades[str(c_port.loc)][nombre]
                    print session.add(calle_bd)

                session.delete(c_port)
                try:
                    session.commit()
                except Exception,e:
                    session.rollback()
                    session.delete(c_port)
                    session.commit()
                    print str(e)

    def migrar_bis(self):

        session = self.gis3.binded_session()
        tabla_calles_nombres = self.gis3.tabla('calles_nombres')
        tabla_calles = self.gis3.tabla('calles')
        # Obtenemos el ultimo id de calle nombre
        q_obj = session.query(tabla_calles_nombres).filter(
            and_(
              tabla_calles_nombres.nombre != None,
              func.isdigit(tabla_calles_nombres.nombre)
            )
        ).order_by(tabla_calles_nombres.id.asc())
        calles_nombres = q_obj.all()
        for c_n in calles_nombres:
#            print 'BUSCAMOS ', c_n.nombre
            flag_bis = False
            flag_letra = False
            letra = None
            nuevo_nombre = c_n.nombre
            if c_n.nombre.find(' Bis') != -1 or c_n.nombre.find('(Bis)') != -1:
                flag_bis = True
                nuevo_nombre = nuevo_nombre.replace(' Bis', '').strip()
                nuevo_nombre = nuevo_nombre.replace('(Bis)', '').strip()
            if nuevo_nombre.find('Av.') != -1 or nuevo_nombre.find('Av ') != -1:
                nuevo_nombre = nuevo_nombre.replace('Av.', '').strip()
                nuevo_nombre = nuevo_nombre.replace('Av ', '').strip()
                nuevo_nombre = 'Av. ' + nuevo_nombre
            if nuevo_nombre.find('Calle: ') != -1 or nuevo_nombre.find('C ') != -1 or \
                nuevo_nombre.isdigit():
                nuevo_nombre = nuevo_nombre.replace('C ', '').strip()
                nuevo_nombre = nuevo_nombre.replace('Calle: ', '').strip()
                nuevo_nombre = 'Calle ' + nuevo_nombre
            if nuevo_nombre.find('Bv.') != -1 or nuevo_nombre.find('Bv ') != -1 or \
               nuevo_nombre.find('Boulevard ') != -1 or nuevo_nombre.find('Bulevard ') != -1 or \
               nuevo_nombre.find('Bulevar') != -1:
                nuevo_nombre = nuevo_nombre.replace('Bv.', '').strip()
                nuevo_nombre = nuevo_nombre.replace('Bv ', '').strip()
                nuevo_nombre = nuevo_nombre.replace('Boulevard', '').strip()
                nuevo_nombre = nuevo_nombre.replace('Bulevard', '').strip()
                nuevo_nombre = nuevo_nombre.replace('Bulevar', '').strip()
                nuevo_nombre = 'Bv. ' + nuevo_nombre
            if nuevo_nombre.endswith(' A') or nuevo_nombre.endswith(' B') or \
               nuevo_nombre.endswith(' C') or nuevo_nombre.endswith(' D') or \
               nuevo_nombre.endswith(' G') or nuevo_nombre.endswith(' H') or \
               nuevo_nombre.endswith(' I') or nuevo_nombre.endswith(' J') or \
               nuevo_nombre.endswith(' K') or nuevo_nombre.endswith(' L') or \
               nuevo_nombre.endswith(' E') or nuevo_nombre.endswith(' F'):
                flag_letra = True
                letra = nuevo_nombre[-1:]
            elif nuevo_nombre.endswith(' (A)') or nuevo_nombre.endswith(' (B)') or \
               nuevo_nombre.endswith(' (C)') or nuevo_nombre.endswith(' (D)') or \
               nuevo_nombre.endswith(' (G)') or nuevo_nombre.endswith(' (H)') or \
               nuevo_nombre.endswith(' (I)') or nuevo_nombre.endswith(' (J)') or \
               nuevo_nombre.endswith(' (K)') or nuevo_nombre.endswith(' (L)') or \
               nuevo_nombre.endswith(' (E)') or nuevo_nombre.endswith(' (F)'):
                flag_letra = True
                letra = nuevo_nombre[-2:-1]
                nuevo_nombre = nuevo_nombre[:-3]
            aux = ''
            for parte in nuevo_nombre.split(' '):
                if parte != '' and len(parte) > 1:
                    aux += parte + ' '
            nuevo_nombre = aux.strip()
            if nuevo_nombre == '' or nuevo_nombre == 'Calle':
                continue
            q_obj2 = session.query(tabla_calles_nombres).filter(
                and_(
                    tabla_calles_nombres.nombre == nuevo_nombre, #ve.like(nuevo_nombre  +'%'),
                    tabla_calles_nombres.nombre != c_n.nombre,
                    tabla_calles_nombres.id_ciudad == c_n.id_ciudad,
                )
            ).order_by(tabla_calles_nombres.id.asc())
            nueva_calle_nombre = q_obj2.first()
            if nueva_calle_nombre is None:
                print 'Para ##### ', c_n.nombre, 'No se encontro nada de ', nuevo_nombre
                continue
            print 'BUSCAMOS ', c_n.nombre, 'como', nuevo_nombre
            print '#### Encontrado',nueva_calle_nombre.nombre

            q_obj3 =  session.query(tabla_calles).filter(
                tabla_calles.id_calle_nombre == c_n.id
            )
            calles = q_obj3.all()
            for c in calles:
                sql = "UPDATE calles SET id_calle_nombre = " + str(nueva_calle_nombre.id)
                if flag_bis:
                    sql += ', desde_der=' + str(abs(c.desde_der) * -1)
                    sql += ', hasta_der=' + str(abs(c.hasta_der) * -1)
                    sql += ', desde_izq=' + str(abs(c.desde_izq) * -1)
                    sql += ', hasta_izq=' + str(abs(c.hasta_izq) * -1)
                if flag_letra:
                    sql += ",letra= '"+ letra + "'"
                sql += " WHERE gid=" + str(c.gid) + ""
                print sql
#                conn = session.connection()
#                r = conn.execute(sql)
#                print r.rowcount
#
#            sql = "DELETE FROM calles_nombres WHERE id = " + str(c_n.id)
#            print sql
#            conn = session.connection()
#            r = conn.execute(sql)
#            print r.rowcount
#        session.commit()
        session.close()

    def migrar_calles_perpendiculares(self):

        session = self.gis3.binded_session()
        sql = '''
SELECT
    DISTINCT foo.gid,
        foo.id_calle_nombre AS id_viejo,
        calles_nomb.nombre as calle_vieja,
        tree.id_calle_nombre AS id_nuevo,
        calles_nombres.nombre AS calle_nueva
FROM
    calles AS foo,
    (SELECT geom, gid, id_calle_nombre FROM calles) AS bar,
    (SELECT geom, gid, id_calle_nombre FROM calles) AS tree,
    (SELECT id, id_ciudad, nombre FROM calles_nombres) AS calles_nombres,
    (SELECT id, id_ciudad, nombre FROM calles_nombres) AS calles_nomb
WHERE
    bar.gid != foo.gid AND
    bar.id_calle_nombre = foo.id_calle_nombre AND
    calles_nombres.id_ciudad = 324 AND
    calles_nomb.id_ciudad = 324 AND
    tree.id_calle_nombre != foo.id_calle_nombre AND
    tree.id_calle_nombre = calles_nombres.id AND
    foo.id_calle_nombre = calles_nomb.id AND
    ST_Intersects(foo.geom, bar.geom) AND
    ST_Intersects(foo.geom, tree.geom) AND
    abs(round(degrees(
        ST_Azimuth(
            ST_Line_Interpolate_Point(LineMerge(foo.geom), 0),
            ST_Line_Interpolate_Point(LineMerge(foo.geom), 1)
        )
        -
        ST_Azimuth(
            ST_Line_Interpolate_Point(LineMerge(tree.geom), 0),
            ST_Line_Interpolate_Point(LineMerge(tree.geom), 1)
        )
    )::decimal %% 180.0,2)) < 5 AND
    abs(round(degrees(
        ST_Azimuth(
            ST_Line_Interpolate_Point(LineMerge(foo.geom), 0),
            ST_Line_Interpolate_Point(LineMerge(foo.geom), 1)
        )
        -
        ST_Azimuth(
            ST_Line_Interpolate_Point(LineMerge(bar.geom), 0),
            ST_Line_Interpolate_Point(LineMerge(bar.geom), 1)
        )
    )::decimal %% 180.0,2)) > 5 AND (
        abs(round(degrees(
            ST_Azimuth(
                ST_Line_Interpolate_Point(LineMerge(foo.geom), 0),
                ST_Line_Interpolate_Point(LineMerge(foo.geom), 1)
            )
            -
            ST_Azimuth(
                ST_Line_Interpolate_Point(LineMerge(bar.geom), 0),
                ST_Line_Interpolate_Point(LineMerge(bar.geom), 1)
            )
        )::decimal %% 180.0,2)) < 175 OR
        abs(round(degrees(
                ST_Azimuth(
                    ST_Line_Interpolate_Point(LineMerge(foo.geom), 0),
                    ST_Line_Interpolate_Point(LineMerge(foo.geom), 1)
                )
                -
                ST_Azimuth(
                    ST_Line_Interpolate_Point(LineMerge(bar.geom), 0 ),
                    ST_Line_Interpolate_Point(LineMerge(bar.geom), 1 )
                )
        )::decimal %% 180.0,2)) > 185
    )
'''
        conn = session.connection()
        rta = conn.execute(sql)
        row = rta.fetchall()
        for r in row:
            print r.id_viejo, r.calle_vieja, r.id_nuevo, r.calle_nueva
            sql = "UPDATE calles SET id_calle_nombre = " + str(r.id_nuevo)
            sql += " WHERE gid=" + str(r.gid) + " AND id_calle_nombre=" + str(r.id_viejo)
#            print sql
            conn = session.connection()
            r = conn.execute(sql)
            print r.rowcount
        session.commit()
        session.close()

    def contar(self):
        session = self.gis3.binded_session()
        tabla_calles_nombres = self.gis3.tabla('calles_nombres')
        # Obtenemos el ultimo id de calle nombre
        q_obj = session.query(tabla_calles_nombres).filter(
            and_(
              tabla_calles_nombres.nombre != None,
              tabla_calles_nombres.nombre != ''
            )
        ).order_by(tabla_calles_nombres.nombre.asc())
        calles_nombres = q_obj.all()
        buffer_nombres = []
        buffer_chars = 0
        for calle in calles_nombres:
            aux = calle.nombre.split(' ')
            for a in aux:
                a = a.strip().lower()
                if a != '':
                    if a not in buffer_nombres:
                        buffer_nombres.append(a)
                        buffer_chars += len(a)
        print buffer_nombres
        print 'Total palabras:', len(buffer_nombres)
        print 'Total caracteres:', buffer_chars

if __name__ == '__main__':
    m = Mapas()
    m.contar()
