# -*- coding: utf-8 -*-
import threading
from time import time


class TileCache(object):

    class __impl(object):

        def __init__(self):
            self.tiles_en_proceso = {}

        def tile_en_proceso(self, x, y, z):
            ''' Funcion que devuelve True o False, segun si un tile esta
            en proceso o no
            '''
            tile = str(x) + '-' + str(y) + '-' + str(z)
            if tile in self.tiles_en_proceso.keys():
                delta = time() - self.tiles_en_proceso[tile]
                if delta > 1:
                    # Borramos el cache
                    del self.tiles_en_proceso[tile]
                    # Decimos que por lo menos nosotros no podemos asegurar
                    # que esta en proceso
                    return False
                # Si no expiro, es por que no arranco todavia
                return True
            # Sino, no esta
            return False

        def agregar_tile_en_proceso(self, x, y, z):
            tile = str(x) + '-' + str(y) + '-' + str(z)
            self.tiles_en_proceso[tile] = time()

        def remover_tile_en_proceso(self, x, y, z):
            tile = str(x) + '-' + str(y) + '-' + str(z)
            if tile in self.tiles_en_proceso.keys():
                del self.tiles_en_proceso[tile]

   ## Atributos privados.
    __instance = None
    __lock = threading.Lock()

    ## Inicializa la unica instancia del nucleo.
    def __init__(self):
        TileCache.__lock.acquire(True)
        try:
            if TileCache.__instance is None:
                TileCache.__instance = TileCache.__impl()
        finally:
            TileCache.__lock.release()

    ## Delegate access to implementation.
    def __getattr__(self, attr):
        return getattr(self.__instance, attr)

    ## Delegate access to implementation.
    def __delattr__(self, attr):
        return delattr(self.__instance, attr)

    ## Delegate access to implementation.
    def __setattr__(self, attr, value):
        return setattr(self.__instance, attr, value)
