# -*- coding: utf-8 *-*

import os
import sys

databases = []

try:
    import configobj
    etc = '/var/lib/at/etc/dbs'
    if not os.path.isdir(etc):
        raise Exception

    # Vamos a guardar todos los datos
    dbs = [db for db in os.listdir(etc) if db.endswith('.db')]
    if len(dbs) is 0:
        print(':: no hay archivos de configuracion de dbs.')

    # Recorremos los archivos
    for db in dbs:
        archivo = os.path.join(etc, db)
        db = configobj.ConfigObj(archivo)
        # Agregamos los datos
        databases.append(db)

except:
    try:
        print(':: modo viejo de at.orm')
        print(':: revisar si tenemos configobj')

        ## MODO VIEJO ##############3
        import cPickle
        etc = '/var/lib/at/etc'

        # Si fallamos, salimos
        if not os.path.isdir(etc):
            print(
            'Debes crear la carpeta %s y agregar algun archivo de conexion' %
                etc
            )
            sys.exit(1)
        # Vamos a guardar todos los datos
        databases = []
        dbs = [db for db in os.listdir(etc) if db.endswith('.db')]
        if len(dbs) is 0:
            print(
            'Por favor, agregar algunos archivos de configuracion en %s' % etc
            )
            sys.exit(1)
        # Recorremos los archivos
        for db in dbs:
            archivo = os.path.join(etc, db)
            with open(archivo, 'r') as fp:
                # Procesamos con cPickle y deserializamos
                db = cPickle.load(fp)
            # Agregamos los datos
            if not db in databases:
                databases.append(db)
    except:
        print(':: no hay cPickle')
