# -*- encoding: utf-8 -*-

import os
import logging
import logging.handlers

path = '/var/lib/at/logs/at.orm'
if not os.path.isdir(path):
    os.makedirs(path)

sa_log = {
    'at.orm': False,
    'sqlalchemy.engine': True,
    'sqlalchemy.pool': True,
    'sqlalchemy.orm.mapper': True,
    'sqlalchemy.orm.unitofwork': True,
    'sqlalchemy.orm.sync': True,
}


def init():
    for kw in sa_log.keys():
        if sa_log[kw] is True:
            x = logging.getLogger(kw)
            x.setLevel(logging.ERROR)
            log_name = kw + '.error'
            log_file = os.path.join(path, log_name)
            h1 = logging.handlers.RotatingFileHandler(
                log_file,
                maxBytes=1000000,
                backupCount=5
            )
            f = logging.Formatter(
                "%(levelname)s %(asctime)s func: %(funcName)s line: %(lineno)\
    d msg: %(message)s"
            )
            h1.setFormatter(f)
            h1.setLevel(logging.DEBUG)
            x.addHandler(h1)
