import unittest

from at.orm.abm import ABM


class TestBugTablesSameName(unittest.TestCase):
    ''' Error al llamar la tabla zonas de la base de datos gis, 
    me tomo la tabla zonas de cp2000. 
    
    Reportado en Redmine:
    http://code.airtrack.ovz:8080/redmine/issues/113
    '''

    def setUp(self):        
        pass
    
    def tearDown(self):
        pass
    
    def test_distintas_db_mismo_nombre_tabla(self):
        ''' El bug consiste en que al utilizar varias DB's, si el nombre de 
        una tabla en DBn es == al nombre de otra tabla en DBk, se devuelve
        la tabla de DBn ...
        ''' 
        
        db1 = {
             'user': 'root',
             'dbname': 'cp2000',
             'name': 'cp',
             'passwd': 'changeme',
             'host': '192.168.0.51',
             'engine': 'mysql',
             'port': '3306'
             }

        db2 = {
             'user': 'root',
             'dbname': 'gis',
             'name': 'cp',
             'passwd': 'changeme',
             'host': '192.168.0.51',
             'engine': 'mysql',
             'port': '3306'
             }
        
        db1 = ABM(db1)
        db2 = ABM(db2)
        
        self.assertTrue(id(db1.db) != id(db2.db))
        
        ''' Los ids de los objetos deben ser distintos '''
        self.assertTrue(id(db1.tabla('zonas')) != id(db2.tabla('zonas')))


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestBugTablesSameName))
    return suite
