import unittest

from at.orm.mapper import ATMapper

from sqlalchemy.engine.base import Engine
from sqlalchemy.orm.session import Session
from sqlalchemy import MetaData


ATMapper.test = True
login = {
         'user': 'root',
         'dbname': 'cp2000',
         'name': 'cp',
         'passwd': 'changeme',
         'host': '192.168.0.51',
          'engine': 'mysql',
         'port': '3306'
         }


class TestATMapper(unittest.TestCase):

    def test_mapper_engine(self):
        # fakelogin = {'foo': 'bar'}
        # self.assertRaises(Exception, ATMapper, fakelogin)
        fakelogin = 'un string'
        self.assertRaises(Exception, ATMapper, fakelogin)
        fakelogin = True
        self.assertRaises(Exception, ATMapper, fakelogin)
        mapper = ATMapper(login)
        mapper.connect()
        self.assertTrue(hasattr(mapper, 'engine'))
        self.assertTrue(isinstance(mapper.engine, Engine))

    def test_bind_engine(self):
        mapper = ATMapper(login)
        self.assertTrue(hasattr(mapper, 'binded_session'))
        self.assertTrue(isinstance(mapper.binded_session(), Session))

    def test_mapper(self):
        mapper = ATMapper(login)
        mapped = mapper.db
        self.assertTrue(isinstance(mapped, dict))
        # Bindeamos una session
        mapper.connect()

        ''' las claves del diccionario son los nombres de las tablas, compruebo
        si las claves del diccionario son todos los nombres  '''
        mapped_table_names = mapped.keys()
        for name in mapper.engine.table_names():
            self.assertTrue(name in mapped_table_names)

        ''' tendriamos que tener guardada la db en el objeto instanciado '''
        self.assertTrue(hasattr(mapper, 'db'))

        ''' mapper.db es un diccionario igual al que obtenemos al instanciar el objeto
        '''
        self.assertTrue(isinstance(mapper.db, dict))
        for kw in mapper.db.keys():
            self.assertTrue(kw in mapped_table_names)

    def test_atributos_instancia_objeto_atmapper(self):

        mapper = ATMapper(login)
        mapper.connect()
        ''' tenemos la DB en mapper '''
        self.assertTrue(hasattr(mapper, 'db'))

        ''' tenemos metadata '''
        self.assertTrue(hasattr(mapper, 'meta'))
        self.assertTrue(isinstance(getattr(mapper, 'meta'), MetaData))

        ''' tenemos para crear sesiones '''
        self.assertTrue(hasattr(mapper, 'binded_session'))
        session = mapper.binded_session()
        self.assertTrue(isinstance(session, Session))
        self.assertTrue(hasattr(session, 'query'))
        session.close()

        ''' tenemos engine '''
        self.assertTrue(hasattr(mapper, 'engine'))
        self.assertTrue(isinstance(getattr(mapper, 'engine'), Engine))


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestATMapper))
    return suite
