import unittest

from at.orm.decorators import DBSwitch


class TestDBSwitch(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_db_switcher(self):
        # creo una clase
        class mifoo(object):
            pass

        # la clase no tiene el atributo cp, ni gis
        self.assertFalse(hasattr(mifoo, 'cp'))
        self.assertFalse(hasattr(mifoo, 'gis'))

        # decoro mi clase foo, para que tenga coneccion contra la base de datos
        # cp ...
        @DBSwitch('cp')
        class mifoo(object):
            pass

        self.assertTrue(hasattr(mifoo, 'cp'))

        # mi nuevo atributo en el objeto mifoo tiene engine, db meta y
        # binded_session
        self.assertTrue(hasattr(getattr(mifoo, 'cp'), 'engine'))
        self.assertTrue(hasattr(getattr(mifoo, 'cp'), 'db'))
        self.assertTrue(hasattr(getattr(mifoo, 'cp'), 'meta'))
        self.assertTrue(hasattr(getattr(mifoo, 'cp'), 'binded_session'))

        # la base de datos es la que tengo configurada X)
        # mama me ensenio a no hardcodear las cosas... MAL XIP, MAL!
        # self.assertTrue('cp2000' == mifoo.cp.engine.url.database)
        from at.orm.tests.databases import callprocesor_dict
        mifoo.cp.connect()
        self.assertTrue(callprocesor_dict != None)
        self.assertTrue(
            callprocesor_dict['dbname'] == mifoo.cp.engine.url.database)

        # Ahora agrego gis como atributo de mi objeto mibar
        @DBSwitch('gis2')
        class mibar(object):
            pass

        mibar.gis2.connect()
        self.assertTrue(hasattr(mibar, 'gis2'))
        self.assertTrue(hasattr(getattr(mibar, 'gis2'), 'engine'))
        self.assertTrue(hasattr(getattr(mibar, 'gis2'), 'db'))
        self.assertTrue(hasattr(getattr(mibar, 'gis2'), 'meta'))
        self.assertTrue(hasattr(getattr(mibar, 'gis2'), 'binded_session'))


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestDBSwitch))
    return suite
