# -*- coding: utf-8 -*-

import unittest

from at.orm import _
from at.orm.utiles import obtener_bd
from at.orm.utiles import cambiar_bd
from at.orm.utiles import obtener_datos_conexion_bd
from at.orm.utiles import recargar_databases


class TestUtiles(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_obtener_bd(self):
        # Caso correcto
        nombre_bd = 'cp'
        rta = obtener_bd(nombre_bd)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(isinstance(rta['Respuesta'], object))

        # Le paso un nombre de una base de datos que no existe
        nombre_bd = 'nombre_de_la_bd_no_existe'
        rta = obtener_bd(nombre_bd)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'No se encontró la configuracion para conectarse a la base de datos nombre_de_la_bd_no_existe')
        )

    def test_cambiar_bd(self):
        ## Comento este test porque no se si voy a tener at.pidetutaxi
        pass
        # from at.pidetutaxi.utiles import Utiles
        # utiles = Utiles()
        #
        # clase = utiles
        # nombre_bd_actual = 'pidetutaxi'
        # nombre_bd_nueva = 'pideturemis'
        # rta = cambiar_bd(clase, nombre_bd_actual, nombre_bd_nueva)
        # print(rta)
        #
        # print('utiles.pidetutaxi.engine')
        # print(utiles.pidetutaxi.engine)
        #
        # print('utiles.seguime.pidetutaxi.engine')
        # print(utiles.seguime.pidetutaxi.engine)
        #
        # print('utiles.seguime.comandos_utiles.pidetutaxi.engine')
        # print(utiles.seguime.comandos_utiles.pidetutaxi.engine)

    def test_obtener_datos_conexion_bd(self):
        # Le paso la BD 'cp2000' para obtener sus datos de coenxión
        nombre_bd = 'cp2000'
        rta = obtener_datos_conexion_bd(nombre_bd)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta']['engine'] == 'mysql')
        self.assertTrue(rta['Respuesta']['name'] == 'cp')
        self.assertTrue(rta['Respuesta']['passwd'] == 'changeme')
        self.assertTrue(rta['Respuesta']['port'] == '3306')
        self.assertTrue(rta['Respuesta']['host'] == '192.168.0.51')
        self.assertTrue(rta['Respuesta']['user'] == 'root')
        self.assertTrue(rta['Respuesta']['dbname'] == 'cp2000')

        # Le paso un nombre de base de datos que no existe
        nombre_bd = 'no_existe'
        rta = obtener_datos_conexion_bd(nombre_bd)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'No se pudieron obtener los datos de conexión para la base de datos no_existe')
        )

    def test_recargar_databases(self):
        # Caso correcto
        rta = recargar_databases()
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(
            rta['Respuesta'] == _(u'Se volvieron a cargar las bases de datos')
        )


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestUtiles))
    return suite
