# -*- coding: utf-8 *-*
import os
import tempfile
from ffmpegwrapper import FFmpeg
from ffmpegwrapper import Input
from ffmpegwrapper import Output
from ffmpegwrapper import AudioCodec


AMRNB_CODEC = 'libopencore_amrnb'
WAV_CODEC = 'pcm_u8'
GSM_CODEC = 'libgsm_ms'


def wav2amr(filename):
    # Generamos archivo temporal
    ruta_archivo = tempfile.mkstemp()[1]

    if os.path.exists(ruta_archivo):
        os.remove(ruta_archivo)

    entrada = Input(filename)
    codec = AudioCodec(AMRNB_CODEC)
    codec.bitrate('7.95k')
    codec.frequence('8000')
    codec.channels('1')
    output = Output(ruta_archivo, codec)
    ffmpeg = FFmpeg('ffmpeg', entrada, output)
    resultado = ffmpeg.run()

    lineas = resultado.readlines()
    for linea in lineas:
        pass

    return ruta_archivo


def amr2wav(filename):
    # Generamos archivo temporal
    ruta_archivo = tempfile.mkstemp()[1]

    if os.path.exists(ruta_archivo):
        os.remove(ruta_archivo)

    entrada = Input(filename)
    codec = AudioCodec(WAV_CODEC)
    codec.bitrate('88k')
    codec.frequence('11025')
    codec.channels('1')

    output = Output(ruta_archivo, codec)
    ffmpeg = FFmpeg('ffmpeg', entrada, output)
    resultado = ffmpeg.run()

    lineas = resultado.readlines()
    for linea in lineas:
        pass

    return ruta_archivo


def wav2gsm(filename):
    # Generamos archivo temporal
    ruta_archivo = tempfile.mkstemp()[1]

    if os.path.exists(ruta_archivo):
        os.remove(ruta_archivo)

    entrada = Input(filename)
    codec = AudioCodec(GSM_CODEC)
    codec.bitrate('13k')
    codec.frequence('8000')
    codec.channels('1')
    output = Output(ruta_archivo, codec)
    ffmpeg = FFmpeg('ffmpeg', entrada, output)
    resultado = ffmpeg.run()

    lineas = resultado.readlines()
    for linea in lineas:
        pass

    return ruta_archivo


def gsm2wav(filename):
    # Generamos archivo temporal
    ruta_archivo = '%s.wav' % filename

    if os.path.exists(ruta_archivo):
        os.remove(ruta_archivo)

    entrada = Input(filename)
    codec = AudioCodec(WAV_CODEC)
    codec.bitrate('88k')
    codec.frequence('11025')
    codec.channels('1')

    output = Output(ruta_archivo, codec)
    output = output.overwrite()
    ffmpeg = FFmpeg('ffmpeg', entrada, output)
    print(ffmpeg)
    resultado = ffmpeg.run()

    lineas = resultado.readlines()
    for linea in lineas:
        print(lineas)
        pass

    return ruta_archivo