# -*- coding: utf-8 -*-

from time import sleep
from boto.ec2.connection import EC2Connection

from at.utiles import _
from at.utiles import validar
from at.utiles.conversiones import respuesta

AWS_ACCESS_KEY_ID = 'AKIAIWIEGKJTKVCJOUAA'
AWS_SECRET_ACCESS_KEY = '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'


class Aws(object):

    def obtener_coneccion_ec2(self):
        '''
        Esta función obtiene la conección al servicio de EC2.
        :return: DIC
        '''

        try:
            # Me conecto a AWS.
            conexion = EC2Connection(AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY)
        except Exception as error:
            return respuesta(
                False, _(u'Error al conectarse al servicio EC2.'), error
            )

        # Retorno la conexion
        return respuesta(
            True,
            _(u'Se logró conectar al servicio EC2 correctamente'),
            conexion
        )

    def verificar_estado_intancia_ec2(self, conexion, id_instancia):
        '''
        Funcion sirve para Verificar el estado de una instancia de EC2.
        :param estado:
        :param respuesta:
        :return:
        '''

        # Valido el id de la instancia.
        v_id_instancia = validar.string(id_instancia)
        if v_id_instancia['Estado'] is not True:
            return v_id_instancia

        # Guardo el id en una lista.
        instance_ids = [id_instancia]

        try:
            # Trato de obtener el estado de la instancia
            status = conexion.get_all_instance_status(instance_ids=instance_ids)

        except Exception as error:
            return respuesta(
                False,
                _(u'La instancia no existe.'),
                error
            )

        # Represento el estado
        estado = len(status)

        # Verifico si obtengo algún resultado.
        if len(status) == 0:
            return respuesta(
                True,
                _(u'La instancia se encuentra apagada.'),
                estado
            )

        # Retorno  el estado.
        return respuesta(
            True,
            _(u'La instancia se encuentra encendida'),
            estado
        )

    def encender_instancia_ec2(self, id_instancia, ip_publica=None):
        '''
        Funcion sirve para encender una instancia EC2 de AWS
        :param estado:
        :param respuesta:
        :return:
        '''

        # Valido la ip pública si no es None.
        if ip_publica is not None:
            # Valido la ip_publica.
            v_ip_publica = validar.string(ip_publica)
            if v_ip_publica['Estado'] is not True:
                return v_ip_publica

        # Trato de obtenre la conexión.
        rta_conexion = self.obtener_coneccion_ec2()
        if rta_conexion['Estado'] is not True:
            return rta_conexion

        # Obtengo la conexión al servicio de EC2.
        conexion = rta_conexion['Dato']

        # Verifico el estado de la instancia.
        rta_verificar_estado = self.verificar_estado_intancia_ec2(
            conexion, id_instancia
        )
        if rta_verificar_estado['Estado'] is not True:
            return rta_verificar_estado

        # Obtengo el estado.
        estado = rta_verificar_estado['Dato']

        # Si el estado no es 0 significa que está prendido.
        if estado > 0:
            return respuesta(False, rta_verificar_estado['Respuesta'])

        # Guardo el id en una lista.
        instance_ids = [id_instancia]

        # Trato de encender la instancia.
        encender = conexion.start_instances(instance_ids=instance_ids)

        # Verifico si obtengo algún resultado.
        if len(encender) > 0:

            if ip_publica is not None:
                # IMPORTANTE: Duermo 120 segundos para epserar que se encienda
                # la instancia "esclavo", no importa que se bloquee el hilo
                # del servicio principal porque es lo único que hace esta
                # tarea de mapadmin
                # De otra forma tendíamos que tener el evento para saber si
                # ya se inició la instancia para luego asociarle la IP
                sleep(120)

                conexion.associate_address(
                    instance_id=id_instancia, public_ip=ip_publica
                )

            return respuesta(
                True,
                _(u'Se envió la petición para encender la instancia correctamente'),
                encender
            )

        return respuesta(False, _(u'Error al encender la instancia.'))

    def apagar_instancia_ec2(self, id_instancia, forzar=None):
        '''
        Funcion sirve para apagar una instancia EC2 de AWS
        :param estado:
        :param respuesta:
        :return:
        '''

        # Valido forzar.
        if forzar is not None:
            v_forzar = validar.booleano(forzar)
            if v_forzar['Estado'] is not True:
                return v_forzar

        # Trato de obtenre la conexión.
        rta_conexion = self.obtener_coneccion_ec2()
        if rta_conexion['Estado'] is not True:
            return rta_conexion

        # Obtengo la conexión al servicio de EC2.
        conexion = rta_conexion['Dato']

        # Verifico el estado de la instancia.
        rta_verificar_estado = self.verificar_estado_intancia_ec2(
            conexion, id_instancia
        )
        if rta_verificar_estado['Estado'] is not True:
            return rta_verificar_estado

        # Obtengo el estado.
        estado = rta_verificar_estado['Dato']

        # Si el estado es 0 significa que está apagada.
        if estado == 0:
            return respuesta(False, rta_verificar_estado['Respuesta'])

        # Guardo el id en una lista.
        instance_ids = [id_instancia]

        # Trato de apagar la instancia.
        apagar = conexion.stop_instances(
            instance_ids=instance_ids, force=forzar
        )

        # Verifico si obtengo algún resultado.
        if len(apagar) > 0:
            return respuesta(
                True,
                _(u'Se envió la petición para apagar la instancia correctamente'),
                apagar
            )

        return respuesta(False, _(u'Error al apagar la instancia.'))
