# -*- coding: utf-8 -*-

import sys
import binascii


def ascci_to_binary(ascii):
    '''
        Esta función se encarga de convertir un ascii a binario.

        Argumento:
            ascii (str) # ascii

        Retorna:
            (str) # binario de 8 bit
    '''

    try:
        ascii = ascii.encode('ascii', errors='replace')
    except:
        pass

    binario = bin(int(binascii.hexlify(ascii), 16))
    binario = binario[2:]

    cant_bit = len(binario)

    if(cant_bit < 8):
        ceros_a_agregar = 8 - cant_bit

        while(ceros_a_agregar != 0):
            binario = "0" + binario
            ceros_a_agregar -= 1

    return binario


def descomprimir_asciis(asciis):
    '''
        Esta función recibe una cadena de asciis y se encarga de pasarla a un
        número entero.

        Argumento:
            asciis (str)

        Funciones:
            ascci_to_binary

        Retorna:
            (int)
    '''

    asciis = asciis.replace("-@", "#")

    if asciis == '':
        return ''

    binario = ''

    for ascii in asciis:
        binario = '%s%s' % (binario, ascci_to_binary(ascii))

    entero = int(binario, 2)

    return entero


def int_to_binary(entero):
    '''
        Esta función debe pasar un entero a número binario.

        Argumento:
            entero (int)

        Retorna:
            (str)
    '''

    binario = bin(entero)
    binario = binario[2:]

    cant_num = len(binario)

    cant_byte = cant_num / 8

    cant_byte = int(cant_byte)

    resto = cant_num % 8

    if resto != 0:
        resto = 1
    else:
        resto = 0

    ceros_a_agregar = 8 * (cant_byte + resto) - cant_num

    while ceros_a_agregar != 0:
        binario = "0" + binario
        ceros_a_agregar -= 1

    return binario


def comprimir_entero(entero):
    '''
        Esta función se encarga de comprimir un número entero pasandolo a una
        cadena de asciis.

        Argumento:
            entero (int)

        Funciones:
            int_to_binary

        Retorna:
            (str) // cadena de asciis
    '''

    if sys.version_info.major >= 3:
        return '* No funciona comprimir_entero en Python 3'

    binario = int_to_binary(entero)

    byte_separados = [binario[i:i + 8] for i in range(0, len(binario), 8)]

    asciis = ''

    for byte in byte_separados:
        entero = int(byte, 2)
        entero = chr(entero)
        asciis = '%s%s' % (asciis, entero)

    asciis = asciis.replace("#", "-@")

    return asciis
