# -*- coding: utf-8 -*-
import geocoder
import json
import re
import requests

from at.utiles.conversiones import unicode_to_str

lista = ['movil', 'mobil', 'móvil',
         'remis', 'remi', 'remiss',
         'remisse', 'vehiculo', 'vehículo',
         'servicio', 'tasi', 'taxi',
         'coche', 'auto', 'unidades',
         'unidad']


def obtener_ultimo_numero(string):
    """
    obtener_direccion el ultimo numero del string y lo devuelve
    :param string: string o list :"hola 10 que tal 20 perro" o ["hola","10","que","tal","20","perro"]
    :return: str (20)
    """
    if not string: return -1

    if isinstance(string, str):
        array = [int(s) for s in string.split() if s.isdigit()]
    else:
        array = [int(s) for s in string if s.isdigit()]

    if not array: return -2

    lastdigit = array.pop()  # borra el primero de los encontrados
    # print(lastdigit)
    return str(lastdigit)


def obtener_indice_elemento(string, elemento):
    """

    :param string: "hola que tal",o sino ["hola","que","tal"]
    :param elemento: "que"
    :return: 5, o sino 2

    """
    if not string: return -1
    if not elemento: return -1

    try:
        a = string.index(elemento)
        # print(a)
        return a
    except:
        return -2


def dividir_string(string):
    """
    :param string: "hola que tal"
    :return list: ["hola","que","tal"]
    """

    if not string: return -1
    a = string.split(' ')
    # print(a)
    return a


def obtener_substring(string, desde, hasta):
    if hasta == [] or hasta is None or hasta == '': return -1
    if desde == [] or desde is None or desde == '': return -1
    if not string: return -1

    if desde == '*inicio': desde = 0
    if hasta == '*fin': hasta = len(string)

    print("antes:", string)

    # le paso hasta + 1 porque quiero que lo incluya
    _substring = string[desde: hasta + 1]
    print("despues:", _substring)
    return _substring


def caso_uso_desuso(string, palabra_inicial):
    if not string: return -1

    string = reemplazar_string(string, '.,;')
    print("string_limpio:", string)

    string = reducir_espacios_string(string)
    print("reducido espacios:", string)

    string = dividir_string(string)
    print("dividir_string:", string)

    ultimo_numero = obtener_ultimo_numero(string)
    print("ultimo numero:", ultimo_numero)

    indice_ultimo_numero = obtener_indice_elemento(string, ultimo_numero)
    print("indice_ultimo_numero:", indice_ultimo_numero)

    substring = obtener_substring(string, palabra_inicial, indice_ultimo_numero)
    print("extraccion:", substring)

    concatenado = array_to_string(substring)
    print("concatenado:", concatenado)

    return concatenado


def array_to_string(string):
    return " ".join(string)


def reemplazar_string(string, elementos_a_limpiar):
    if not string: return -1
    if not elementos_a_limpiar: return -1

    for i in elementos_a_limpiar:
        string = string.replace(i, " ")

    # print(string)
    return string


def reducir_espacios_string(string):
    if not string: return -1

    a = array_to_string(string.split())
    print(a)
    return a


def reg(list, string):
    expresion_regular_creada = re.compile("|".join(list))

    print(expresion_regular_creada)
    salida = expresion_regular_creada.search(string)
    if not salida: return -2
    print('encontro', salida)
    print('indice:', salida.span(0)[0])

    return salida.span(0)[0]


def busqueda(lista, string):
    """
    obtener_direccion si alguna palabra de la lista esta en el string
    :param list: lista de palabras
    :param string: string
    :return: indice,palabra ejemplo 0,"perro"
    """

    if not lista: return [-1, -1]
    if not string: return [-1, -1]

    print("lista:", lista)
    print("string;", string)
    if isinstance(string, str):
        string = dividir_string(string)

    for indice, valor in enumerate(string):
        if valor in lista:
            return [indice, valor]
    print("hosidjoa")
    return [-2, -2]


def obtener_direccion(lista, string):
    """
    obtener_direccion si
    :param lista:
    :param string:
    :return:
    """
    if not lista: return -1
    if not string: return -1

    string = reemplazar_string(string, '.,;?')
    # print("string_limpio:", string)

    string = reducir_espacios_string(string)
    # print("reducido espacios:", string)

    string = dividir_string(string)
    # print("dividir_string:", string)

    ultimo_numero = obtener_ultimo_numero(string)
    # print("ultimo numero:", ultimo_numero)

    # si no encuentra numeros sale
    if int(ultimo_numero) < 0: return ultimo_numero

    indice_ultimo_numero = obtener_indice_elemento(string, ultimo_numero)
    # print("indice_ultimo_numero:", indice_ultimo_numero)

    indice_inicial = '*inicio'

    indice = busqueda(lista, string)
    # print("busqueda:", indice)
    if indice[0] > 0:  # si encontró alguna palabra
        indice_inicial = indice[0] + 1

    # para que pase 'Necesito un coche a las 14.20 , en Colon 1444'
    indice_en = obtener_indice_elemento(string, 'en')
    if indice_en >= 0: indice_inicial = indice_en

    # para que pase 'Magallanes 556 aqui mandame el coche'
    if indice[0] > indice_ultimo_numero:
        indice_inicial = '*inicio'

    # print("largo string:", len(string))
    # print("indice ultimo:", indice_ultimo_numero + 1)
    if indice_ultimo_numero + 1 < len(string):
        valor_despues_numero = string[indice_ultimo_numero + 1]
        if valor_despues_numero.lower() == 'a' or \
                valor_despues_numero.lower() == 'b' or \
                valor_despues_numero.lower() == 'c' or \
                valor_despues_numero.lower() == 'd' or \
                valor_despues_numero.lower() == 'bis':
            indice_ultimo_numero = indice_ultimo_numero + 1
    # print("indice ultimo pasado:", indice_ultimo_numero)
    substring = obtener_substring(string, indice_inicial, indice_ultimo_numero)
    # print("substring es:", substring)

    if len(substring) < 2: return -2

    if substring[0].lower() == 'para' or \
            substring[0].lower() == 'a' or \
            substring[0].lower() == 'ah' or \
            substring[0].lower() == 'acá' or \
            substring[0].lower() == 'hola' or \
            substring[0].lower() == 'aqui' or \
            substring[0].lower() == 'aca' or \
            substring[0].lower() == 'ahora' or \
            substring[0].lower() == 'en' or \
            substring[0].lower() == 'calle' or \
            substring[0].lower() == 'direccion' or \
            substring[0].lower() == 'dirección' or \
            substring[0].lower() == 'buen' or \
            substring[0].lower() == 'b' or \
            substring[0].lower() == 'Beuenas' or \
            substring[0].lower() == 'buenas':
        # print("encontro para o a y lo saca")
        substring.pop(0)
    if substring[0].lower() == 'dia' or \
            substring[0].lower() == 'día' or \
            substring[0].lower() == 'en' or \
            substring[0].lower() == 'días' or \
            substring[0].lower() == 'dias' or \
            substring[0].lower() == 'tarde' or \
            substring[0].lower() == 'tardes' or \
            substring[0].lower() == 'noche' or \
            substring[0].lower() == 'noches':
        # print("encontro noche o dias y lo saca")
        substring.pop(0)

    # print("antes de mandarlo al substring:", substring)

    substring = array_to_string(substring)

    return substring


def address_to_lat_lon(place, x_min, y_min, x_max, y_max, maxRows, TOKEN):
    """
    Esta función se conecta a la API Rest de ArcGis, validándose con un TOKEN, recibe una dirección, un rango donde
    buscar y una cantidad máxima de resultados posibles y devuelve una lista con las direcciones encontradas y sus
    latitudes y longitudes y otros datos.

    :param place: Dirección a buscar
    :param x_min: Longitud menor de la zona a buscar.
    :param y_min: Latitud menor de la zona a buscar.
    :param x_max: Longitud Mayor de la zona a buscar.
    :param y_max: Latitud Mayor de la zona a buscar.
    :param maxRows: Cantidad máxima de direcciones encontradas.
    :return: Lista de diccionarios con las direcciones encontradas
        Ej. respuesta: [{'address','latitud','longitud','score','street_name','street_number','city','subregion','region','country'},
                        {'address','latitud','longitud','score','street_name','street_number','city','subregion','region','country'},
                        {'address','latitud','longitud','score','street_name','street_number','city','subregion','region','country'}]


    funciones
        unicode_to_str
        ordenar_bis
    dependencias
        requests
        json

    """

    # Inicializar variables
    result = []
    lista = []

    direccion = place['direccion']
    direccion = ordenar_bis(direccion)
    place = direccion + ' ,' + place['ciudad']
    headers = {'content-type': 'application/json'}

    print("place:", place)
    # Armado de la url a consultar
    url = 'https://geocode-api.arcgis.com/arcgis/rest/services/World/GeocodeServer/findAddressCandidates' \
          '?address=%(searchText)s' \
          '&maxLocations=%(maxRows)s' \
          '&searchExtent=%(x_min)s,%(y_min)s,%(x_max)s,%(y_max)s' \
          '&outFields=StName,AddNum,City,Subregion,Region,Country' \
          '&f=json' \
          '&token=%(token)s' % {'searchText': place,
                                'x_min': x_min,
                                'y_min': y_min,
                                'x_max': x_max,
                                'y_max': y_max,
                                'maxRows': maxRows,
                                'token': TOKEN}
    #     '&location=%(lon)s,%(lat)s' \  Agregar este filtro para referenciar un centro de busqueda, en caso de pasar searchExtent, no es necesario

    # Si se pasa la ciudad separada por "," optener la primera parte para sacar de ahí la altura
    domicilio = place.split(',')[0]

    # Extraer los números dentro de la dirección recibida
    for s in domicilio.split():
        if s.isdigit():
            lista.append(s)

    req = requests.post(url, headers=headers)
    resp = json.loads(req.text)

    # Iniciar la busqueda
    # g = geocoder.arcgis(place, maxRows=maxRows)

    # Verificar las direcciones encontradas
    for pos in resp['candidates']:
        if lista:
            # Según la cantidad de numeros en contrados trato de ver cual puede ser la altura de la dirección
            # Ya que las direcciones pueden ser:
            #        - Urquiza 7164
            #        - 1 de Mayo 1554
            #        - Batallon 121 1568

            if len(lista) == 1:
                i = 0
            elif len(lista) > 1:
                i = 1

            if lista[i] in pos['address'] and pos['score'] >= 80:
                # Filtrar por porcentaje de acierto que la dirección encontrada tenga un numero de los pasados en la dirección
                # Agregar dirección a los resultados
                result.append({'direccion': unicode_to_str(pos['address'].split(',')[0]),
                               'latitud': pos['location']['y'],
                               'longitud': pos['location']['x'],
                               'score': pos['score'],
                               'ciudad': unicode_to_str(pos['attributes']['City'])
                               })

    if result:
        # ordena por score, no lo puse en una funcion aparte porque se rompia y no se porque
        result.sort(key=lambda x: x['score'], reverse=True)
        return {'Estado': True, 'Respuesta': 'ok', 'Dato': result}
    return {'Estado': False, 'Respuesta': 'no hay direcciones'}


def address_to_lat_lon_vieja(place, max_rows=5):
    """
    Recibe una dirección como parámetro y devuelve una lista con las direcciones encontradas, porcentaje de acierto
    , latitud y longitud
    :param place: Direccion (Ej.: Urquiza 7164, Rosario, Rosario)
    :param max_rows: Cantidad maxima de resultados
    :return: [{'address', 'latitude', 'longitude', 'score'},
              {'address', 'latitude', 'longitude', 'score'},
              {'address', 'latitude', 'longitude', 'score'}]
    """
    direccion = place['direccion']
    direccion = ordenar_bis(direccion)
    place = direccion + ' ,' + place['ciudad']

    result = []
    lista_de_numeros = []

    # Si se pasa la ciudad separada por "," optener la primera parte para sacar de ahí la altura
    domicilio = place.split(',')[0]

    # Extraer los números dentro de la dirección recibida
    for s in domicilio.split():
        if s.isdigit():
            lista_de_numeros.append(s)

    # Iniciar la busqueda
    direcciones = geocoder.arcgis(place, maxRows=max_rows)

    # Verificar las direcciones encontradas
    for direccion in direcciones:

        if lista_de_numeros:
            # Según la cantidad de numeros encontrados trato de ver cual puede ser la altura de la dirección
            # Ya que las direcciones pueden ser:
            #        - Urquiza 7164
            #        - 1 de Mayo 1554
            #        - Batallon 121 1568

            if len(lista_de_numeros) == 1:
                i = 0
            elif len(lista_de_numeros) > 1:
                i = 1

            if lista_de_numeros[i] in direccion.json['address'] and direccion.json['score'] >= 75:
                # Filtrar por porcentaje de acierto que la dirección encontrada tenga un numero de los pasados en la dirección
                # Agregar dirección a los resultados
                result.append({'direccion': unicode_to_str(direccion.json['address'].split(',')[0]),
                               'ciudad': unicode_to_str(direccion.json['address'].split(',')[1]),
                               'latitud': direccion.latlng[0],
                               'longitud': direccion.latlng[1],
                               'score': direccion.json['score']}
                              )

    if result:
        # ordena por score, no lo puse en una funcion aparte porque se rompia y no se porque
        result.sort(key=lambda x: x['score'], reverse=True)
        return {'Estado': True, 'Respuesta': 'ok', 'Dato': result}
    return {'Estado': False, 'Respuesta': 'no hay direcciones'}


def pasar_a_minusculas(palabra):
    return palabra.lower()


def ordenar_bis(palabra):
    """
    busca si esta bis y si esta lo pone delante del ultimo numero

    ejemplo: entra: uruguay 2020. sale: uruguay 2020
    ejemplo: entra: uruguay 2020 bis . sale: uruguay bis 2020
    ejemplo: entra: uruguay bis 2020 . sale: uruguay bis 2020

    :param palabra: string
    :return: -1 si no hay palabra, o un string
    """

    if not palabra: return -1  # valida el string

    palabra = pasar_a_minusculas(palabra)  # pasa a minusculas todo
    palabra = dividir_string(palabra)  # pasa palabra a array
    indice_bis = obtener_indice_elemento(palabra, 'bis')  # busca donde está el bis
    if indice_bis < 0:
        return array_to_string(palabra)  # si no esta bis devuelve la palabra

    ultimo_numero = obtener_ultimo_numero(palabra)  # obtiene el ultimo numero
    indice_ultimo_numero = obtener_indice_elemento(palabra, ultimo_numero)  # obtiene indice del ultimo numero
    if indice_ultimo_numero > indice_bis:  # si envia "uruguay bis 2020" que lo devuelva tal cual
        return array_to_string(palabra)

    # si envio uruguay 2020 bis, reemplaza el ultimo numero por el bis.
    palabra[indice_bis] = ultimo_numero
    palabra[indice_ultimo_numero] = 'bis'

    palabra = array_to_string(palabra)  # lo pasa nuevamente a string

    return palabra
