# -*- coding: utf-8 -*-

import os
import logging
import datetime
from subprocess import PIPE
from subprocess import Popen

from at.orm.decorators import DBSwitch


# dame acceso a la DB
@DBSwitch('cp')
class db(object):
    pass

cp = db().cp
log = logging.getLogger('srv.cp.tasks')


def ajustarsegundos(debug=None, now=None, secs=None):
    ''' Cambia la hora de Linux segun segundos.
    '''

    def comprobar_segundos():
        ''' Esta función retorna True si no estamos entre las 23:55 y
        las 00:05, caso contrario, retorna False '''

        now = datetime.datetime.now()
        hour, mins, secs = now.hour, now.minute, now.second

        t_current = datetime.time(hour, mins, secs)

        t_max = datetime.time(23, 55, 0)
        t_min = datetime.time(0, 5, 0)

        if t_current < t_max and t_current > t_min:
            return True
        else:
            return False

    def resetear_ajustarhora():
        ''' Resetea campo AjustarHora de la tabla parametros a cero '''
        session = cp.binded_session()
        q_obj = session.query(parametros)
        u = {'AjustarHora': 0}
        q_obj.update(u)
        session.commit()
        session.close()

    def modificar_hora(segundos):
        ''' Obtengo un integer y lo sumo a la hora actual, luego ejecuto
        saliendo al shell el comando date '''

        now = datetime.datetime.now()
        log.debug('Hora actual: %s' % now.strftime("%H:%M:%S"))

        time = now + segundos
        unix_time = time.strftime("%m%d%H%M%Y") + '.' + time.strftime("%S")
        cmd = 'date %s' % unix_time
        log.debug('Comando de unix: %s' % cmd)
        os.system(cmd)
        now = datetime.datetime.now()
        log.debug('Hora actualizada a: %s' % now.strftime("%H:%M:%S"))

    def modificar_hw_hora():
        ''' Modifica la hora del hardware usando la hora del sistema del OS.
        Uso subprocess porque preciso constatar la hora del hardware, osea
        obtener la salida del comando hwclock
        '''
        cmd = 'hwclock --systohc'
        p = Popen(cmd, stdout=PIPE, stderr=PIPE, shell=True)
        pstdout, pstderr = p.communicate()
        # Si no tuvimos error
        if pstderr == '':
            cmd = 'hwclock --show'
            p = Popen(cmd, stdout=PIPE, stderr=PIPE, shell=True)
            pstdout, pstderr = p.communicate()
            log.debug('Hora del Hardware actualizada a: %s' % pstdout)
        else:
            log.debug('Error al actualizar hora del hardware: %s' % pstderr)

    def modificar_hora_debug(secs):
        time = now + secs
        unix_time = time.strftime("%m%d%H%M%Y") + '.' + time.strftime("%S")
        return unix_time

    if comprobar_segundos():

        parametros = cp.tabla('parametros')
        session = cp.binded_session()
        q_obj = session.query(parametros).all()
        session.close()

        if len(q_obj) != 0:
            for q in q_obj:
                if q.AjustarHora != 0:
                    q = datetime.timedelta(seconds=int(q.AjustarHora))
                    if debug:
                        return modificar_hora_debug(q)
                    else:
                        modificar_hora(q)
                        modificar_hw_hora()
                    resetear_ajustarhora()
                # solo presto atencion al primer registro
                break


def ajustarhora():
    ''' Cambia la hora de Linux segun SetDateTime '''

    plocales = cp.tabla('parametroslocales')
    session = cp.binded_session()

    q_obj = session.query(plocales).all()
    session.close()

    if len(q_obj) != 0:
        q_obj = q_obj[0]
        in_time = q_obj.SetDateTime
        zero_time = datetime.datetime(1900, 1, 1, 0, 0)
        if in_time != zero_time:
            log.debug('Debo cambiar la hora de linux a: %s' % in_time.strftime("%Y/%m/%d %H:%M:%S"))
            unix_time = in_time.strftime("%m%d%H%M%Y") + '.' + in_time.strftime("%S")
            cmd = 'date %s' % unix_time
            log.debug('Comando de unix: %s' % cmd)
            print(cmd)
