# -*- coding: utf-8 -*-

import time
from sqlalchemy.sql.expression import and_
from sqlalchemy.sql.expression import or_

from at.utiles import _
from at.utiles.servidores import DateTimeHelper
from at.utiles.validaciones_generales import ValidacionesGenerales
from at.orm.decorators import DBSwitch


@DBSwitch('cp')
class Numerador(ValidacionesGenerales):
    '''
        Clase relacionada con los numeradores.
    '''

    def __init__(self):
        self.dthelper = DateTimeHelper()

    def obtener_numerador(self, tabla='', usuario=''):
        '''
            Función para obtener los numeradores correspondientes de una tabla
            especifica de forma segura
        '''

        # NOTA: Cambio toda la función
        # Lo que hace ahora está función es obtener el último ID de la
        # tabla "mensajes" y pasar al siguiente.
        # Se hace esto porque el campo IdMensaje no es AUTOINCREMENT

        session = self.cp.binded_session()

        tabla_mensajes = self.cp.tabla('mensajes')

        q_obj = session.query(tabla_mensajes.IdMensaje)

        q_obj = q_obj.order_by(tabla_mensajes.IdMensaje.desc())

        q_obj = q_obj.limit(1)

        registro = q_obj.first()

        session.close()

        if registro is None:
            return 1

        return registro.IdMensaje + 1

        # NOTA: Comento esta función porque funciona muy lento
        # se va a resolver de otra forma
        # if not self.validar_string_no_vacio(tabla):
        #     raise ValueError, _('Tabla debe ser un string.')
        #
        # if not self.validar_string_no_vacio(usuario):
        #     raise ValueError, _('Usuario debe ser un string.')
        #
        # strBloqAnt = ''
        # intReintentos = 0
        # fecha_hora_actual = self.dthelper.get_now()
        # fecha_hora_actual = fecha_hora_actual.strftime("%d/%m/%Y %H:%M:%S")
        # strBloqueo = fecha_hora_actual + usuario
        #
        # session = self.cp.binded_session()
        #
        # while(True):
        #     intReintentos += 1
        #     numeradores = self.cp.tabla('numeradores')
        #
        #     str_vacio = ''
        #     none = None
        #
        #     q_obj = session.query(numeradores)
        #     q_obj = q_obj.filter(and_(
        #                             numeradores.Tabla == tabla,
        #                             or_(
        #                                 numeradores.Bloqueo == none,
        #                                 numeradores.Bloqueo == str_vacio,
        #                             )
        #                         ))
        #
        #     if q_obj.count() == 1:
        #
        #         numerador = q_obj.first()
        #
        #         dic = {}
        #         dic['Numero'] = int(numerador.Numero) + 1
        #         dic['Bloqueo'] = strBloqueo
        #
        #         try:
        #             q_obj.update(dic)
        #             session.commit()
        #         except:
        #             session.rollback()
        #
        #         q_obj2 = session.query(numeradores.Numero)
        #         q_obj2 = q_obj2.filter(
        #                             and_(
        #                                 numeradores.Tabla == tabla,
        #                                 numeradores.Bloqueo == strBloqueo
        #                             )
        #                         ).with_lockmode("update")
        #
        #         numero = q_obj2.first()
        #
        #         if numero is None:
        #             session.close()
        #             return False
        #
        #         numero = numero.Numero
        #
        #         q_obj3 = session.query(numeradores)
        #         q_obj3 = q_obj3.filter(
        #                             and_(
        #                                 numeradores.Tabla == tabla,
        #                                 numeradores.Bloqueo == strBloqueo
        #                             )
        #                         )
        #
        #         dic = {}
        #         dic['Bloqueo'] = ''
        #
        #         try:
        #             q_obj3.update(dic)
        #             session.commit()
        #         except:
        #             session.rollback()
        #
        #         session.close()
        #         return numero
        #     else:
        #         if intReintentos >= 5:
        #             # Ver si esta bloqueando el Registro
        #             q_obj4 = session.query(numeradores.Bloqueo)
        #             q_obj4 = q_obj4.filter(numeradores.Tabla == tabla)
        #
        #             bloqueo = q_obj4.first()
        #
        #             q_obj4 = None
        #
        #             if bloqueo is not None:
        #                 bloqueo = bloqueo.Bloqueo
        #
        #                 if strBloqAnt != bloqueo:
        #                     # Si no esta trabado el bloqueo
        #                     strBloqAnt = bloqueo
        #                     intReintentos = 0
        #                 else:
        #                     # 'Si esta trabado el bloqueo, liberar el Numerador
        #                     q_obj5 = session.query(numeradores)
        #                     q_obj5 = q_obj5.filter(
        #                                 and_(
        #                                     numeradores.Tabla == tabla,
        #                                     numeradores.Bloqueo == strBloqAnt
        #                                 )
        #                             )
        #
        #                     dic = {}
        #                     dic['Bloqueo'] = ''
        #
        #                     try:
        #                         q_obj5.update(dic)
        #                         session.commit()
        #                     except:
        #                         session.rollback()
        #                     strBloqAnt = ''
        #
        #         time.sleep(1)
        #
        # session.close()
        #
        # return False
