# -*- coding: utf-8 -*-

from random import choice
from random import randrange


class Password(object):
    '''
        Clase encargada de generar contraseñas aleatorias.
    '''

    def generar_password(self, longitud=12, solo_minusculas=False):
        '''
            Esta función se encarga de generar una contraseña de 12 caracteres.

            Argumentos:
                longitud (int)
                solo_minusculas (bool)

            Retorna:
                password (str)
        '''

        valores = 'abcdefghijklmnopqrstuvwxyz'
        if solo_minusculas is False:
            valores = valores + '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ=@#%&+'

        password = ''
        password = password.join([choice(valores) for i in range(longitud)])

        return password

    def generar_serial(self):
        '''
            Esta función se encarga de generar un serial de 24 caracteres.

            Retorna:
                serial (str)
        '''

        longitud = 50
        valores = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ=@#%&+'

        serial = ''
        serial = serial.join([choice(valores) for i in range(longitud)])

        return serial

    def generar_sesion(self):
        '''
            Esta función se encarga de generar un nombre de sesión random.

            Retorna:
                sesion (str)
        '''

        longitud = 10
        valores = 'abcdefghijklmnopqrstuvwxyz'

        sesion = ''
        sesion = sesion.join([choice(valores) for i in range(longitud)])

        return sesion

    def generar_hash(self, longitud=20):
        '''
            Esta función se encarga de generar un hash random.

            Retorna:
                sesion (str)
        '''

        valores = 'abcdefghijklmnopqrstuvwxyz'

        hash_generado = ''
        hash_generado = hash_generado.join(
            [choice(valores) for i in range(longitud)]
        )

        return hash_generado

    def generar_numero(self, max_num, min_num=0, min_caracteres=None):
        '''
            Esta función se encarga de generar un número random.
            El número debe estar entre 0 y un número dado.
            Si se requiere un mínimo de caracteres se debe pasar a str
            y completar con "0".
            Esta función solo sirve para números positivos.

            Argumentos:
                max_num (int)
                min_num (int)
                min_caracteres (int)

            Retorna:
                int o str
        '''

        # Obtengo un número random entre en mínimo y el máximo dado
        numero = randrange(min_num, max_num)

        # Obtengo la cantidad de caracteres que tiene el número obtenido
        cant_caracteres = len(str(numero))

        # Si tengo un mínimo de caracteres
        if min_caracteres is not None:
            # Paso el número a str para poder concatener con "0"
            numero = str(numero)
            # Si la cantidad de caracteres es menor al mínimo requerido
            if cant_caracteres < min_caracteres:
                # Obtengo la diferencia de caracteres entre lo requerido
                # y lo que tiene el número
                dif_caracteres = min_caracteres - cant_caracteres

                # Agrego un 0 al número hasta completar los caracteres
                # requeridos
                for caracter in range(dif_caracteres):
                    # Concateno un 0 adelante con el número
                    numero = '0' + numero

        # Retorno el número obtenido, puede ser int o str
        return numero
