# -*- coding: utf-8 -*-

import unittest

from at.utiles import _
from at.utiles.scripts.simular_movil import simular_movil
from at.utiles.hilos import ejecutar_hilo


class TestSimularMovil(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_1_simular_movil(self):
        # Le paso un móvil que no existe
        id_movil = '1234'
        estado1 = 1
        posiciones = [
            [-32.932772, -60.719928],
            [-32.932763, -60.718769],
            [-32.932718, -60.717642],
            [-32.933591, -60.717631],
            [-32.933609, -60.718758],
            [-32.933654, -60.719874],
        ]
        segundos = 5
        infinito = False
        rta = simular_movil(
            id_movil, estado1, posiciones, segundos, infinito
        )
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'No se encontró el móvil con id 1234')
        )

        # COMENTO ESTOS TEST PORQUE SON INFINITOS, USAR PARA HACER PRUEBAS ###
        # MOVIL 1
        id_movil = '1'
        estado1 = 1
        posiciones = [
            [-32.932772, -60.719928],
            [-32.932763, -60.718769],
            [-32.932718, -60.717642],
            [-32.933591, -60.717631],
            [-32.933609, -60.718758],
            [-32.933654, -60.719874],
        ]
        segundos = 5
        infinito = True
        # Ejecuto la función en un hilo para que no termine nunca
        ejecutar_hilo(
            funcion=simular_movil,
            parametros=(id_movil, estado1, posiciones, segundos, infinito),
            daemon=True
        )
        # MOVIL 2
        id_movil = '2'
        estado1 = 1
        posiciones = [
            [-32.934663, -60.717568],
            [-32.933600, -60.717622],
            [-32.932736, -60.717633],
            [-32.932691, -60.716539],
            [-32.933609, -60.716464],
            [-32.934645, -60.716443],
        ]
        segundos = 5
        infinito = True
        # Ejecuto la función en un hilo para que no termine nunca
        ejecutar_hilo(
            funcion=simular_movil,
            parametros=(id_movil, estado1, posiciones, segundos, infinito),
            daemon=True
        )
        #######################################################################

    def test_2_simular_movil(self):
        # # MOVIL 3
        id_movil = '3'
        estado1 = 1
        posiciones = [
            [-32.933618, -60.718746],
            [-32.933645, -60.719889],
            [-32.932781, -60.719943],
            [-32.932776, -60.718784],
        ]
        segundos = 5
        infinito = True
        # Ejecuto la función en un hilo para que no termine nunca
        ejecutar_hilo(
            funcion=simular_movil,
            parametros=(id_movil, estado1, posiciones, segundos, infinito),
            daemon=True
        )
        # MOVIL 4
        id_movil = '4'
        estado1 = 1
        posiciones = [
            [-32.934730, -60.718650],
            [-32.934671, -60.717561],
            [-32.933608, -60.717604],
            [-32.933635, -60.718757],
        ]
        segundos = 5
        infinito = True
        # Ejecuto la función en un hilo para que no termine nunca
        ejecutar_hilo(
            funcion=simular_movil,
            parametros=(id_movil, estado1, posiciones, segundos, infinito),
            daemon=True
        )


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestSimularMovil))
    return suite
