# -*- coding: utf-8 -*-

from subprocess import Popen
from subprocess import PIPE

from at.utiles import _
from at.utiles.validar import string
from at.utiles.validar import no_vacio
from at.utiles.conversiones import respuesta


def ejecutar_comando(comando):
    '''
    Esta función sirve para ejecutar un comando en la consola de shell.
    :param comando: str
    :return: dic
    '''

    # Verifico si recibo un string.
    rta_string = string(comando)

    # Verifico el resultado.
    if rta_string['Estado'] is not True:
        return rta_string

    # Acomodo los parámetros.
    comando = comando.split(' ')

    # Si recibo un solo bloque lo paso como string y no como lista.
    if len(comando) == 0:
        comando = comando[0]

    try:
        # Ejecuto el parámetro.
        process = Popen(comando, stdout=PIPE, stderr=PIPE)

        # Registro las salidas
        stdout, stderr = process.communicate()

        # Registro el código.
        codigo = process.poll()

        # Acomodo los datos.
        dic = {
            'salida': stdout,
            'sub_proceso': stderr,
            'codigo': codigo
        }

        # Verifico si hay un error.
        if codigo != 0:
            return respuesta(False, _(u'Error al ejecutar el comando.'), dic)

        # Retorno la salida.
        return respuesta(True, _(u'Se ejecutó el comando.'), dic)

    except Exception as ins:
        return respuesta(
            False, _(u'Error al ejecutar el comando (Exception): %s') % ins, ins
        )
