# -*- coding: utf-8 *-*
import threading


class Singleton(object):

    class __impl(object):

        def __init__(self):
            pass

    # Atributos privados.
    __instance = None
    __lock = threading.Lock()

    ## Inicializa la unica instancia del nucleo.
    def __init__(self):
        Singleton.__lock.acquire(True)
        try:
            if Singleton.__instance is None:
                Singleton.__instance = Singleton.__impl()
        finally:
            Singleton.__lock.release()

    ## Delegate access to implementation.
    def __getattr__(self, attr):
        return getattr(self.__instance, attr)

    ## Delegate access to implementation.
    def __delattr__(self, attr):
        return delattr(self.__instance, attr)

    ## Delegate access to implementation.
    def __setattr__(self, attr, value):
        return setattr(self.__instance, attr, value)
