# -*- coding: utf-8 -*-

import unittest

from at.utiles.aws import Aws
from at.orm.abm import ABM
from sqlalchemy import and_, func


class AwsTesting(Aws):

    def __init__(self):
        Aws.__init__(self)

class TestAws(unittest.TestCase):

    def setUp(self):
        self.aws = Aws()

    def tearDown(self):
        pass

    def test_obtener_coneccion_ec2(self):

        rta = self.aws.obtener_coneccion_ec2()
        self.assertTrue(rta['Estado'])

    def test_verificar_estado_intancia_ec2(self):

        rta = self.aws.obtener_coneccion_ec2()

        self.assertTrue(rta['Estado'])

        conexion = rta['Dato']

        id_instancia = 'asdasdsad'

        rta = self.aws.verificar_estado_intancia_ec2(conexion, id_instancia)

        self.assertTrue(rta['Estado'] is False)

        id_instancia = 'i-02d2c9ccd1f3876a9'

        rta = self.aws.verificar_estado_intancia_ec2(conexion, id_instancia)

        # self.assertTrue(rta['Estado'])



    # SE COMENTA PARA QUE NO SE PRENDA NI APAGUE LA INSTANCIA .

    # def test_encender_instancia_ec2(self):
    #
    #     id_instancia = '13123a9asdasd'
    #
    #     rta = self.aws.encender_instancia_ec2(id_instancia)
    #
    #     self.assertTrue(rta['Estado'] is False)
    #
    #     id_instancia = 'i-00a6d87e02279165b'
    #     ip_publica = '23.21.113.217'
    #
    #     print(id_instancia)
    #
    #     rta = self.aws.encender_instancia_ec2(
    #         id_instancia, ip_publica=ip_publica
    #     )
    #
    #     print(rta)
    #
    # def test_apagar_instancia_ec2(self):
    #
    #     id_instancia = '13123a9asdasd'
    #
    #     rta = self.aws.apagar_instancia_ec2(id_instancia)
    #
    #     self.assertTrue(rta['Estado'] is False)
    #
    #     id_instancia = 'i-00a6d87e02279165b'
    #
    #     rta = self.aws.apagar_instancia_ec2(id_instancia)
    #
    #     print(rta)


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestAws))
    return suite
