# -*- coding: utf-8 -*-

import unittest

from at.utiles.decoradores import con_log
from at.utiles.decoradores import con_try


class TestDecoradores(unittest.TestCase):

    def test_decoradores(self):
        # Ejecuto la función "funcion_prueba" que está decorada con @con_log
        rta = self.funcion_prueba(2, 3)
        self.assertTrue(rta == 5)

        # Ejecuto la función "funcion_prueba2" que está decorada con @con_log
        # que setea el nombre del log
        rta = self.funcion_prueba2(3, 5)
        self.assertTrue(rta == 8)

        # Ejecuto la función "funcion_prueba3" que está decorada con @con_try
        # esta tiene un error
        rta = self.funcion_prueba3(4, 2)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(rta['Respuesta'] == 'ERROR EN EL TRY')

        # Ejecuto la función "funcion_prueba4" que está decorada con @con_try
        # esta no tiene un error
        rta = self.funcion_prueba4(17, 18)
        self.assertTrue(rta == 35)

        # Ejecuto la función "funcion_prueba5" que está decorada con @con_try
        # esta tiene un error
        rta = self.funcion_prueba5(8, 9)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(rta['Respuesta'] == 'ERROR EN EL TRY')

        # Probando de logear los acentos
        rta = self.funcion_prueba6()
        self.assertTrue(rta == u'canción')

        # Prueba con dos decoradores
        rta = self.funcion_prueba7(11, 14)
        self.assertTrue(rta == 25)

        # Prueba con dos decoradores y con error
        rta = self.funcion_prueba8(15, 25)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(rta['Respuesta'] == 'ERROR EN EL TRY')

    @con_log()
    def funcion_prueba(self, parametro1, parametro2):
        # Creo una función de prueba decorada con @con_log
        resultado = parametro1 + parametro2
        return resultado

    @con_log()
    def funcion_prueba2(self, parametro1, parametro2):
        # Creo una función de prueba decorada con @con_log
        resultado = parametro1 + parametro2
        return resultado

    @con_try()
    def funcion_prueba3(self, parametro1, parametro2):
        # Creo una función de prueba decorada con @con_try que tiene un error
        print(no_existo)
        resultado = parametro1 + parametro2
        return resultado

    @con_try()
    def funcion_prueba4(self, parametro1, parametro2):
        # Creo una función de prueba decorada con @con_try pero sin errores
        resultado = parametro1 + parametro2
        return resultado

    @con_try()
    def funcion_prueba5(self, parametro1, parametro2):
        # Creo una función de prueba decorada con @con_try que tiene un error
        print(no_existo)
        resultado = parametro1 + parametro2
        return resultado

    @con_log()
    def funcion_prueba6(self):
        # Creo una función de prueba decorada con @con_log para probar
        # una respuesta con acento
        resultado = u'canción'
        return resultado

    @con_log()
    @con_try()
    def funcion_prueba7(self, parametro1, parametro2):
        # Creo una función de prueba decorada con @con_log y @con_try
        resultado = parametro1 + parametro2
        return resultado

    @con_log()
    @con_try()
    def funcion_prueba8(self, parametro1, parametro2):
        # Creo una función de prueba decorada con @con_log y @con_try y falla
        print(con_dos_decoradores)
        resultado = parametro1 + parametro2
        return resultado


def suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestDecoradores))
    return suite
