# -*- coding: utf-8 -*-

import unittest

from at.utiles.encriptaciones import Encriptaciones


class TestEncriptaciones(unittest.TestCase):

    def setUp(self):
        self.e = Encriptaciones()

    def test_encriptar_md5(self):
        valor = 'asdasd'
        r = self.e.encriptar_md5(valor)
        self.assertTrue(r == 'a8f5f167f44f4964e6c998dee827110c')

        # le paso un unicode, anda igual
        valor = u'esunicode'
        r = self.e.encriptar_md5(valor)
        self.assertTrue(r == '01b18bec0ed1f9501c8ea038550bb3cb')

        # le paso un entero
        valor = 123
        self.assertRaises(ValueError, self.e.encriptar_md5, valor)

        #### XXX testear pasandole None y ''

    def test_encriptar_sha1(self):
        # le paso un str
        valor = 'asdasd'
        r = self.e.encriptar_sha1(valor)
        self.assertTrue(r == '85136c79cbf9fe36bb9d05d0639c70c265c18d37')

        # le paso un unicode
        valor = u'asdasd'
        r = self.e.encriptar_sha1(valor)
        self.assertTrue(r == '85136c79cbf9fe36bb9d05d0639c70c265c18d37')

        # le paso un int
        valor = 1234
        self.assertRaises(ValueError, self.e.encriptar_md5, valor)

    def test_encriptar_sha256(self):
        # le paso un str
        valor = 'asdasd'
        r = self.e.encriptar_sha256(valor)
        self.assertTrue(r ==
            '5fd924625f6ab16a19cc9807c7c506ae1813490e4ba675f843d5a10e0baacdb8')
        self.assertTrue(len(r) == 64)

        # le paso un unicode
        valor = u'asdasd'
        r = self.e.encriptar_sha256(valor)
        self.assertTrue(r ==
            '5fd924625f6ab16a19cc9807c7c506ae1813490e4ba675f843d5a10e0baacdb8')
        self.assertTrue(len(r) == 64)

        # le paso otro valor
        valor = u'qwerty3569'
        r = self.e.encriptar_sha256(valor)
        self.assertTrue(r ==
            '77eec1934e2309a4b9a66c6648bb193f034128bcaef1e6b4aadebcafd8a7e735')
        self.assertTrue(len(r) == 64)

        # le paso un str vacío
        valor = u''
        r = self.e.encriptar_sha256(valor)
        self.assertTrue(r ==
            'e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855')
        self.assertTrue(len(r) == 64)

    def test_encriptar_cp(self):
        s = 'asdasd'
        key = 3091974
        salt = False
        bDo = True
        r = self.e.encriptar_cp(s, key, salt, bDo)
        self.assertTrue(isinstance(r, str))

        s = '+'
        key = 3091974
        salt = False
        bDo = True
        r = self.e.encriptar_cp(s, key, salt, bDo)
        self.assertTrue(isinstance(r, str))


def suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestEncriptaciones))
    return suite
