# -*- coding: utf-8 -*-

import unittest

from at.utiles.numerador import Numerador
from at.orm.abm import ABM


class NumeradorTesting(Numerador):

    def __init__(self):
        Numerador.__init__(self)
        cp = {'user': 'frula',
              'passwd': 'changeme',
              'dbname': 'tests',
              'name': 'cp',
              'host': '192.168.0.51',
              'engine': 'mysql',
              'port': '3306',
              }

        self.cp = ABM(cp)


class TestNumerador(unittest.TestCase):

    def setUp(self):
        self.n_t = NumeradorTesting()
        self.n_t.cp.borrar('numeradores')

        #agrego un numerador
        n = {}
        n['Tabla'] = 'prueba'
        n['Numero'] = 0
        n['Bloqueo'] = ''

        self.n_t.cp.agregar('numeradores', **n)

        self.n_t.cp.borrar('mensajes')

    def tearDown(self):
        self.n_t.cp.borrar('numeradores')

        self.n_t.cp.borrar('mensajes')

    def test_obtener_numerador(self):
        # Caso para cuando no hay ningún registro en la tabla "mensajes"
        rta_obtener_numerador = self.n_t.obtener_numerador('mensajes', '')
        self.assertTrue(rta_obtener_numerador == 1)

        # Agrego un registro en la tabla "mensajes"
        dic = {}
        dic['IdMensaje'] = 1
        dic['Sucursal'] = 'SUC01'
        dic['Remitente'] = 'el remitente'
        dic['Destinatario'] = 'el destinatario'
        dic['Enviado'] = '2019-08-08 14:50:00'
        dic['Mensaje'] = 'el mensaje'
        agregar = self.n_t.cp.agregar('mensajes', **dic)
        self.assertTrue(agregar is True)

        # Caso para el segundo mensaje
        rta_obtener_numerador = self.n_t.obtener_numerador('mensajes', '')
        self.assertTrue(rta_obtener_numerador == 2)

        # Agrego un registro en la tabla "mensajes"
        dic = {}
        dic['IdMensaje'] = 2
        dic['Sucursal'] = 'SUC01'
        dic['Remitente'] = 'el remitente'
        dic['Destinatario'] = 'el destinatario'
        dic['Enviado'] = '2019-08-08 14:50:00'
        dic['Mensaje'] = 'el mensaje'
        agregar = self.n_t.cp.agregar('mensajes', **dic)
        self.assertTrue(agregar is True)

        # Agrego un registro en la tabla "mensajes"
        dic = {}
        dic['IdMensaje'] = 3
        dic['Sucursal'] = 'SUC01'
        dic['Remitente'] = 'el remitente'
        dic['Destinatario'] = 'el destinatario'
        dic['Enviado'] = '2019-08-08 14:50:00'
        dic['Mensaje'] = 'el mensaje'
        agregar = self.n_t.cp.agregar('mensajes', **dic)
        self.assertTrue(agregar is True)

        # Agrego un registro en la tabla "mensajes"
        dic = {}
        dic['IdMensaje'] = 4
        dic['Sucursal'] = 'SUC01'
        dic['Remitente'] = 'el remitente'
        dic['Destinatario'] = 'el destinatario'
        dic['Enviado'] = '2019-08-08 14:50:00'
        dic['Mensaje'] = 'el mensaje'
        agregar = self.n_t.cp.agregar('mensajes', **dic)
        self.assertTrue(agregar is True)

        # Caso para el quinto mensaje
        rta_obtener_numerador = self.n_t.obtener_numerador('mensajes', '')
        self.assertTrue(rta_obtener_numerador == 5)

        # NOTA: Comento los tests de la función como era antes, ya no sirven
        # # Obtenemos varios numeradores y chequeamos que este todo en orden
        #
        # numerador = self.n_t.obtener_numerador('prueba', 'usuario')
        # self.assertTrue(numerador == 1)
        #
        # numerador = self.n_t.obtener_numerador('prueba', 'usuario')
        # self.assertTrue(numerador == 2)
        #
        # numerador = self.n_t.obtener_numerador('prueba', 'usuario')
        # self.assertTrue(numerador == 3)
        #
        # #agrego un numerador bloqueado
        # n = {}
        # n['Tabla'] = 'prueba2'
        # n['Numero'] = 0
        # n['Bloqueo'] = 'bloqueado'
        #
        # self.n_t.cp.agregar('numeradores', **n)
        #
        # numerador = self.n_t.obtener_numerador('prueba2', 'usuario')
        # self.assertTrue(numerador == 1)
        #######################################################################


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestNumerador))
    return suite
