# -*- coding: utf-8 -*-

import sys
import unittest

from at.utiles.parser_xml import ParserXML


class TestParserXML(unittest.TestCase):

    def setUp(self):
        self.p = ParserXML()

    def tearDown(self):
        pass

    def test_xml_a_objeto(self):
        if sys.version_info.major >= 3:
            return '* test_xml_a_objeto no funciona con Python 3'

        xml = """<?xml version="1.0" standalone="yes" ?>
<!-- generated by lshw-B.02.14 -->
<!-- GCC 4.4.4 -->
<!-- Linux 2.6.33.4-smp #2 SMP Wed May 12 22:47:36 CDT 2010 i686 -->
<!-- GNU libc 2 (glibc 2.11.1) -->
<node id="emily" claimed="true" class="system" handle="DMI:0001">
 <description>Desktop Computer</description>
 <product>MS-7353</product>
 <vendor>MICRO-STAR INTERNATIONAL CO.,LTD</vendor>
 <version>3.0</version>
 <serial>To Be Filled By O.E.M.</serial>
 <width units="bits">32</width>
 <configuration>
  <setting id="boot" value="normal" />
  <setting id="chassis" value="desktop" />
  <setting id="cpus" value="4" />
 </configuration>
 <capabilities>
  <capability id="smbios-2.5" >SMBIOS version 2.5</capability>
  <capability id="dmi-2.5" >DMI version 2.5</capability>
  <capability id="smp-1.4" >SMP specification v1.4</capability>
  <capability id="smp" >Symmetric Multi-Processing</capability>
 </capabilities>
  <node id="slacktrack">
   <user>foo</user>
   <passwd>bar</passwd>
  </node>
  <node id="core" claimed="true" class="bus" handle="DMI:0002">
   <description>Motherboard</description>
   <product>MS-7353</product>
   <vendor>MICRO-STAR INTERNATIONAL CO.,LTD</vendor>
   <physid>0</physid>
   <version>3.0</version>
   <serial>To be filled by O.E.M.</serial>
   <slot>To Be Filled By O.E.M.</slot>
    <node id="firmware" claimed="true" class="memory" handle="">
     <description>BIOS</description>
     <vendor>American Megatrends Inc.</vendor>
     <physid>0</physid>
     <version>V7.3 (11/06/2008)</version>
     <size units="bytes">65536</size>
     <capacity units="bytes">983040</capacity>
     <capabilities>
      <capability id="isa" >ISA bus</capability>
      <capability id="pci" >PCI bus</capability>
      <capability id="pnp" >Plug-and-Play</capability>
      <capability id="apm" >Advanced Power Management</capability>
      <capability id="upgrade" >BIOS EEPROM can be upgraded</capability>
      <capability id="shadowing" >BIOS shadowing</capability>
      <capability id="escd" >ESCD</capability>
      <capability id="cdboot" >Booting from CD-ROM/DVD</capability>
      <capability id="bootselect" >Selectable boot path</capability>
      <capability id="socketedrom" >BIOS ROM is socketed</capability>
      <capability id="edd" >Enhanced Disk Drive extensions</capability>
      <capability id="int13floppy1200" >5.25&quot; 1.2MB floppy</capability>
      <capability id="int13floppy720" >3.5&quot; 720KB floppy</capability>
      <capability id="int13floppy2880" >3.5&quot; 2.88MB floppy</capability>
      <capability id="int5printscreen" >Print Screen key</capability>
      <capability id="int9keyboard" >i8042 keyboard controller</capability>
      <capability id="int14serial" >INT14 serial line control</capability>
      <capability id="int17printer" >INT17 printer control</capability>
      <capability id="int10video" >INT10 CGA/Mono video</capability>
      <capability id="acpi" >ACPI</capability>
      <capability id="usb" >USB legacy emulation</capability>
      <capability id="ls120boot" >Booting from LS-120</capability>
      <capability id="zipboot" >Booting from ATAPI ZIP</capability>
      <capability id="biosbootspecification" >BIOS boot specification</capability>
     </capabilities>
    </node>
    <node id="cpu:0" claimed="true" class="processor" handle="DMI:0004">
     <description>CPU</description>
     <product>Intel(R) Core(TM)2 Quad CPU    Q8400  @ 2.66GHz</product>
     <vendor>Intel Corp.</vendor>
     <physid>4</physid>
     <businfo>cpu@0</businfo>
     <version>6.7.10</version>
     <serial>0001-067A-0000-0000-0000-0000</serial>
     <slot>CPU 1</slot>
     <size units="Hz">2664000000</size>
     <capacity units="Hz">2666000000</capacity>
     <width units="bits">64</width>
     <clock units="Hz">333000000</clock>
     <configuration>
      <setting id="id" value="3" />
     </configuration>
     <capabilities>
      <capability id="boot" >boot processor</capability>
      <capability id="fpu" >mathematical co-processor</capability>
      <capability id="fpu_exception" >FPU exceptions reporting</capability>
      <capability id="wp" />
      <capability id="vme" >virtual mode extensions</capability>
      <capability id="de" >debugging extensions</capability>
      <capability id="pse" >page size extensions</capability>
      <capability id="tsc" >time stamp counter</capability>
      <capability id="msr" >model-specific registers</capability>
      <capability id="pae" >4GB+ memory addressing (Physical Address Extension)</capability>
      <capability id="mce" >machine check exceptions</capability>
      <capability id="cx8" >compare and exchange 8-byte</capability>
      <capability id="apic" >on-chip advanced programmable interrupt controller (APIC)</capability>
      <capability id="sep" >fast system calls</capability>
      <capability id="mtrr" >memory type range registers</capability>
      <capability id="pge" >page global enable</capability>
      <capability id="mca" >machine check architecture</capability>
      <capability id="cmov" >conditional move instruction</capability>
      <capability id="pat" >page attribute table</capability>
      <capability id="pse36" >36-bit page size extensions</capability>
      <capability id="clflush" />
      <capability id="dts" >debug trace and EMON store MSRs</capability>
      <capability id="acpi" >thermal control (ACPI)</capability>
      <capability id="mmx" >multimedia extensions (MMX)</capability>
      <capability id="fxsr" >fast floating point save/restore</capability>
      <capability id="sse" >streaming SIMD extensions (SSE)</capability>
      <capability id="sse2" >streaming SIMD extensions (SSE2)</capability>
      <capability id="ss" >self-snoop</capability>
      <capability id="ht" >HyperThreading</capability>
      <capability id="tm" >thermal interrupt and status</capability>
      <capability id="pbe" >pending break event</capability>
      <capability id="nx" >no-execute bit (NX)</capability>
      <capability id="x86-64" >64bits extensions (x86-64)</capability>
      <capability id="constant_tsc" />
      <capability id="arch_perfmon" />
      <capability id="pebs" />
      <capability id="bts" />
      <capability id="aperfmperf" />
      <capability id="pni" />
      <capability id="dtes64" />
      <capability id="monitor" />
      <capability id="ds_cpl" />
      <capability id="vmx" >CPU virtualization (Vanderpool)</capability>
      <capability id="est" />
      <capability id="tm2" />
      <capability id="ssse3" />
      <capability id="cx16" />
      <capability id="xtpr" />
      <capability id="pdcm" />
      <capability id="sse4_1" />
      <capability id="xsave" />
      <capability id="lahf_lm" />
      <capability id="tpr_shadow" />
      <capability id="vnmi" />
      <capability id="flexpriority" />
     </capabilities>
      <node id="cache:0" claimed="true" class="memory" handle="DMI:0005">
       <description>L1 cache</description>
       <physid>5</physid>
       <slot>L1-Cache</slot>
       <size units="bytes">131072</size>
       <capacity units="bytes">131072</capacity>
       <capabilities>
        <capability id="internal" >Internal</capability>
        <capability id="write-back" >Write-back</capability>
        <capability id="data" >Data cache</capability>
       </capabilities>
      </node>
      <node id="cache:1" claimed="true" class="memory" handle="DMI:0006">
       <description>L2 cache</description>
       <physid>6</physid>
       <slot>L2-Cache</slot>
       <size units="bytes">4194304</size>
       <capacity units="bytes">4194304</capacity>
       <capabilities>
        <capability id="internal" >Internal</capability>
        <capability id="write-back" >Write-back</capability>
        <capability id="unified" >Unified cache</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:0" claimed="true" class="processor" handle="CPU:3.0">
       <description>Logical CPU</description>
       <physid>3.1</physid>
       <width units="bits">64</width>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:1" claimed="true" class="processor" handle="CPU:3.1">
       <description>Logical CPU</description>
       <physid>3.2</physid>
       <width units="bits">64</width>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:2" claimed="true" class="processor" handle="CPU:3.2">
       <description>Logical CPU</description>
       <physid>3.3</physid>
       <width units="bits">64</width>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:3" claimed="true" class="processor" handle="CPU:3.3">
       <description>Logical CPU</description>
       <physid>3.4</physid>
       <width units="bits">64</width>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
    </node>
    <node id="memory" claimed="true" class="memory" handle="DMI:000E">
     <description>System Memory</description>
     <physid>e</physid>
     <slot>System board or motherboard</slot>
     <size units="bytes">2147483648</size>
      <node id="bank:0" claimed="true" class="memory" handle="DMI:0010">
       <description>DIMM SDRAM Synchronous</description>
       <product>PartNum0</product>
       <vendor>Manufacturer0</vendor>
       <physid>0</physid>
       <serial>SerNum0</serial>
       <slot>DIMM0</slot>
       <size units="bytes">2147483648</size>
       <width units="bits">64</width>
      </node>
      <node id="bank:1" claimed="true" class="memory" handle="DMI:0012">
       <description>DIMM [empty]</description>
       <product>PartNum1</product>
       <vendor>Manufacturer1</vendor>
       <physid>1</physid>
       <serial>SerNum1</serial>
       <slot>DIMM1</slot>
      </node>
      <node id="bank:2" claimed="true" class="memory" handle="DMI:0014">
       <description>DIMM [empty]</description>
       <product>PartNum2</product>
       <vendor>Manufacturer2</vendor>
       <physid>2</physid>
       <serial>SerNum2</serial>
       <slot>DIMM2</slot>
      </node>
      <node id="bank:3" claimed="true" class="memory" handle="DMI:0016">
       <description>DIMM [empty]</description>
       <product>PartNum3</product>
       <vendor>Manufacturer3</vendor>
       <physid>3</physid>
       <serial>SerNum3</serial>
       <slot>DIMM3</slot>
      </node>
    </node>
    <node id="cpu:1" claimed="true" class="processor" handle="">
     <physid>1</physid>
     <businfo>cpu@1</businfo>
     <version>6.7.10</version>
     <serial>0001-067A-0000-0000-0000-0000</serial>
     <size units="Hz">2700000000</size>
     <configuration>
      <setting id="id" value="3" />
     </configuration>
     <capabilities>
      <capability id="vmx" >CPU virtualization (Vanderpool)</capability>
      <capability id="ht" >HyperThreading</capability>
     </capabilities>
      <node id="logicalcpu:0" claimed="true" class="processor" handle="CPU:3.0">
       <description>Logical CPU</description>
       <physid>3.1</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:1" claimed="true" class="processor" handle="CPU:3.1">
       <description>Logical CPU</description>
       <physid>3.2</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:2" claimed="true" class="processor" handle="CPU:3.2">
       <description>Logical CPU</description>
       <physid>3.3</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:3" claimed="true" class="processor" handle="CPU:3.3">
       <description>Logical CPU</description>
       <physid>3.4</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
    </node>
    <node id="cpu:2" claimed="true" class="processor" handle="">
     <physid>2</physid>
     <businfo>cpu@2</businfo>
     <version>6.7.10</version>
     <serial>0001-067A-0000-0000-0000-0000</serial>
     <size units="Hz">2700000000</size>
     <configuration>
      <setting id="id" value="3" />
     </configuration>
     <capabilities>
      <capability id="vmx" >CPU virtualization (Vanderpool)</capability>
      <capability id="ht" >HyperThreading</capability>
     </capabilities>
      <node id="logicalcpu:0" claimed="true" class="processor" handle="CPU:3.0">
       <description>Logical CPU</description>
       <physid>3.1</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:1" claimed="true" class="processor" handle="CPU:3.1">
       <description>Logical CPU</description>
       <physid>3.2</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:2" claimed="true" class="processor" handle="CPU:3.2">
       <description>Logical CPU</description>
       <physid>3.3</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:3" claimed="true" class="processor" handle="CPU:3.3">
       <description>Logical CPU</description>
       <physid>3.4</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
    </node>
    <node id="cpu:3" claimed="true" class="processor" handle="">
     <physid>3</physid>
     <businfo>cpu@3</businfo>
     <version>6.7.10</version>
     <serial>0001-067A-0000-0000-0000-0000</serial>
     <size units="Hz">2700000000</size>
     <configuration>
      <setting id="id" value="3" />
     </configuration>
     <capabilities>
      <capability id="vmx" >CPU virtualization (Vanderpool)</capability>
      <capability id="ht" >HyperThreading</capability>
     </capabilities>
      <node id="logicalcpu:0" claimed="true" class="processor" handle="CPU:3.0">
       <description>Logical CPU</description>
       <physid>3.1</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:1" claimed="true" class="processor" handle="CPU:3.1">
       <description>Logical CPU</description>
       <physid>3.2</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:2" claimed="true" class="processor" handle="CPU:3.2">
       <description>Logical CPU</description>
       <physid>3.3</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
      <node id="logicalcpu:3" claimed="true" class="processor" handle="CPU:3.3">
       <description>Logical CPU</description>
       <physid>3.4</physid>
       <capabilities>
        <capability id="logical" >Logical CPU</capability>
       </capabilities>
      </node>
    </node>
    <node id="pci" claimed="true" class="bridge" handle="PCIBUS:0000:00">
     <description>Host bridge</description>
     <product>82X38/X48 Express DRAM Controller</product>
     <vendor>Intel Corporation</vendor>
     <physid>100</physid>
     <businfo>pci@0000:00:00.0</businfo>
     <version>01</version>
     <width units="bits">32</width>
     <clock units="Hz">33000000</clock>
      <node id="pci:0" claimed="true" class="bridge" handle="PCIBUS:0000:01">
       <description>PCI bridge</description>
       <product>82X38/X48 Express Host-Primary PCI Express Bridge</product>
       <vendor>Intel Corporation</vendor>
       <physid>1</physid>
       <businfo>pci@0000:00:01.0</businfo>
       <version>01</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="pcieport" />
       </configuration>
       <capabilities>
        <capability id="pci" />
        <capability id="pm" >Power Management</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="normal_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;24" />
        <resource type="ioport&quot; value=&quot;b000(size=4096)" />
        <resource type="memory&quot; value=&quot;fa000000-fe8fffff" />
        <resource type="ioport&quot; value=&quot;c0000000(size=536870912)" />
       </resources>
        <node id="display" class="display" handle="PCI:0000:01:00.0">
         <description>VGA compatible controller</description>
         <product>G98 [GeForce 8400 GS]</product>
         <vendor>nVidia Corporation</vendor>
         <physid>0</physid>
         <businfo>pci@0000:01:00.0</businfo>
         <version>a1</version>
         <width units="bits">64</width>
         <clock units="Hz">33000000</clock>
         <configuration>
          <setting id="latency" value="0" />
         </configuration>
         <capabilities>
          <capability id="pm" >Power Management</capability>
          <capability id="msi" >Message Signalled Interrupts</capability>
          <capability id="pciexpress" >PCI Express</capability>
          <capability id="vga_controller" />
          <capability id="bus_master" >bus mastering</capability>
          <capability id="cap_list" >PCI capabilities listing</capability>
         </capabilities>
         <resources>
          <resource type="memory&quot; value=&quot;fd000000-fdffffff" />
          <resource type="memory&quot; value=&quot;c0000000-dfffffff(prefetchable)" />
          <resource type="memory&quot; value=&quot;fa000000-fbffffff" />
          <resource type="ioport&quot; value=&quot;bc00(size=128)" />
          <resource type="memory&quot; value=&quot;fe8e0000-fe8fffff(prefetchable)" />
         </resources>
        </node>
      </node>
      <node id="usb:0" claimed="true" class="bus" handle="PCI:0000:00:1a.0">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB UHCI Controller #4</product>
       <vendor>Intel Corporation</vendor>
       <physid>1a</physid>
       <businfo>pci@0000:00:1a.0</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="uhci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="uhci" >Universal Host Controller Interface (USB1)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;16" />
        <resource type="ioport&quot; value=&quot;ac00(size=32)" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:3:1">
         <product>UHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp uhci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@3</businfo>
         <logicalname>usb3</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="2" />
          <setting id="speed" value="12.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-1.10" >USB 1.1</capability>
         </capabilities>
        </node>
      </node>
      <node id="usb:1" claimed="true" class="bus" handle="PCI:0000:00:1a.1">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB UHCI Controller #5</product>
       <vendor>Intel Corporation</vendor>
       <physid>1a.1</physid>
       <businfo>pci@0000:00:1a.1</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="uhci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="uhci" >Universal Host Controller Interface (USB1)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;21" />
        <resource type="ioport&quot; value=&quot;a880(size=32)" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:4:1">
         <product>UHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp uhci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@4</businfo>
         <logicalname>usb4</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="2" />
          <setting id="speed" value="12.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-1.10" >USB 1.1</capability>
         </capabilities>
        </node>
      </node>
      <node id="usb:2" claimed="true" class="bus" handle="PCI:0000:00:1a.2">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB UHCI Controller #6</product>
       <vendor>Intel Corporation</vendor>
       <physid>1a.2</physid>
       <businfo>pci@0000:00:1a.2</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="uhci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="uhci" >Universal Host Controller Interface (USB1)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;19" />
        <resource type="ioport&quot; value=&quot;a800(size=32)" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:5:1">
         <product>UHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp uhci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@5</businfo>
         <logicalname>usb5</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="2" />
          <setting id="speed" value="12.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-1.10" >USB 1.1</capability>
         </capabilities>
        </node>
      </node>
      <node id="usb:3" claimed="true" class="bus" handle="PCI:0000:00:1a.7">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB2 EHCI Controller #2</product>
       <vendor>Intel Corporation</vendor>
       <physid>1a.7</physid>
       <businfo>pci@0000:00:1a.7</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="ehci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="pm" >Power Management</capability>
        <capability id="debug" >Debug port</capability>
        <capability id="ehci" >Enhanced Host Controller Interface (USB2)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;18" />
        <resource type="memory&quot; value=&quot;f9fffc00-f9ffffff" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:1:1">
         <product>EHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp ehci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@1</businfo>
         <logicalname>usb1</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="6" />
          <setting id="speed" value="480.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-2.00" >USB 2.0</capability>
         </capabilities>
        </node>
      </node>
      <node id="multimedia" claimed="true" class="multimedia" handle="PCI:0000:00:1b.0">
       <description>Audio device</description>
       <product>82801I (ICH9 Family) HD Audio Controller</product>
       <vendor>Intel Corporation</vendor>
       <physid>1b</physid>
       <businfo>pci@0000:00:1b.0</businfo>
       <version>02</version>
       <width units="bits">64</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="HDA Intel" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="pm" >Power Management</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;32" />
        <resource type="memory&quot; value=&quot;f9ff8000-f9ffbfff" />
       </resources>
      </node>
      <node id="pci:1" claimed="true" class="bridge" handle="PCIBUS:0000:02">
       <description>PCI bridge</description>
       <product>82801I (ICH9 Family) PCI Express Port 1</product>
       <vendor>Intel Corporation</vendor>
       <physid>1c</physid>
       <businfo>pci@0000:00:1c.0</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="pcieport" />
       </configuration>
       <capabilities>
        <capability id="pci" />
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pm" >Power Management</capability>
        <capability id="normal_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;25" />
        <resource type="ioport&quot; value=&quot;c000(size=4096)" />
        <resource type="memory&quot; value=&quot;fe900000-fe9fffff" />
        <resource type="memory&quot; value=&quot;80000000-801fffff(prefetchable)" />
       </resources>
        <node id="ide" claimed="true" class="storage" handle="PCI:0000:02:00.0">
         <description>IDE interface</description>
         <product>88SE6121 SATA II Controller</product>
         <vendor>Marvell Technology Group Ltd.</vendor>
         <physid>0</physid>
         <businfo>pci@0000:02:00.0</businfo>
         <version>b2</version>
         <width units="bits">32</width>
         <clock units="Hz">33000000</clock>
         <configuration>
          <setting id="driver" value="pata_marvell" />
          <setting id="latency" value="0" />
         </configuration>
         <capabilities>
          <capability id="ide" />
          <capability id="pm" >Power Management</capability>
          <capability id="msi" >Message Signalled Interrupts</capability>
          <capability id="pciexpress" >PCI Express</capability>
          <capability id="bus_master" >bus mastering</capability>
          <capability id="cap_list" >PCI capabilities listing</capability>
         </capabilities>
         <resources>
          <resource type="irq&quot; value=&quot;16" />
          <resource type="ioport&quot; value=&quot;cc00(size=8)" />
          <resource type="ioport&quot; value=&quot;c880(size=4)" />
          <resource type="ioport&quot; value=&quot;c800(size=8)" />
          <resource type="ioport&quot; value=&quot;c480(size=4)" />
          <resource type="ioport&quot; value=&quot;c400(size=16)" />
          <resource type="memory&quot; value=&quot;fe9ffc00-fe9fffff" />
         </resources>
        </node>
      </node>
      <node id="pci:2" claimed="true" class="bridge" handle="PCIBUS:0000:03">
       <description>PCI bridge</description>
       <product>82801I (ICH9 Family) PCI Express Port 2</product>
       <vendor>Intel Corporation</vendor>
       <physid>1c.1</physid>
       <businfo>pci@0000:00:1c.1</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="pcieport" />
       </configuration>
       <capabilities>
        <capability id="pci" />
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pm" >Power Management</capability>
        <capability id="normal_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;26" />
        <resource type="ioport&quot; value=&quot;1000(size=4096)" />
        <resource type="memory&quot; value=&quot;80200000-803fffff" />
        <resource type="memory&quot; value=&quot;80400000-805fffff(prefetchable)" />
       </resources>
      </node>
      <node id="pci:3" claimed="true" class="bridge" handle="PCIBUS:0000:04">
       <description>PCI bridge</description>
       <product>82801I (ICH9 Family) PCI Express Port 3</product>
       <vendor>Intel Corporation</vendor>
       <physid>1c.2</physid>
       <businfo>pci@0000:00:1c.2</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="pcieport" />
       </configuration>
       <capabilities>
        <capability id="pci" />
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pm" >Power Management</capability>
        <capability id="normal_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;27" />
        <resource type="ioport&quot; value=&quot;2000(size=4096)" />
        <resource type="memory&quot; value=&quot;80600000-807fffff" />
        <resource type="memory&quot; value=&quot;80800000-809fffff(prefetchable)" />
       </resources>
      </node>
      <node id="pci:4" claimed="true" class="bridge" handle="PCIBUS:0000:05">
       <description>PCI bridge</description>
       <product>82801I (ICH9 Family) PCI Express Port 4</product>
       <vendor>Intel Corporation</vendor>
       <physid>1c.3</physid>
       <businfo>pci@0000:00:1c.3</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="pcieport" />
       </configuration>
       <capabilities>
        <capability id="pci" />
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pm" >Power Management</capability>
        <capability id="normal_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;28" />
        <resource type="ioport&quot; value=&quot;3000(size=4096)" />
        <resource type="memory&quot; value=&quot;80a00000-80bfffff" />
        <resource type="memory&quot; value=&quot;80c00000-80dfffff(prefetchable)" />
       </resources>
      </node>
      <node id="pci:5" claimed="true" class="bridge" handle="PCIBUS:0000:06">
       <description>PCI bridge</description>
       <product>82801I (ICH9 Family) PCI Express Port 5</product>
       <vendor>Intel Corporation</vendor>
       <physid>1c.4</physid>
       <businfo>pci@0000:00:1c.4</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="pcieport" />
       </configuration>
       <capabilities>
        <capability id="pci" />
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pm" >Power Management</capability>
        <capability id="normal_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;29" />
        <resource type="ioport&quot; value=&quot;d000(size=4096)" />
        <resource type="memory&quot; value=&quot;fea00000-feafffff" />
        <resource type="memory&quot; value=&quot;80e00000-80ffffff(prefetchable)" />
       </resources>
        <node id="network" claimed="true" class="network" handle="PCI:0000:06:00.0">
         <description>Ethernet interface</description>
         <product>RTL8111/8168B PCI Express Gigabit Ethernet controller</product>
         <vendor>Realtek Semiconductor Co., Ltd.</vendor>
         <physid>0</physid>
         <businfo>pci@0000:06:00.0</businfo>
         <logicalname>eth0</logicalname>
         <version>01</version>
         <serial>00:1d:92:9b:8c:bd</serial>
         <size>1000000000</size>
         <capacity>1000000000</capacity>
         <width units="bits">64</width>
         <clock units="Hz">33000000</clock>
         <configuration>
          <setting id="autonegotiation" value="on" />
          <setting id="broadcast" value="yes" />
          <setting id="driver" value="r8169" />
          <setting id="driverversion" value="2.3LK-NAPI" />
          <setting id="duplex" value="full" />
          <setting id="ip" value="192.168.1.150" />
          <setting id="latency" value="0" />
          <setting id="link" value="yes" />
          <setting id="multicast" value="yes" />
          <setting id="port" value="MII" />
          <setting id="speed" value="1GB/s" />
         </configuration>
         <capabilities>
          <capability id="pm" >Power Management</capability>
          <capability id="vpd" >Vital Product Data</capability>
          <capability id="msi" >Message Signalled Interrupts</capability>
          <capability id="pciexpress" >PCI Express</capability>
          <capability id="bus_master" >bus mastering</capability>
          <capability id="cap_list" >PCI capabilities listing</capability>
          <capability id="rom" >extension ROM</capability>
          <capability id="ethernet" />
          <capability id="physical" >Physical interface</capability>
          <capability id="tp" >twisted pair</capability>
          <capability id="mii" >Media Independant Interface</capability>
          <capability id="10bt" >10MB/s</capability>
          <capability id="10bt-fd" >10MB/s (full duplex)</capability>
          <capability id="100bt" >100MB/s</capability>
          <capability id="100bt-fd" >100MB/s (full duplex)</capability>
          <capability id="1000bt" >1GB/s</capability>
          <capability id="1000bt-fd" >1GB/s (full duplex)</capability>
          <capability id="autonegotiation" >Auto-negotiation</capability>
         </capabilities>
         <resources>
          <resource type="irq&quot; value=&quot;31" />
          <resource type="ioport&quot; value=&quot;d800(size=256)" />
          <resource type="memory&quot; value=&quot;feaff000-feafffff" />
          <resource type="memory&quot; value=&quot;feac0000-feadffff(prefetchable)" />
         </resources>
        </node>
      </node>
      <node id="pci:6" claimed="true" class="bridge" handle="PCIBUS:0000:07">
       <description>PCI bridge</description>
       <product>82801I (ICH9 Family) PCI Express Port 6</product>
       <vendor>Intel Corporation</vendor>
       <physid>1c.5</physid>
       <businfo>pci@0000:00:1c.5</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="pcieport" />
       </configuration>
       <capabilities>
        <capability id="pci" />
        <capability id="pciexpress" >PCI Express</capability>
        <capability id="msi" >Message Signalled Interrupts</capability>
        <capability id="pm" >Power Management</capability>
        <capability id="normal_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;30" />
        <resource type="ioport&quot; value=&quot;4000(size=4096)" />
        <resource type="memory&quot; value=&quot;81000000-811fffff" />
        <resource type="memory&quot; value=&quot;81200000-813fffff(prefetchable)" />
       </resources>
      </node>
      <node id="usb:4" claimed="true" class="bus" handle="PCI:0000:00:1d.0">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB UHCI Controller #1</product>
       <vendor>Intel Corporation</vendor>
       <physid>1d</physid>
       <businfo>pci@0000:00:1d.0</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="uhci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="uhci" >Universal Host Controller Interface (USB1)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;23" />
        <resource type="ioport&quot; value=&quot;a480(size=32)" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:6:1">
         <product>UHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp uhci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@6</businfo>
         <logicalname>usb6</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="2" />
          <setting id="speed" value="12.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-1.10" >USB 1.1</capability>
         </capabilities>
        </node>
      </node>
      <node id="usb:5" claimed="true" class="bus" handle="PCI:0000:00:1d.1">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB UHCI Controller #2</product>
       <vendor>Intel Corporation</vendor>
       <physid>1d.1</physid>
       <businfo>pci@0000:00:1d.1</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="uhci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="uhci" >Universal Host Controller Interface (USB1)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;19" />
        <resource type="ioport&quot; value=&quot;a400(size=32)" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:7:1">
         <product>UHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp uhci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@7</businfo>
         <logicalname>usb7</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="2" />
          <setting id="speed" value="12.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-1.10" >USB 1.1</capability>
         </capabilities>
          <node id="usb" claimed="true" class="input" handle="USB:7:3">
           <description>Mouse</description>
           <product>Optical Mouse</product>
           <vendor>Genius</vendor>
           <physid>2</physid>
           <businfo>usb@7:2</businfo>
           <version>1.00</version>
           <configuration>
            <setting id="driver" value="usbhid" />
            <setting id="maxpower" value="100mA" />
            <setting id="speed" value="1.5MB/s" />
           </configuration>
           <capabilities>
            <capability id="usb-1.10" >USB 1.1</capability>
           </capabilities>
          </node>
        </node>
      </node>
      <node id="usb:6" claimed="true" class="bus" handle="PCI:0000:00:1d.2">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB UHCI Controller #3</product>
       <vendor>Intel Corporation</vendor>
       <physid>1d.2</physid>
       <businfo>pci@0000:00:1d.2</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="uhci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="uhci" >Universal Host Controller Interface (USB1)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;18" />
        <resource type="ioport&quot; value=&quot;a080(size=32)" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:8:1">
         <product>UHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp uhci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@8</businfo>
         <logicalname>usb8</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="2" />
          <setting id="speed" value="12.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-1.10" >USB 1.1</capability>
         </capabilities>
        </node>
      </node>
      <node id="usb:7" claimed="true" class="bus" handle="PCI:0000:00:1d.7">
       <description>USB Controller</description>
       <product>82801I (ICH9 Family) USB2 EHCI Controller #1</product>
       <vendor>Intel Corporation</vendor>
       <physid>1d.7</physid>
       <businfo>pci@0000:00:1d.7</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="driver" value="ehci_hcd" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="pm" >Power Management</capability>
        <capability id="debug" >Debug port</capability>
        <capability id="ehci" >Enhanced Host Controller Interface (USB2)</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;23" />
        <resource type="memory&quot; value=&quot;f9fff800-f9fffbff" />
       </resources>
        <node id="usbhost" claimed="true" class="bus" handle="USB:2:1">
         <product>EHCI Host Controller</product>
         <vendor>Linux 2.6.33.4-smp ehci_hcd</vendor>
         <physid>1</physid>
         <businfo>usb@2</businfo>
         <logicalname>usb2</logicalname>
         <version>2.06</version>
         <configuration>
          <setting id="driver" value="hub" />
          <setting id="slots" value="6" />
          <setting id="speed" value="480.0MB/s" />
         </configuration>
         <capabilities>
          <capability id="usb-2.00" >USB 2.0</capability>
         </capabilities>
        </node>
      </node>
      <node id="pci:7" claimed="true" class="bridge" handle="PCIBUS:0000:08">
       <description>PCI bridge</description>
       <product>82801 PCI Bridge</product>
       <vendor>Intel Corporation</vendor>
       <physid>1e</physid>
       <businfo>pci@0000:00:1e.0</businfo>
       <version>92</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <capabilities>
        <capability id="pci" />
        <capability id="subtractive_decode" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="ioport&quot; value=&quot;e000(size=4096)" />
        <resource type="memory&quot; value=&quot;feb00000-febfffff" />
       </resources>
        <node id="firewire" claimed="true" class="bus" handle="PCI:0000:08:04.0">
         <description>FireWire (IEEE 1394)</description>
         <product>VT6306/7/8 [Fire II(M)] IEEE 1394 OHCI Controller</product>
         <vendor>VIA Technologies, Inc.</vendor>
         <physid>4</physid>
         <businfo>pci@0000:08:04.0</businfo>
         <version>c0</version>
         <width units="bits">32</width>
         <clock units="Hz">33000000</clock>
         <configuration>
          <setting id="driver" value="ohci1394" />
          <setting id="latency" value="64" />
          <setting id="maxlatency" value="32" />
         </configuration>
         <capabilities>
          <capability id="pm" >Power Management</capability>
          <capability id="ohci" >Open Host Controller Interface</capability>
          <capability id="bus_master" >bus mastering</capability>
          <capability id="cap_list" >PCI capabilities listing</capability>
         </capabilities>
         <resources>
          <resource type="irq&quot; value=&quot;20" />
          <resource type="memory&quot; value=&quot;febff800-febfffff" />
          <resource type="ioport&quot; value=&quot;ec00(size=128)" />
         </resources>
        </node>
      </node>
      <node id="isa" claimed="true" class="bridge" handle="PCI:0000:00:1f.0">
       <description>ISA bridge</description>
       <product>82801IR (ICH9R) LPC Interface Controller</product>
       <vendor>Intel Corporation</vendor>
       <physid>1f</physid>
       <businfo>pci@0000:00:1f.0</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="isa" />
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
      </node>
      <node id="ide:0" claimed="true" class="storage" handle="PCI:0000:00:1f.2">
       <description>IDE interface</description>
       <product>82801IR/IO/IH (ICH9R/DO/DH) 4 port SATA IDE Controller</product>
       <vendor>Intel Corporation</vendor>
       <physid>1f.2</physid>
       <businfo>pci@0000:00:1f.2</businfo>
       <logicalname>scsi2</logicalname>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">66000000</clock>
       <configuration>
        <setting id="driver" value="ata_piix" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="ide" />
        <capability id="pm" >Power Management</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
        <capability id="emulated" >Emulated device</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;19" />
        <resource type="ioport&quot; value=&quot;a000(size=8)" />
        <resource type="ioport&quot; value=&quot;9c00(size=4)" />
        <resource type="ioport&quot; value=&quot;9880(size=8)" />
        <resource type="ioport&quot; value=&quot;9800(size=4)" />
        <resource type="ioport&quot; value=&quot;9480(size=16)" />
        <resource type="ioport&quot; value=&quot;9400(size=16)" />
       </resources>
        <node id="disk" claimed="true" class="disk" handle="SCSI:02:00:00:00">
         <description>ATA Disk</description>
         <product>SAMSUNG HD321HJ</product>
         <physid>0.0.0</physid>
         <businfo>scsi@2:0.0.0</businfo>
         <logicalname>/dev/sda</logicalname>
         <dev>8:0</dev>
         <version>1AC0</version>
         <serial>S1L7J9BS624486</serial>
         <size units="bytes">320072933376</size>
         <configuration>
          <setting id="ansiversion" value="5" />
          <setting id="signature" value="10d110d0" />
         </configuration>
         <capabilities>
          <capability id="partitioned" >Partitioned disk</capability>
          <capability id="partitioned:dos" >MS-DOS partition table</capability>
         </capabilities>
          <node id="volume:0" claimed="true" class="volume" handle="">
           <description>EXT3 volume</description>
           <vendor>Linux</vendor>
           <physid>1</physid>
           <businfo>scsi@2:0.0.0,1</businfo>
           <logicalname>/dev/sda1</logicalname>
           <logicalname>/lfs</logicalname>
           <dev>8:1</dev>
           <version>1.0</version>
           <serial>411099a2-05eb-4e6d-a57d-c864a4ed5b3e</serial>
           <size>4005679104</size>
           <capacity>20012073984</capacity>
           <configuration>
            <setting id="created" value="2010-11-19 16:57:50" />
            <setting id="filesystem" value="ext3" />
            <setting id="modified" value="2011-01-10 16:35:43" />
            <setting id="mount.fstype" value="ext3" />
            <setting id="mount.options" value="rw,relatime,errors=continue,data=ordered" />
            <setting id="mounted" value="2011-01-10 16:35:43" />
            <setting id="state" value="mounted" />
           </configuration>
           <capabilities>
            <capability id="primary" >Primary partition</capability>
            <capability id="journaled" />
            <capability id="extended_attributes" >Extended Attributes</capability>
            <capability id="large_files" >4GB+ files</capability>
            <capability id="recover" >needs recovery</capability>
            <capability id="ext3" />
            <capability id="ext2" >EXT2/EXT3</capability>
            <capability id="initialized" >initialized volume</capability>
           </capabilities>
          </node>
          <node id="volume:1" claimed="true" class="volume" handle="">
           <description>EXT3 volume</description>
           <vendor>Linux</vendor>
           <physid>2</physid>
           <businfo>scsi@2:0.0.0,2</businfo>
           <logicalname>/dev/sda2</logicalname>
           <logicalname>/</logicalname>
           <dev>8:2</dev>
           <version>1.0</version>
           <serial>44b7dc70-6e76-4891-8db4-44ca63a69e55</serial>
           <size>128857235456</size>
           <capacity>128857236480</capacity>
           <configuration>
            <setting id="created" value="2010-11-23 11:40:42" />
            <setting id="filesystem" value="ext3" />
            <setting id="modified" value="2010-11-23 11:53:42" />
            <setting id="mount.fstype" value="ext3" />
            <setting id="mount.options" value="rw,relatime,errors=continue,data=ordered" />
            <setting id="mounted" value="2011-01-10 16:35:38" />
            <setting id="state" value="mounted" />
           </configuration>
           <capabilities>
            <capability id="primary" >Primary partition</capability>
            <capability id="bootable" >Bootable partition (active)</capability>
            <capability id="journaled" />
            <capability id="extended_attributes" >Extended Attributes</capability>
            <capability id="large_files" >4GB+ files</capability>
            <capability id="recover" >needs recovery</capability>
            <capability id="ext3" />
            <capability id="ext2" >EXT2/EXT3</capability>
            <capability id="initialized" >initialized volume</capability>
           </capabilities>
          </node>
          <node id="volume:2" claimed="true" class="volume" handle="">
           <description>Linux swap volume</description>
           <physid>3</physid>
           <businfo>scsi@2:0.0.0,3</businfo>
           <logicalname>/dev/sda3</logicalname>
           <dev>8:3</dev>
           <version>1</version>
           <serial>5462b8af-91cc-4ca6-98ca-59c47e6a4385</serial>
           <size>1085734912</size>
           <capacity>1085736960</capacity>
           <configuration>
            <setting id="filesystem" value="swap" />
            <setting id="pagesize" value="4096" />
           </configuration>
           <capabilities>
            <capability id="primary" >Primary partition</capability>
            <capability id="nofs" >No filesystem</capability>
            <capability id="swap" >Linux swap</capability>
            <capability id="initialized" >initialized volume</capability>
           </capabilities>
          </node>
        </node>
      </node>
      <node id="serial" class="bus" handle="PCI:0000:00:1f.3">
       <description>SMBus</description>
       <product>82801I (ICH9 Family) SMBus Controller</product>
       <vendor>Intel Corporation</vendor>
       <physid>1f.3</physid>
       <businfo>pci@0000:00:1f.3</businfo>
       <version>02</version>
       <width units="bits">64</width>
       <clock units="Hz">33000000</clock>
       <configuration>
        <setting id="latency" value="0" />
       </configuration>
       <resources>
        <resource type="memory&quot; value=&quot;f9fff400-f9fff4ff" />
        <resource type="ioport&quot; value=&quot;400(size=32)" />
       </resources>
      </node>
      <node id="ide:1" claimed="true" class="storage" handle="PCI:0000:00:1f.5">
       <description>IDE interface</description>
       <product>82801I (ICH9 Family) 2 port SATA IDE Controller</product>
       <vendor>Intel Corporation</vendor>
       <physid>1f.5</physid>
       <businfo>pci@0000:00:1f.5</businfo>
       <version>02</version>
       <width units="bits">32</width>
       <clock units="Hz">66000000</clock>
       <configuration>
        <setting id="driver" value="ata_piix" />
        <setting id="latency" value="0" />
       </configuration>
       <capabilities>
        <capability id="ide" />
        <capability id="pm" >Power Management</capability>
        <capability id="bus_master" >bus mastering</capability>
        <capability id="cap_list" >PCI capabilities listing</capability>
       </capabilities>
       <resources>
        <resource type="irq&quot; value=&quot;19" />
        <resource type="ioport&quot; value=&quot;9000(size=8)" />
        <resource type="ioport&quot; value=&quot;8c00(size=4)" />
        <resource type="ioport&quot; value=&quot;8880(size=8)" />
        <resource type="ioport&quot; value=&quot;8800(size=4)" />
        <resource type="ioport&quot; value=&quot;8480(size=16)" />
        <resource type="ioport&quot; value=&quot;8400(size=16)" />
       </resources>
      </node>
    </node>
  </node>
  <node id="network" disabled="true" claimed="true" class="network" handle="">
   <description>Ethernet interface</description>
   <physid>1</physid>
   <logicalname>vboxnet0</logicalname>
   <serial>0a:00:27:00:00:00</serial>
   <configuration>
    <setting id="broadcast" value="yes" />
    <setting id="multicast" value="yes" />
   </configuration>
   <capabilities>
    <capability id="ethernet" />
    <capability id="physical" >Physical interface</capability>
   </capabilities>
  </node>
</node>
"""

        r = self.p.xml_a_objeto(xml)
        self.assertTrue(r.slacktrack.user == 'foo')
        self.assertTrue(r.slacktrack.passwd == 'bar')
        self.assertTrue(r.core.cpu_0.serial == '0001-067A-0000-0000-0000-0000')
        self.assertTrue(r.core.pci.pci_5.network.serial == '00:1d:92:9b:8c:bd')
        self.assertTrue(r.core.pci.ide_0.disk.serial == 'S1L7J9BS624486')
        self.assertTrue(r.core.pci.ide_0.disk.volume_0.serial == '411099a2-05eb-4e6d-a57d-c864a4ed5b3e')
        self.assertTrue(r.core.pci.ide_0.disk.volume_1.serial == '44b7dc70-6e76-4891-8db4-44ca63a69e55')
        self.assertTrue(r.core.pci.ide_0.disk.volume_2.serial == '5462b8af-91cc-4ca6-98ca-59c47e6a4385')
        self.assertTrue(r.network.serial == '0a:00:27:00:00:00')

        xml = """<?xml version="1.0"?>
<catalog>
   <book id="bk101">
      <author>Gambardella, Matthew</author>
      <title>XML Developer's Guide</title>
      <genre>Computer</genre>
      <price>44.95</price>
      <publish_date>2000-10-01</publish_date>
      <description>An in-depth look at creating applications
      with XML.</description>
   </book>
   <book id="bk102">
      <author>Ralls, Kim</author>
      <title>Midnight Rain</title>
      <genre>Fantasy</genre>
      <price>5.95</price>
      <publish_date>2000-12-16</publish_date>
      <description>A former architect battles corporate zombies,
      an evil sorceress, and her own childhood to become queen
      of the world.</description>
   </book>
   <book id="bk103">
      <author>Corets, Eva</author>
      <title>Maeve Ascendant</title>
      <genre>Fantasy</genre>
      <price>5.95</price>
      <publish_date>2000-11-17</publish_date>
      <description>After the collapse of a nanotechnology
      society in England, the young survivors lay the
      foundation for a new society.</description>
   </book>
   <book id="bk104">
      <author>Corets, Eva</author>
      <title>Oberon's Legacy</title>
      <genre>Fantasy</genre>
      <price>5.95</price>
      <publish_date>2001-03-10</publish_date>
      <description>In post-apocalypse England, the mysterious
      agent known only as Oberon helps to create a new life
      for the inhabitants of London. Sequel to Maeve
      Ascendant.</description>
   </book>
   <book id="bk105">
      <author>Corets, Eva</author>
      <title>The Sundered Grail</title>
      <genre>Fantasy</genre>
      <price>5.95</price>
      <publish_date>2001-09-10</publish_date>
      <description>The two daughters of Maeve, half-sisters,
      battle one another for control of England. Sequel to
      Oberon's Legacy.</description>
   </book>
   <book id="bk106">
      <author>Randall, Cynthia</author>
      <title>Lover Birds</title>
      <genre>Romance</genre>
      <price>4.95</price>
      <publish_date>2000-09-02</publish_date>
      <description>When Carla meets Paul at an ornithology
      conference, tempers fly as feathers get ruffled.</description>
   </book>
   <book id="bk107">
      <author>Thurman, Paula</author>
      <title>Splish Splash</title>
      <genre>Romance</genre>
      <price>4.95</price>
      <publish_date>2000-11-02</publish_date>
      <description>A deep sea diver finds true love twenty
      thousand leagues beneath the sea.</description>
   </book>
   <book id="bk108">
      <author>Knorr, Stefan</author>
      <title>Creepy Crawlies</title>
      <genre>Horror</genre>
      <price>4.95</price>
      <publish_date>2000-12-06</publish_date>
      <description>An anthology of horror stories about roaches,
      centipedes, scorpions  and other insects.</description>
   </book>
   <book id="bk109">
      <author>Kress, Peter</author>
      <title>Paradox Lost</title>
      <genre>Science Fiction</genre>
      <price>6.95</price>
      <publish_date>2000-11-02</publish_date>
      <description>After an inadvertant trip through a Heisenberg
      Uncertainty Device, James Salway discovers the problems
      of being quantum.</description>
   </book>
   <book id="bk110">
      <author>O'Brien, Tim</author>
      <title>Microsoft .NET: The Programming Bible</title>
      <genre>Computer</genre>
      <price>36.95</price>
      <publish_date>2000-12-09</publish_date>
      <description>Microsoft's .NET initiative is explored in
      detail in this deep programmer's reference.</description>
   </book>
   <book id="bk111">
      <author>O'Brien, Tim</author>
      <title>MSXML3: A Comprehensive Guide</title>
      <genre>Computer</genre>
      <price>36.95</price>
      <publish_date>2000-12-01</publish_date>
      <description>The Microsoft MSXML3 parser is covered in
      detail, with attention to XML DOM interfaces, XSLT processing,
      SAX and more.</description>
   </book>
   <book id="bk112">
      <author>Galos, Mike</author>
      <title>Visual Studio 7: A Comprehensive Guide</title>
      <genre>Computer</genre>
      <price>49.95</price>
      <publish_date>2001-04-16</publish_date>
      <description>Microsoft Visual Studio 7 is explored in depth,
      looking at how Visual Basic, Visual C++, C#, and ASP+ are
      integrated into a comprehensive development
      environment.</description>
   </book>
</catalog>
"""

        r = self.p.xml_a_objeto(xml)
        self.assertTrue(r.bk101.title == "XML Developer's Guide")
        self.assertTrue(r.bk102.author == "Ralls, Kim")
        self.assertTrue(r.bk103.genre == "Fantasy")
        self.assertTrue(r.bk104.price == "5.95")


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestParserXML))
    return suite
