# -*- coding: utf-8 -*-

import unittest

from at.utiles.password import Password


class TestPassword(unittest.TestCase):

    def setUp(self):
        self.p = Password()

    def test_generar_password(self):
        r = self.p.generar_password()
        self.assertTrue(isinstance(r, str))
        self.assertTrue(len(r) == 12)

    def test_generar_numero(self):
        # Le paso con un mínimo de caracteres
        max_num = 110
        min_num = 90
        min_caracteres = 5
        rta = self.p.generar_numero(max_num, min_num, min_caracteres)
        self.assertTrue(isinstance(rta, str))
        self.assertTrue(len(rta) == 5)

        # Solo le paso el número máximo
        max_num = 10
        rta = self.p.generar_numero(max_num)
        self.assertTrue(isinstance(rta, int))

        # Le paso un mínimo y un máximo
        max_num = 200
        min_num = 100
        rta = self.p.generar_numero(max_num, min_num)
        self.assertTrue(isinstance(rta, int))
        self.assertTrue(len(str(rta)) == 3)

        # Le paso con un mínimo de caracteres pero con un máximo y un mínimo
        # en el rango de 4 caracteres
        max_num = 4999
        min_num = 1000
        min_caracteres = 4
        rta = self.p.generar_numero(max_num, min_num, min_caracteres)
        self.assertTrue(isinstance(rta, str))
        self.assertTrue(len(rta) == 4)

        # Le paso con un mínimo de caracteres de 3
        # pero con un máximo y un mínimo en el rango de 4 caracteres
        max_num = 4999
        min_num = 1000
        min_caracteres = 3
        rta = self.p.generar_numero(max_num, min_num, min_caracteres)
        self.assertTrue(isinstance(rta, str))
        self.assertTrue(len(rta) == 4)


def suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestPassword))
    return suite
