# -*- coding: utf-8 -*-

import unittest
import datetime

from at.utiles import _
from at.utiles import validar


class TestValidar(unittest.TestCase):

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_no_vacio(self):
        # Le paso un entero
        valor = 5
        v = validar.no_vacio(valor)
        self.assertTrue(v['Estado'])
        # Le paso vacio
        valor = ''
        v = validar.no_vacio(valor)
        self.assertTrue(v['Estado'] is False)
        # Le paso None
        valor = None
        v = validar.no_vacio(valor)
        self.assertTrue(v['Estado'] is False)

    def test_numero(self):
        # le paso un entero.
        valor = 5
        v = validar.numero(valor)
        self.assertTrue(v['Estado'])
        # Le paso vacio.
        valor = ''
        v = validar.numero(valor)
        self.assertTrue(v['Estado'] is False)
        # Le paso None.
        valor = None
        v = validar.numero(valor)
        self.assertTrue(v['Estado'] is False)
        # Le paso un string.
        valor = 'asd'
        v = validar.numero(valor)
        self.assertTrue(v['Estado'] is False)
        # Le paso un float.
        valor = 5.2
        v = validar.numero(valor)
        self.assertTrue(v['Estado'])
        # Le paso un float negativo.
        valor = -5.2
        v = validar.numero(valor)
        self.assertTrue(v['Estado'])
        # Le paso un bool.
        valor = True
        v = validar.numero(valor)
        self.assertTrue(v['Estado'] is False)

    def test_lista_valores_no_vacio(self):
        # le paso una lista vacia.
        valores = []
        v = validar.lista_valores_no_vacio(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un string.
        valores = [5, 'asd']
        v = validar.lista_valores_no_vacio(valores)
        self.assertTrue(v['Estado'])
        # Le paso un entero y un negativo
        valores = [5, -19]
        v = validar.lista_valores_no_vacio(valores)
        self.assertTrue(v['Estado'])
        # entero None y string
        valores = [5, None, 'asd']
        v = validar.lista_valores_no_vacio(valores)
        self.assertTrue(v['Estado'] is False)
        # Vacio
        valores = [5, '', 'asd']
        v = validar.lista_valores_no_vacio(valores)
        self.assertTrue(v['Estado'] is False)

    def test_lista_valores_numero(self):
        # le paso una lista vacia.
        valores = []
        v = validar.lista_valores_no_vacio(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un string.
        valores = [5, 'asd']
        v = validar.lista_valores_numero(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y None.
        valores = [5, None]
        v = validar.lista_valores_numero(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y vacio.
        valores = [5, '']
        v = validar.lista_valores_numero(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un float.
        valores = [5, 5.6]
        v = validar.lista_valores_numero(valores)
        self.assertTrue(v['Estado'])
        # le paso un entero y un negativo.
        valores = [5, -5.6]
        v = validar.lista_valores_numero(valores)
        self.assertTrue(v['Estado'])

    def test_string(self):
        # le paso un entero.
        valor = 5
        v = validar.string(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso un string.
        valor = 'asd'
        v = validar.string(valor)
        self.assertTrue(v['Estado'])
        # Le paso un bool
        valor = True
        v = validar.string(valor)
        self.assertTrue(v['Estado'] is False)
        # Le paso none
        valor = None
        v = validar.string(valor)
        self.assertTrue(v['Estado'] is False)
        # Le paso vacio
        valor = ''
        v = validar.string(valor)
        self.assertTrue(v['Estado'] is False)

    def test_lista_valores_string(self):
        # le paso una lista vacia.
        valores = []
        v = validar.lista_valores_string(valores)
        self.assertTrue(v['Estado'] is False)
        # lista con un entero
        valores = [5]
        v = validar.lista_valores_string(valores)
        self.assertTrue(v['Estado'] is False)
        # lista con entero y string
        valores = [5, 'string']
        v = validar.lista_valores_string(valores)
        self.assertTrue(v['Estado'] is False)
        # Bool y string
        valores = [True, 'string']
        v = validar.lista_valores_string(valores)
        self.assertTrue(v['Estado'] is False)
        # String
        valores = ['algo', 'string']
        v = validar.lista_valores_string(valores)
        self.assertTrue(v['Estado'])

    def test_numero_positivo(self):
        # le paso un numero negativo.
        valor = -9
        v = validar.numero_positivo(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso un string.
        valor = 'asd'
        v = validar.numero_positivo(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso vacio.
        valor = ''
        v = validar.numero_positivo(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso un bool.
        valor = False
        v = validar.numero_positivo(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso un numero postivo float.
        valor = 56.6
        v = validar.numero_positivo(valor)
        self.assertTrue(v['Estado'])
        # le paso un numero postivo.
        valor = 965874112366544
        v = validar.numero_positivo(valor)
        self.assertTrue(v['Estado'])

    def test_lista_valores_numero_positivo(self):
        # le paso una lista vacia.
        valores = []
        v = validar.lista_valores_numero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un string.
        valores = [5, 'asd']
        v = validar.lista_valores_numero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y None.
        valores = [5, None]
        v = validar.lista_valores_numero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y vacio.
        valores = [5, '']
        v = validar.lista_valores_numero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un float.
        valores = [5, 5.6]
        v = validar.lista_valores_numero_positivo(valores)
        self.assertTrue(v['Estado'])
        # le paso un entero y un negativo.
        valores = [5, -5.6]
        v = validar.lista_valores_numero_positivo(valores)
        self.assertTrue(v['Estado'] is False)

    def test_numero_entero(self):
        # le paso un numero entero negativo.
        valor = -9
        v = validar.numero_entero(valor)
        self.assertTrue(v['Estado'])
        # le paso un string.
        valor = 'asd'
        v = validar.numero_entero(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso vacio.
        valor = ''
        v = validar.numero_entero(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso un bool.
        valor = False
        v = validar.numero_entero(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso un numero postivo float.
        valor = 56.6
        v = validar.numero_entero(valor)
        self.assertTrue(v['Estado'] is False)
        # le paso un numero entero positivo.
        valor = 9658741
        v = validar.numero_entero(valor)
        self.assertTrue(v['Estado'])

    def test_numero_entero_positivo(self):
        # le paso un numero entero negativo.
        valor = -9
        v = validar.numero_entero_positivo(valor)
        self.assertTrue(v['Estado'] is False)

        # le paso un numero entero positivo.
        valor = 9
        v = validar.numero_entero_positivo(valor)
        self.assertTrue(v['Estado'] is True)

        # le paso un numero con coma.
        valor = 9.2
        v = validar.numero_entero_positivo(valor)
        self.assertTrue(v['Estado'] is False)

        # le paso un 0.
        valor = 0
        v = validar.numero_entero_positivo(valor)
        self.assertTrue(v['Estado'] is False)

        # le paso un 0.
        valor = 0
        v = validar.numero_entero_positivo(valor, incluye_cero=True)
        self.assertTrue(v['Estado'] is True)

    def test_lista_numero_entero_positivo(self):
        # le paso una lista vacia.
        valores = []
        v = validar.lista_numero_entero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un string.
        valores = [5, 'asd']
        v = validar.lista_numero_entero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y None.
        valores = [5, None]
        v = validar.lista_numero_entero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y vacio.
        valores = [5, '']
        v = validar.lista_numero_entero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un float.
        valores = [5, 5.6]
        v = validar.lista_numero_entero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso un entero y un negativo.
        valores = [5, -5.6]
        v = validar.lista_numero_entero_positivo(valores)
        self.assertTrue(v['Estado'] is False)
        # le paso 2 enteros positivos.
        valores = [5, 8]
        v = validar.lista_numero_entero_positivo(valores)
        self.assertTrue(v['Estado'])

    def test_dic_con_datos(self):
        # Caso correcto
        valor = {}
        valor['nombre'] = 'Juan'
        valor['apellido'] = 'Rivas'
        rta = validar.dic_con_datos(valor)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato es un diccionario con llaves y datos.')
        )

        # Le paso un diccionario vacío
        valor = {}
        rta = validar.dic_con_datos(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe tener llaves.')
        )

        # Le paso un string
        valor = 'no es un diccionario'
        rta = validar.dic_con_datos(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser un diccionario.')
        )

        # Le paso un diccionario con llaves pero son datos
        valor = {}
        valor['nombre'] = None
        valor['apellido'] = None
        rta = validar.dic_con_datos(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato tiene llaves sin datos.')
        )

        # Le paso un diccionario con llaves y un solo dato
        valor = {}
        valor['nombre'] = None
        valor['apellido'] = 'SoloApellido'
        rta = validar.dic_con_datos(valor)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato es un diccionario con llaves y datos.')
        )

    def test_usuario(self):
        valor = 'joni'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'jo'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'jon'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = '_jon-'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = '_jon1234567891234567'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = '_jon12345678912345678'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = '_jon -'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'Joni'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'JonatanGarcia'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'Jonatan Garcia'
        rta = validar.usuario(valor)
        self.assertTrue(rta['Estado'] is False)

    def test_nombre(self):
        valor = 'joni'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = ' joni'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'joni garcia'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'Joni Garcia'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'Joni Garcia Schaff'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'Joni García'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'JONI GARCÍA'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'JONI GARCÍA 3'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'JONI_GARCÍA'
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = "joni's"
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = "js"
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = "jsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjsjs"
        rta = validar.nombre(valor)
        self.assertTrue(rta['Estado'] is False)

    def test_clave(self):
        valor = 'joni'
        rta = validar.clave(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'jonigarcia'
        rta = validar.clave(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'TrackLong'
        rta = validar.clave(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'adasjkdnask asdasdasda'
        rta = validar.clave(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'adasadasadasadasadasadasadasadasadasadasadasadasadasadasadas'
        rta = validar.clave(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 64
        nombre_dato = 'password'
        rta = validar.clave(valor, nombre_dato)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato "password" debe ser un string.')
        )

    def test_email(self):
        valor = 'joni'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'joni@joni.com'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'joni_garcia@joni.com'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'joni_garcia@joni.com.ar'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'joni_garcia@@joni.com.ar'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'joni_garcia_93@joni.com.ar'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'joni_garcia_93@joni5254122ssd.com.ar'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'joni_garcia_93@joni5254122ssd.com52118.arararar'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = '@joni5254122ssd.com52118.arararar'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'joni_garcia@'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'joni@joni'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'joni@joni.'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'Joni@joni.'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is False)

        valor = 'Joni@joni.com'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'JONATAN@GARCIA.com'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'joni.garcia@hotmail.com'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

        valor = 'joni.garcia.schaff@live.com.ar'
        rta = validar.email(valor)
        self.assertTrue(rta['Estado'] is True)

    def test_fecha_min(self):
        # Le paso un datetime válido
        fecha = datetime.datetime(2017, 10, 27, 15, 26, 31)
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato es una fecha válida')
        )

        # Le paso un date válido
        fecha = datetime.date(2017, 10, 27)
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

        # Le paso un date str con formato date
        fecha = '2017-10-27'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

        # Le paso un date str con formato datetime
        fecha = '2017-10-27 15:49:43'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

        # Le paso un str sin formato de fecha
        fecha = 'asd'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no es una fecha válida')
        )

        # Le paso un str con un formato de fecha inválido
        fecha = '27/10/2017 16:01:08'
        nombre_dato = 'fecha de ingreso'
        rta = validar.fecha_min(fecha, nombre_dato)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato "fecha de ingreso" no es una fecha válida')
        )

        # Le paso un str con un formato de fecha inválido
        fecha = '27/10/2017'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no es una fecha válida')
        )

        # Le paso un str vacío
        fecha = ''
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no es una fecha válida')
        )

        # Le paso cualquier dato
        fecha = True
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no es una fecha válida')
        )

        # Le paso None
        fecha = None
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no es una fecha válida')
        )

        # Le paso un número
        fecha = 2017
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no es una fecha válida')
        )

        # Le paso un datetime válido
        fecha = datetime.datetime(2017, 10, 27, 0, 0, 0)
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

        # Le paso un datetime válido
        fecha = datetime.datetime(2017, 10, 27)
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

        # Le paso un date válido
        fecha = datetime.date(1900, 1, 1)
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

        # Le paso un date menor a 1900-01-01
        fecha = datetime.date(1899, 1, 1)
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no puede ser menor a 1900-01-01')
        )

        # Le paso un datetime menor a 1900-01-01
        fecha = datetime.datetime(1899, 1, 1, 16, 19, 40)
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no puede ser menor a 1900-01-01')
        )

        # Le paso un str menor a 1900-01-01
        fecha = '1899-01-01'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no puede ser menor a 1900-01-01')
        )

        # Le paso un str menor a 1900-01-01
        fecha = '1800-05-20 16:23:08'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no puede ser menor a 1900-01-01')
        )

        # Le paso un str igual a 1900-01-01
        fecha = '1900-01-01'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

        # Le paso un str igual a 1900-01-01
        fecha = '1900-01-01 00:00:00'
        rta = validar.fecha_min(fecha)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una fecha válida'))

    def test_es_lista(self):
        # Caso correcto
        lista = [5, 9, 'asd', True, [1, 'qwe'], None]
        rta = validar.es_lista(lista)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una lista'))

        # Le paso un dato que no es una lista
        lista = '[]'
        rta = validar.es_lista(lista)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(rta['Respuesta'] == _(u'El dato debe ser una lista'))

        # Le paso un dato que no es una lista
        lista = 0
        rta = validar.es_lista(lista)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(rta['Respuesta'] == _(u'El dato debe ser una lista'))

        # Le paso un dato que no es una lista
        lista = {}
        rta = validar.es_lista(lista)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(rta['Respuesta'] == _(u'El dato debe ser una lista'))

        # Le paso un dato que no es una lista
        lista = None
        rta = validar.es_lista(lista)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(rta['Respuesta'] == _(u'El dato debe ser una lista'))

        # Le paso una lista vacía
        lista = []
        rta = validar.es_lista(lista)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una lista'))

        # Le paso una lista vacía pero exijo un mínimo de elementos
        lista = []
        min_elementos = 2
        rta = validar.es_lista(lista, min_elementos)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser una lista con un mínimo de 2 elementos')
        )

        # Le paso una lista con 2 elementos pero el mínimo es 3
        lista = [5, 88]
        min_elementos = 3
        rta = validar.es_lista(lista, min_elementos)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser una lista con un mínimo de 3 elementos')
        )

        # Le paso una lista con 3 elementos y el mínimo es 3
        lista = [5, 88, 19]
        min_elementos = 3
        rta = validar.es_lista(lista, min_elementos)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una lista'))

        # Le paso una lista con 6 elementos y el mínimo es 3 pero el máximo es 4
        lista = [5, 88, 19, 71, 0, 63]
        min_elementos = 3
        max_elementos = 4
        rta = validar.es_lista(lista, min_elementos, max_elementos)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser una lista con un máximo de 4 elementos')
        )

        # Le paso una lista con 6 elementos y el mínimo es 3 y el máximo es 6
        lista = [5, 88, 19, 71, 0, 63]
        min_elementos = 3
        max_elementos = 6
        rta = validar.es_lista(lista, min_elementos, max_elementos)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una lista'))

        # Le paso una lista con 6 elementos y el mínimo es 3 y el máximo es 10
        lista = [5, 88, 19, 71, 0, 63]
        min_elementos = 3
        max_elementos = 10
        rta = validar.es_lista(lista, min_elementos, max_elementos)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es una lista'))

        # Le paso el nombre del dato
        lista = '[5, 88, 19, 71, 0, 63]'
        nombre_dato = 'numeros'
        rta = validar.es_lista(lista, nombre_dato=nombre_dato)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato "numeros" debe ser una lista')
        )

    def test_numero_entre(self):
        # Caso correcto
        valor = 5
        num_minimo = 1
        num_maximo = 7
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato está entre 1 y 7'))

        # Le paso un número mayor
        valor = 8
        num_minimo = 1
        num_maximo = 7
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser mayor o igual que 1 y menor o igual que 7')
        )

        # Le paso un número menor
        valor = 0
        num_minimo = 1
        num_maximo = 7
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser mayor o igual que 1 y menor o igual que 7')
        )

        # Le paso un número igual al menor
        valor = 1
        num_minimo = 1
        num_maximo = 7
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato está entre 1 y 7'))

        # Le paso un número igual al mayor
        valor = 7
        num_minimo = 1
        num_maximo = 7
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato está entre 1 y 7'))

        # Valido entre 0 y 1
        valor = 0
        num_minimo = 0
        num_maximo = 1
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato está entre 0 y 1'))

        # Valido entre 0 y 1
        valor = 1
        num_minimo = 0
        num_maximo = 1
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato está entre 0 y 1'))

        # Le paso un número negativo menor al mínimo
        valor = -1
        num_minimo = 0
        num_maximo = 1
        nombre_dato = 'encendido'
        rta = validar.numero_entre(valor, num_minimo, num_maximo, nombre_dato)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato "encendido" debe ser mayor o igual que 0 y menor o igual que 1')
        )

        # No le paso un número
        valor = '15'
        num_minimo = 1
        num_maximo = 30
        nombre_dato = 'mes'
        rta = validar.numero_entre(valor, num_minimo, num_maximo, nombre_dato)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato "mes" debe ser un número.')
        )

        # Le paso mal el dato de comparación
        valor = 15
        num_minimo = []
        num_maximo = 30
        rta = validar.numero_entre(valor, num_minimo, num_maximo)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato "num_minimo" debe ser un número.')
        )

    def test_horario(self):
        # Caso correcto
        valor = '17:08'
        rta = validar.horario(valor)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es un horario válido'))

        # Caso correcto
        valor = '17:08:44'
        rta = validar.horario(valor)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(rta['Respuesta'] == _(u'El dato es un horario válido'))

        # Le paso un horario incorrecto
        valor = '25:69:81'
        rta = validar.horario(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser un horario válido')
        )

        # Le paso un horario incorrecto
        valor = '21:75'
        rta = validar.horario(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser un horario válido')
        )

        # Le paso un horario incorrecto
        valor = '21:10:99'
        rta = validar.horario(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser un horario válido')
        )

        # Le paso cualquier dato
        valor = 'asd'
        rta = validar.horario(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser un horario válido')
        )

        # No le paso un string
        valor = 23
        rta = validar.horario(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser un string.')
        )

    def test_fecha_hora_str(self):
        # Caso correcto
        valor = '2018-12-27 13:26:06'
        rta = validar.fecha_hora_str(valor)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato es una fecha y hora válida')
        )

        # Paso mal el formato de la fecha y hora
        valor = '27/12/2018 13:26:06'
        rta = validar.fecha_hora_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser una fecha y hora válida')
        )

        # Paso solo la fecha
        valor = '2018-12-27'
        rta = validar.fecha_hora_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser una fecha y hora válida')
        )

        # Paso None como fecha y hora
        valor = None
        rta = validar.fecha_hora_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser una fecha y hora válida')
        )

        # Paso una fecha que no existe
        valor = '2018-12-32 13:26:06'
        rta = validar.fecha_hora_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser una fecha y hora válida')
        )

        # Paso una fecha que no existe
        valor = '2018-13-26 13:26:06'
        rta = validar.fecha_hora_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser una fecha y hora válida')
        )

        # Paso una fecha que no existe
        valor = '2018-12-26 25:26:06'
        rta = validar.fecha_hora_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser una fecha y hora válida')
        )

    def test_fecha_str(self):
        # Caso correcto
        valor = '2018-12-27'
        rta = validar.fecha_str(valor)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato es un string con formato de fecha')
        )

        # Le paso una fecha que no existe
        valor = '2018-00-27'
        rta = validar.fecha_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser un string con formato de fecha')
        )

        # Le paso un date, debe ser un str
        valor = datetime.date(2019, 2, 22)
        rta = validar.fecha_str(valor)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser un string con formato de fecha')
        )

    def test_llaves(self):
        # Caso correcto
        dic = {}
        dic['telefono'] = '4110549'
        dic['dni'] = 33228899
        nombres_llaves = ['telefono', 'dni']
        rta = validar.llaves(dic, nombres_llaves)
        self.assertTrue(rta['Estado'] is True)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato tiene todas las llaves dadas')
        )

        # Le paso mal las llaves
        dic = {}
        dic['telefono'] = '4110549'
        dic['dni'] = 33228899
        nombres_llaves = ['asd', 'dni']
        rta = validar.llaves(dic, nombres_llaves)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no tiene la llave "asd"')
        )

        # No le paso un diccionario
        dic = '{}'
        nombres_llaves = ['asd', 'dni']
        rta = validar.llaves(dic, nombres_llaves)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato debe ser un diccionario.')
        )

        # Le paso una lista vacía
        dic = {}
        dic['telefono'] = '4110549'
        dic['dni'] = 33228899
        nombres_llaves = []
        rta = validar.llaves(dic, nombres_llaves)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] ==
            _(u'El dato debe ser una lista con un mínimo de 1 elementos')
        )

        # Le paso mal las llaves del diccionario
        dic = {}
        dic['telefono'] = '4110549'
        dic['dni'] = 33228899
        nombres_llaves = [5]
        rta = validar.llaves(dic, nombres_llaves)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no tiene la llave "5"')
        )

        # Le paso mal las llaves del diccionario
        dic = {}
        dic['telefono'] = '4110549'
        dic['dni'] = 33228899
        nombres_llaves = [None]
        rta = validar.llaves(dic, nombres_llaves)
        self.assertTrue(rta['Estado'] is False)
        self.assertTrue(
            rta['Respuesta'] == _(u'El dato no tiene la llave "None"')
        )


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestValidar))
    return suite
