# -*- coding: utf-8 -*-

import unittest
import os

from at.utiles.variables_locales import VariablesLocales


class TestVariablesLocales(unittest.TestCase):

    def setUp(self):
        # creo un archivo de pruebas con una variable
        vl = VariablesLocales()

        variable = True

        self.frula = os.path.join(os.path.expanduser('~'), 'prueba.py')
        self.ruta = self.frula
        # self.ruta = '/home/paco/prueba.py'

        # caso correcto
        r = vl.grabar_variables_locales(variable, self.ruta)
        self.assertTrue(r['Estado'] is True)
        self.assertTrue(r['Mensaje'] is None)

    def tearDown(self):
        os.remove(self.ruta)

    def test_grabar_variables_locales(self):
        vl = VariablesLocales()

        variable = {}
        variable['VerNombreEnLugarDeObservacion'] = 1
        variable['IdMapa'] = 1
        # impresoras
        variable['ImpresoraInformes'] = 'nombre de la impresora para informes'
        variable['ImpresoraFacturacion'] = 'nombre de la impresora para facturar'
        variable['ImpresoraDOS'] = 'nombre de la impresora DOS'
        variable['ModeloImpresoraDOS'] = 'modelo de la impresora DOS'

        # caso correcto
        r = vl.grabar_variables_locales(variable, self.ruta)
        self.assertTrue(r['Estado'] is True)
        self.assertTrue(r['Mensaje'] is None)

    def test_cargar_variables_locales(self):
        vl = VariablesLocales()

        r = vl.cargar_variables_locales(self.ruta)
        self.assertTrue(r['Estado'] is True)
        self.assertTrue(r['Variable'] is not None)

        # le paso mal la ruta
        ruta = '/home/asdqwerty/asd.py'

        r = vl.cargar_variables_locales(ruta)
        self.assertTrue(r['Estado'] is False)
        self.assertTrue(r['Mensaje'] is not None)


def test_suite():
    from unittest import TestSuite
    from unittest import makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestVariablesLocales))
    return suite
