# -*- coding: utf-8 -*-

from sqlalchemy import *
from sqlalchemy.dialects.mysql.base import *

from at.orm.models import BaseModel



# INTEGER()

class CpBotModel(BaseModel):
    model_type = ''
    metadata = MetaData()
    modelmetadata = metadata
    bd = ''

    tipos_accion = Table('tipos_accion', metadata,
                         Column(u'tipos_accion', Integer, primary_key=True, nullable=False),
                         Column(u'nombre_accion', VARCHAR(length=50, convert_unicode=False,
                                                          unicode_error=None, _warn_on_bytestring=False),
                                primary_key=False,
                                nullable=False),
                         Column(u'modo', Integer, primary_key=False, nullable=False, server_default='1'),
                         Column('estado_dia', Integer, primary_key=False, nullable=False, server_default='0'),
                         Column('mensaje', VARCHAR(length=250, convert_unicode=False,
                                                   unicode_error=None,
                                                   _warn_on_bytestring=False), primary_key=False, nullable=False),
                         schema=bd)

    logs = Table('logs', metadata,
                 Column(u'id_log', INTEGER(), primary_key=True, nullable=False,
                        autoincrement=True),

                 Column(u'id_charla', INTEGER(), primary_key=True, nullable=False),

                 Column(u'telefono_empresa', VARCHAR(length=50, convert_unicode=False,
                                                     unicode_error=None,
                                                     _warn_on_bytestring=False), primary_key=True, nullable=False),
                 Column(u'id_empresa', INTEGER(), primary_key=True, nullable=False),

                 Column(u'nombre_accion', VARCHAR(length=50, convert_unicode=False,
                                                  unicode_error=None,
                                                  _warn_on_bytestring=False), primary_key=True, nullable=False),

                 Column(u'dato', VARCHAR(length=100, convert_unicode=False,
                                         unicode_error=None,
                                         _warn_on_bytestring=False), primary_key=False, nullable=True),

                 Column(u'mensaje_recibido', VARCHAR(length=100, convert_unicode=False,
                                                     unicode_error=None,
                                                     _warn_on_bytestring=False), primary_key=False,
                        nullable=True),
                 Column(u'mensaje_enviado', VARCHAR(length=100, convert_unicode=False,
                                                    unicode_error=None,
                                                    _warn_on_bytestring=False), primary_key=False,
                        nullable=True),

                 Column(u'estado', VARCHAR(length=100, convert_unicode=False,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=False, nullable=True),
                 Column(u'info_salvada', BOOLEAN,nullable=True),

                 Column(u'fecha_hora', TIMESTAMP(timezone=False), primary_key=False,
                        nullable=True),

                 Column(u'fecha_hora_respuesta', TIMESTAMP(timezone=False),
                        primary_key=False,
                        nullable=True),

                 Column(u'seleccionado', INTEGER(),
                        primary_key=False,
                        nullable=True),

                 Column(u'telefono_cliente', VARCHAR(length=50, convert_unicode=False,
                                                     unicode_error=None,
                                                     _warn_on_bytestring=False), primary_key=False,
                        nullable=False),
                 schema=bd
                 )
    tags = Table('tags', metadata,
                 Column(u'id_tag', VARCHAR(length=50, convert_unicode=False,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=True, nullable=False),
                 Column(u'tag', VARCHAR(length=50, convert_unicode=False,
                                        unicode_error=None,
                                        _warn_on_bytestring=False), primary_key=False, nullable=False),
                 Column(u'texto', VARCHAR(length=50, convert_unicode=False,
                                          unicode_error=None,
                                          _warn_on_bytestring=False), primary_key=False, nullable=False),
                 Column(u'accion', VARCHAR(length=50, convert_unicode=False,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=False, nullable=False),
                 schema=bd
                 )

    estados_mensaje = Table('estados_mensaje', metadata,
                            Column(u'id', INTEGER(), primary_key=True,
                                   nullable=False, autoincrement=False),
                            Column(u'nombre', VARCHAR(length=50, convert_unicode=False,
                                                      unicode_error=None,
                                                      _warn_on_bytestring=False), primary_key=False, nullable=False),
                            schema=bd
                            )

    tipos_mensaje = Table('tipos_mensaje', metadata,



                          Column(u'id', INTEGER(), primary_key=True,
                                 nullable=False, autoincrement=False),
                          Column(u'nombre', VARCHAR(length=50, convert_unicode=False,
                                                    unicode_error=None,
                                                    _warn_on_bytestring=False), primary_key=False, nullable=False),
                          schema=bd
                          )

    parametros = Table('parametros', metadata,
                       Column(u'telefono', VARCHAR(length=50, convert_unicode=False,
                                                   unicode_error=None,
                                                   _warn_on_bytestring=False), primary_key=True, nullable=False),

                       Column(u'id_sucursal', INTEGER(), primary_key=False, nullable=True,
                              autoincrement=False, server_default='1'),

                       Column(u'automatico', INTEGER(), primary_key=False, nullable=True,
                              autoincrement=False, server_default='0'),

                       Column(u'modo', INTEGER(), primary_key=False, nullable=True,
                              autoincrement=False, server_default='1'),

                       Column(u'nombre_modo', VARCHAR(length=50, convert_unicode=False,
                                                      unicode_error=None,
                                                      _warn_on_bytestring=False), primary_key=False, nullable=False),
                       Column(u'limite_intentos', INTEGER(), primary_key=False, nullable=True,
                              autoincrement=False, server_default='3'),

                       Column(u'acciones_permitidas', VARCHAR(length=100, convert_unicode=False,
                                                              unicode_error=None,
                                                              _warn_on_bytestring=False), primary_key=False,
                              nullable=False),

                       Column(u'tags_permitidas', VARCHAR(length=100, convert_unicode=False,
                                                          unicode_error=None,
                                                          _warn_on_bytestring=False), primary_key=False,
                              nullable=False),

                       Column(u'horarios', VARCHAR(length=50, convert_unicode=False,
                                                   unicode_error=None,
                                                   _warn_on_bytestring=False), primary_key=False, nullable=False),
                       schema=bd
                       )



if __name__ == '__main__':
    merge_model()
