# -*- coding: utf-8 -*-

from sqlalchemy import *
from sqlalchemy.dialects.mysql.base import *

from at.orm.models import BaseModel


# INTEGER()

class CpBotModel(BaseModel):
    model_type = ''
    metadata = MetaData()
    modelmetadata = metadata
    bd = ''




    logs = Table('logs', metadata,
                 Column(u'id_log', INTEGER(), primary_key=True, nullable=False,
                        autoincrement=True),
                 Column(u'id_charla', INTEGER(), primary_key=True, nullable=False),
                 Column(u'mensaje_enviado', VARCHAR(length=400, convert_unicode=True,
                                                    unicode_error=None,
                                                    _warn_on_bytestring=False), primary_key=False,
                        nullable=True),
                 Column(u'id_nodo', INTEGER(), primary_key=False, nullable=False, autoincrement=False),
                 Column(u'datos', VARCHAR(length=500, convert_unicode=True,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=False, nullable=True),
                 Column(u'estado', VARCHAR(length=100, convert_unicode=True,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=False, nullable=True),
                 Column(u'opcion', VARCHAR(length=350, convert_unicode=True,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=False, nullable=False),
                 Column(u'espera', VARCHAR(length=350, convert_unicode=True,
                                            unicode_error=None,
                                            _warn_on_bytestring=False), primary_key=False, nullable=False),
                 Column(u'fecha_hora', TIMESTAMP(timezone=False), primary_key=False,
                        nullable=True),
                 Column(u'fecha_hora_respuesta', TIMESTAMP(timezone=False),
                        primary_key=False,
                        nullable=True),
                 Column(u'seleccionado', INTEGER(),
                        primary_key=False,
                        nullable=True),
                 schema=bd
                 ),



    tags = Table('tags', metadata,
                 Column(u'id_tag', VARCHAR(length=150, convert_unicode=True,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=True, nullable=False),
                 Column(u'tag', VARCHAR(length=250, convert_unicode=True,
                                        unicode_error=None,
                                        _warn_on_bytestring=False), primary_key=False, nullable=False),
                 Column(u'texto', VARCHAR(length=250, convert_unicode=True,
                                          unicode_error=None,
                                          _warn_on_bytestring=False), primary_key=False, nullable=False),
                Column(u'tipo', VARCHAR(length=50, convert_unicode=True,
                                          unicode_error=None,
                                          _warn_on_bytestring=False), primary_key=False, nullable=False)),



    parametros = Table('parametros', metadata,
                       Column(u'telefono', VARCHAR(length=50, convert_unicode=True,
                                                   unicode_error=None,
                                                   _warn_on_bytestring=False), primary_key=True, nullable=False,
                                                    index=True),
                       Column(u'id_empresa', VARCHAR(length=50, convert_unicode=True,
                                                   unicode_error=None,
                                                   _warn_on_bytestring=False), primary_key=False, nullable=True,
                              index=True),
                       Column(u'automatico', INTEGER(), primary_key=False, nullable=True,
                              autoincrement=False, server_default='0'),
                       Column(u'id_modo', VARCHAR(length=50, convert_unicode=True,
                                    unicode_error=None,
                                    _warn_on_bytestring=False), primary_key=False, nullable=False),
                       Column(u'limite_intentos', INTEGER(), primary_key=False, nullable=True,
                              autoincrement=False, server_default='3'),
                       Column(u'horarios', VARCHAR(length=50, convert_unicode=True,
                                                   unicode_error=None,
                                                   _warn_on_bytestring=False), primary_key=False, nullable=False),
                       Column(u'ip_atmsj', VARCHAR(length=50, convert_unicode=True,
                                                   unicode_error=None,
                                                   _warn_on_bytestring=False), primary_key=False, nullable=False),
                       Column(u'ip_callprocessor', VARCHAR(length=50, convert_unicode=True,
                                                           unicode_error=None,
                                                           _warn_on_bytestring=False), primary_key=False, nullable=False),
                       Column(u'ip_atapis', VARCHAR(length=50, convert_unicode=True,
                                                           unicode_error=None,
                                                           _warn_on_bytestring=False), primary_key=False, nullable=False),
                       Column(u'id_ciudad', VARCHAR(length=50, convert_unicode=True,
                                                           unicode_error=None,
                                                           _warn_on_bytestring=False), primary_key=False, nullable=False),
                       Column(u'finalizar_en_arribo', INTEGER(), primary_key=False, nullable=False,
                              autoincrement=False, server_default='1'),
                       Column(u'coordenadas', VARCHAR(length=200, convert_unicode=True,
                                                           unicode_error=None,
                                                           _warn_on_bytestring=False), primary_key=False,
                              nullable=False),
                       Column(u'ignorar_errores', INTEGER(), primary_key=False, nullable=False,
                              autoincrement=False, server_default='0'),
                       schema=bd),




    modos = Table('modos', metadata,
                  Column(u'id_modo', VARCHAR(length=100, convert_unicode=True,
                            unicode_error=None,
                            _warn_on_bytestring=False), primary_key=True, nullable=False),
                    Column(u'habilitado', INTEGER(), primary_key=False, nullable=False, autoincrement=False, index=True,
                           server_default='1'),
                  Column(u'volver_modo_anterior', INTEGER(), primary_key=False, nullable=False, autoincrement=False,
                         server_default='0'),
                    schema=bd),




    funciones = Table('funciones', metadata,
                        Column(u'id_funcion', INTEGER(), primary_key=True, nullable=False, autoincrement=False),
                        Column(u'nombre', VARCHAR(length=100, convert_unicode=True,
                            unicode_error=None,
                            _warn_on_bytestring=False), primary_key=True, nullable=False),
                        Column(u'titulo', VARCHAR(length=500, convert_unicode=True,
                            unicode_error=None,
                            _warn_on_bytestring=False), primary_key=False, nullable=True),
                        Column(u'predeterminado', VARCHAR(length=500, convert_unicode=True,
                            unicode_error=None,
                            _warn_on_bytestring=False), primary_key=False, nullable=True),
                        schema=bd),




    nodos = Table(u'nodos', metadata,
                    Column(u'id_nodo', INTEGER(), primary_key=True, nullable=False, autoincrement=True),
                    Column(u'id_funcion', INTEGER(), primary_key=False, nullable=False, autoincrement=False),
                    Column(u'id_modo', VARCHAR(length=150, convert_unicode=True,
                                             unicode_error=None,
                                             _warn_on_bytestring=False), primary_key=False, nullable=True),
                    Column(u'padre', VARCHAR(length=50, convert_unicode=True,
                                             unicode_error=None,
                                             _warn_on_bytestring=False), primary_key=False, nullable=True),
                    Column(u'permitido', VARCHAR(length=100, convert_unicode=True,
                                           unicode_error=None,
                                           _warn_on_bytestring=False), primary_key=False, nullable=True),
                    Column(u'orden', INTEGER(), primary_key=False, nullable=False, autoincrement=False),
                    schema=bd),




    charla = Table(u'charla', metadata,
                    Column(u'id_charla', INTEGER(), primary_key=True, nullable=False, autoincrement=True),
                    Column(u'automatico',INTEGER(),server_default='1'),
                    Column(u'telefono_origen', VARCHAR(length=50, convert_unicode=True,
                                    unicode_error=None,
                                    _warn_on_bytestring=False), primary_key=False, nullable=False),
                    Column(u'estado', VARCHAR(length=50, convert_unicode=True,
                                    unicode_error=None,
                                    _warn_on_bytestring=False), primary_key=False, nullable=False, index=True),
                    Column(u'datos_servicio', VARCHAR(length=500, convert_unicode=True,
                                    unicode_error=None,
                                    _warn_on_bytestring=False), primary_key=False, nullable=True, index=True),
                    Column(u'telefono_destino', VARCHAR(length=50, convert_unicode=True,
                                    unicode_error=None,
                                    _warn_on_bytestring=False), nullable=False, index=True),
                    Column(u'usuario_responsable', VARCHAR(length=50, convert_unicode=True,
                                    unicode_error=None,
                                    _warn_on_bytestring=False), primary_key=False, nullable=False),
                    Column(u'intentos_fallidos', INTEGER(), server_default='0'),
                    Column(u'id_modo', VARCHAR(length=50, convert_unicode=True,
                                    unicode_error=None,
                                    _warn_on_bytestring=False), primary_key=False, index=True, nullable=False),
                    Column(u'id_ultimo_nodo', INTEGER(), nullable=False, index=True),
                   Column(u'fecha_hora_ultimo_mensaje', TIMESTAMP(timezone=False), primary_key=False,
                          nullable=True),
                   schema=bd)




if __name__ == '__main__':
    merge_model()
